if not FUNC_LUA then dofile("func.lua") end

BOSS_LUA = true

_boss = {
states = {	idle = 1,			--default state when player is not around
			alert = 2,			--player is within view range. Enemy checking if anything is blocking its view of player
			chase_player = 3,	--player is within view range and enemy can see player.
			chase_memory = 4,	--player is within view range but enemy cannot see player. Enemy chases player's last viewable location
			melee = 5,
			hit = 6,
			kill = 7,
			fall = 8,
			deactivate = 9
		  },
consts={	file=enemy_files.super_spiky,
			stats={ max_health=150,
					range=200,
					ai=4,
					color="black",
					fire = {delay=100, counter=0, spawn_delay=617, spawn_counter=0, spawn_enemy="lil_spiky", speed=0.9, life=80, damage=7},
					dist={300, 40},
					spin=60,
					peripheral=150,
					speed=10
				  },
			solidgeom={	type=E.geom_type_sphere,
						size={3.0},
						attr={	cat=cat_enemy,
								col=cat_sslash+cat_floor,
								res=cat_floor,
								cal=cat_sslash,
								mas=20, bou=0.1, fri=1}},
			framegeom={	type=E.geom_type_sphere,
						size={3.0},
						attr={	cat=cat_enemy_frame,
								col=cat_floor+cat_wall,
								res=cat_floor,
								cal=cat_wall,
								mas=20, bou=0.15, fri=1}},
			bosscolgeom={type=E.geom_type_sphere,
						size={3.0},
						attr={	cat=cat_player_enemy,
								col=cat_player_enemy,
								res=0,
								cal=cat_player_enemy}},
			scale=3.1,
			sight_shot_speed=2.25,
			sight_shot_delay=2,
			hit_frame_maxcount=3,
			core_scale=2,
},
c=3,
g=3,
child_pos=2,
freq=1,
boss=nil,
state=1,
shots = {},
sight_shots = {},
base_shot = create_image_sprite(enemy_shot_file, {rx=0,ry=0,rz=0}, 0.04, {x=0,y=0,z=0}, true, clone_basegroup),
fsm_mat = {
					--idle  alert  chase_player  chase_memory  melee  hit  kill  fall  deactivate
--[[idle]]			{   0,    1,        0,            0,         0,    1,    0,    0,       0    };
--[[alert]]			{   1,    0,        1,            0,         0,    1,    0,    0,       0    };
--[[chase_player]]		{   1,    0,        0,            1,         1,    1,    0,    0,       0    };
--[[chase_memory]]	{   0,    1,        1,            0,         1,    1,    0,    0,       0    };
--[[melee]]			{   0,    0,        1,            0,         0,    1,    0,    0,       0    };
--[[hit]]			{   0,    0,        1,            0,         0,    1,    1,    0,       0    };
--[[kill]]			{   0,    0,        0,            0,         0,    0,    0,    1,       0    };
--[[fall]]			{   0,    0,        0,            0,         0,    0,    0,    0,       1    };
--[[deactivate]]		{   0,    0,        0,            0,         0,    0,    0,    0,       0    }},

do_state = function (dt)
	if _boss.state~=_boss.states.fall and _boss.state~=_boss.states.deactivate then _boss.pulse(dt) end
	if	   _boss.state==_boss.states.idle 			then _boss.idle(dt)
	elseif _boss.state==_boss.states.alert 			then _boss.alert(dt)
	elseif _boss.state==_boss.states.chase_player 	then _boss.chase_player(dt)
	elseif _boss.state==_boss.states.chase_memory	then _boss.chase_memory(dt)
	elseif _boss.state==_boss.states.melee 			then _boss.idle(dt)
	elseif _boss.state==_boss.states.hit			then _boss.hit()
	elseif _boss.state==_boss.states.kill			then _boss.kill()
	elseif _boss.state==_boss.states.fall			then _boss.fall(dt)
	end
	table.foreach(_boss.shots, function(i, v) _boss.step_shot(i, v, dt) end)
	table.foreach(_boss.sight_shots, function(i, v) _boss.step_sight_shot(i, v, dt) end)
end,

change_state = function(ts)
	if _boss.fsm_mat[_boss.state][ts] == 1 then 
		if (_boss.boss.pivot.damage_taken>0 and ts==_boss.states.hit) then
			_boss.boss.pivot.hit_frame_counter = 0
			_boss.state = ts
		elseif _boss.boss.pivot.damage_taken==0 then
			_boss.state = ts
		end
	end
end,

pulse = function(dt)
	E.turn_entity(_boss.p1, 0, -180*dt, 0)
	E.turn_entity(_boss.object2, 0, 0, 180*dt)
	E.turn_entity(_boss.p2, 0, 180*dt, 0)
	E.turn_entity(_boss.object3, -180*dt, 0, 0)

	_boss.total_dt=_boss.total_dt+dt
	if _boss.total_dt>_boss.dt_next then
		_boss.dt_last=_boss.dt_next
		_boss.dt_next=_boss.dt_next+_boss.freq
		_boss.expand=not _boss.expand
	end
	local d
	if _boss.expand then d=1+(_boss.total_dt-_boss.dt_last)/_boss.g
	else d=1+(_boss.dt_next-_boss.total_dt)/_boss.g end
	for i, v in pairs(_boss.vert) do
		if v then
			E.set_vert(_boss.boss.solid.entity, i, v[1]*d, v[2]*d, v[3]*d)
			E.set_vert(_boss.boss.frame.entity, i, v[1]*d, v[2]*d, v[3]*d)
		end
	end
end,

idle = function(dt)
	_VP.refresh(_boss.boss)
	local dx=player.entity.pivot.pos[1]-_boss.boss.pivot.pos[1]
	local dz=player.entity.pivot.pos[3]-_boss.boss.pivot.pos[3]
	local dist=math.sqrt(dx^2+dz^2)
	if dist<=_boss.boss.pivot.stats.dist[1] then
		_boss.change_state(_boss.states.alert)
	else
		
	end
end,

alert = function(dt)
	_VP.refresh(_boss.boss)
	local dx=player.entity.pivot.pos[1]-_boss.boss.pivot.pos[1]
	local dz=player.entity.pivot.pos[3]-_boss.boss.pivot.pos[3]
	local dist=math.sqrt(dx^2+dz^2)
	if dist<=_boss.boss.pivot.stats.dist[1] then
		local tr, ty=get_rotation({{dz/dist,0,dx/dist},{0,1,0},{dx/dist,0,dz/dist}})
		local lr, ly=get_rotation(_boss.boss.pivot.vect)
		lr=_boss.boss.pivot.stats.spin*dt
		tr=ty-ly
		if tr>180 then
			tr=-360+tr
		elseif tr<-180 then
			tr=360+tr
		end
		if math.abs(tr)<_boss.boss.pivot.stats.peripheral then
			_boss.boss.pivot.turn=0
			if math.abs(tr)<=lr then
				_VP.set_entity_rotation(_boss.boss, 0, ty, 0)
			elseif tr>0 then
				_VP.turn_entity(_boss.boss, 0, lr, 0)
			else
				_VP.turn_entity(_boss.boss, 0, -lr, 0)
			end
		elseif _boss.boss.pivot.turn==0 then
			if tr>=0 then _boss.boss.pivot.turn=1 else _boss.boss.pivot.turn=-1 end
		end
	else
		_boss.change_state(_boss.states.idle)
	end
	if _boss.boss.pivot.turn~=0 then
		_VP.turn_entity(_boss.boss, 0, _boss.boss.pivot.turn*_boss.boss.pivot.stats.spin*dt, 0)
	end
	_boss.fire_sight_shot()
end,

chase_player=function(dt)
	_VP.refresh(_boss.boss)
	local dx=player.entity.pivot.pos[1]-_boss.boss.pivot.pos[1]
	local dz=player.entity.pivot.pos[3]-_boss.boss.pivot.pos[3]
	local dist=math.sqrt(dx^2+dz^2)
	if dist<=_boss.boss.pivot.stats.dist[1] then
		_boss.chase(dt, dx, dz, dist, true)
	else
		_boss.change_state(_boss.states.idle)
	end
	if _boss.boss.pivot.turn~=0 then
		_VP.turn_entity(_boss.boss, 0, _boss.boss.pivot.turn*_boss.boss.pivot.stats.spin*dt, 0)
	end
	_boss.fire_sight_shot()
end,

chase_memory=function(dt)
	_VP.refresh(_boss.boss)
	local dx=player.entity.pivot.pos[1]-_boss.boss.pivot.pos[1]
	local dz=player.entity.pivot.pos[3]-_boss.boss.pivot.pos[3]
	local dist=math.sqrt(dx^2+dz^2)
	if dist<=_boss.boss.pivot.stats.dist[1] then
		local tr, ty=get_rotation({{dz/dist,0,dx/dist},{0,1,0},{dx/dist,0,dz/dist}})
		local lr, ly=get_rotation(_boss.boss.pivot.vect)
		lr=_boss.boss.pivot.stats.spin*dt
		tr=ty-ly
		if tr>180 then
			tr=-360+tr
		elseif tr<-180 then
			tr=360+tr
		end
		if math.abs(tr)<_boss.boss.pivot.stats.peripheral then
			_boss.boss.pivot.turn=0
			if math.abs(tr)<=lr then	_VP.set_entity_rotation(_boss.boss, 0, ty, 0)
			elseif tr>0 then			_VP.turn_entity(_boss.boss, 0, lr, 0)
			else						_VP.turn_entity(_boss.boss, 0, -lr, 0)
			end
			_boss.fire_sight_shot()
			--_boss.change_state( _boss.states.chase_player)
			return
		end
	end
	local dx=_boss.boss.pivot.last_mem_pos[1]-_boss.boss.pivot.pos[1]
	local dz=_boss.boss.pivot.last_mem_pos[3]-_boss.boss.pivot.pos[3]
	local dist=math.sqrt(dx^2+dz^2)
	if dist > 1 then
		_boss.chase(dt, dx, dz, dist, false)
	else
		_boss.change_state(_boss.states.alert)
	end
	if _boss.boss.pivot.turn~=0 then
		_VP.turn_entity(_boss.boss, 0, _boss.boss.pivot.turn*_boss.boss.pivot.stats.spin*dt, 0)
	end
	_boss.fire_sight_shot()
end,

chase = function(dt, dx, dz, dist, dist_min)
	local tr, ty=get_rotation({{dz/dist,0,dx/dist},{0,1,0},{dx/dist,0,dz/dist}})
	local lr, ly=get_rotation(_boss.boss.pivot.vect)
	lr=_boss.boss.pivot.stats.spin*dt
	tr=ty-ly
	if tr>180 then
		tr=-360+tr
	elseif tr<-180 then
		tr=360+tr
	end
	if math.abs(tr)<_boss.boss.pivot.stats.peripheral then
		_boss.boss.pivot.turn=0
		if math.abs(tr)<=lr then
			_VP.set_entity_rotation(_boss.boss, 0, ty, 0)
		elseif tr>0 then
			_VP.turn_entity(_boss.boss, 0, lr, 0)
		else
			_VP.turn_entity(_boss.boss, 0, -lr, 0)
		end
		if (dist_min and dist>=_boss.boss.pivot.stats.dist[2]) or not dist_min then 
			_VP.set_entity_position(_boss.boss, vector_position(0, 0, _boss.boss.pivot.stats.speed*dt, _boss.boss.pivot.vect, _boss.boss.pivot.pos))
		end
		_boss.fire()
	elseif _boss.boss.pivot.turn==0 then
		if tr>=0 then _boss.boss.pivot.turn=1 else _boss.boss.pivot.turn=-1 end
	end
end,

set_last_mem_pos = function(ploc)
	_boss.boss.pivot.last_mem_pos = ploc
end,

fire_sight_shot = function()
	if _boss.boss.pivot.sight_shot_counter >= _boss.consts.sight_shot_delay then
		_boss.add_sight_shot()
		_boss.boss.pivot.sight_shot_counter = 0
	else
		_boss.boss.pivot.sight_shot_counter = _boss.boss.pivot.sight_shot_counter + 1
	end
end,

create_sight_shot = function(x, z)
	local shot = E.create_pivot()
	E.set_entity_position(shot, x, player.entity.pivot.pos[2], z)
	
	E.set_entity_geom_type(shot, E.geom_type_sphere, 1.7)
	set_geom_attr(shot, {cat=cat_sight_shot, 
						 col=cat_player + cat_wall,
						 res=0,
						 cal=cat_player + cat_wall})

	E.parent_entity(shot, enemysightshotgroup)
	return shot
end,

add_sight_shot = function()
   local shot = {}
   shot.entity = _boss.create_sight_shot(_boss.boss.pivot.pos[1], _boss.boss.pivot.pos[3])

   shot.life = _boss.boss.pivot.stats.dist[1]
   shot.dz 	 = _boss.consts.sight_shot_speed*60
   shot.pos  = {_boss.boss.pivot.pos[1], player.entity.pivot.pos[2], _boss.boss.pivot.pos[3]}
   shot.id	 = id

   table.insert(_boss.sight_shots, shot)
end,

step_sight_shot = function(id, shot, dt)
	if shot.life > 0 then
		local dx=player.entity.pivot.pos[1]-shot.pos[1]
		local dz=player.entity.pivot.pos[3]-shot.pos[3]
		local dh=math.sqrt(dx^2+dz^2)
		
		if dh < 1 then
			shot.pos[1], shot.pos[2], shot.pos[3] = player.entity.pivot.pos[1], player.entity.pivot.pos[2], player.entity.pivot.pos[3]
		else
			shot.pos[1], shot.pos[2], shot.pos[3]=vector_position(0, 0, shot.dz*dt, {{0,0,0},{0,0,0},{(dx/dh),0,(dz/dh)}}, shot.pos)
		end
		E.set_entity_position(shot.entity, shot.pos[1], shot.pos[2], shot.pos[3])
		shot.life = shot.life - 1
	else
		_boss.del_sight_shot(id, shot)
	end
end,

del_sight_shot = function(id, shot)
   E.delete_entity(shot.entity)
   table.remove(_boss.sight_shots, id)
end,

make = function (pos)
	_boss.boss=_VP.create_virtual_pivot(enemygroup)
	_VP.set_entity_position(_boss.boss, pos[1], pos[2], pos[3])
	local data = _boss.consts
	local mesh_num = 0

	_boss.boss.solid = _VP.create_object(_boss.boss, data.file, {0,0,0}, data.solidgeom, nil, true)
	E.set_entity_scale(_boss.boss.solid.entity, data.scale, data.scale, data.scale)
	
	_boss.boss.frame = _VP.create_object(_boss.boss, data.file, {0,0,0}, data.framegeom, nil, true)
	E.set_entity_scale(_boss.boss.frame.entity, data.scale+0.01, data.scale+0.01, data.scale+0.01)
	E.set_entity_flags(_boss.boss.frame.entity, E.entity_flag_wireframe, true)
	
	_boss.boss.boss_col = _VP.create_pivot(_boss.boss, {0,0,0}, data.bosscolgeom)

	_boss.boss.pivot.stats=data.stats
	_boss.boss.pivot.health=data.stats.max_health
	_boss.boss.pivot.last_mem_pos = {0, 0, 0}
	_boss.boss.pivot.sight_shot_counter=0
	_boss.boss.pivot.hit_frame_counter=0
	_boss.boss.pivot.damage_taken=0
	local r, g, b, a = _boss.get_health_color()
	_boss.boss.pivot.brush={ frame=_boss.create_brush(_boss.boss.frame.entity, false, r, g, b, a, mesh_num)}
	_boss.boss.pivot.x_pos=pos[1]
	_boss.boss.pivot.y_pos=pos[2]
	if math.random()>=0.5 then _boss.boss.pivot.turn=1 else _boss.boss.pivot.turn=-1 end
	
	_boss.spawn_sound = E.load_sound(sound_files.boss_spawn)
	E.set_sound_emitter(_boss.spawn_sound, _boss.boss.frame.entity)
	E.set_sound_receiver(camera, 50)
	
	--make rotating lil spikies

	_boss.p1=E.create_pivot()
	_boss.p2=E.create_pivot()
	_boss.object2=E.create_object(enemy_files.lil_spiky)
	_boss.object3=E.create_clone(_boss.object2)
	E.parent_entity(_boss.p1, _boss.boss.solid.entity)
	E.parent_entity(_boss.p2, _boss.boss.solid.entity)
	E.parent_entity(_boss.object2, _boss.p1)
	E.parent_entity(_boss.object3, _boss.p2)
	E.set_entity_rotation(_boss.p1, 0, 0, 30)
	E.set_entity_rotation(_boss.p2, 0, 0, -30)
	E.set_entity_scale(_boss.object2, .2, .2, .2)
	E.set_entity_scale(_boss.object3, .2, .2, .2)
	E.set_entity_position(_boss.object2, 0, 0, _boss.child_pos)
	E.set_entity_position(_boss.object3, _boss.child_pos, 0, 0)

	_boss.vcount=E.get_vert_count(_boss.boss.solid.entity)
	_boss.vert={}
	for i=1, _boss.vcount do --use pairs(vert)
		_boss.vert[i]={}
		_boss.vert[i][1], _boss.vert[i][2], _boss.vert[i][3]=E.get_vert(_boss.boss.solid.entity, i)
		if _boss.vert[i][1]^2+_boss.vert[i][2]^2+_boss.vert[i][3]^2<_boss.consts.core_scale then
			_boss.vert[i]=nil
		end
	end
	_boss.total_dt=0
	_boss.dt_last=0
	_boss.dt_next=1
	_boss.expand=true
end,

create_brush = function (boss, unlit, r, g, b, a, mesh_num)
	mesh_num = mesh_num or 0
	local boss_brush = E.create_brush()
	E.set_mesh(boss, mesh_num, boss_brush)
	E.set_brush_flags(boss_brush, E.brush_flag_unlit, unlit)
	E.set_brush_color(boss_brush, r, g, b, a)
	return boss_brush
end,

hit = function ()
	if _boss.boss.pivot.hit_frame_counter == 0 then
		if not _boss.boss.pivot.hit_sound then 
			_boss.boss.pivot.hit_sound = E.load_sound(sound_files.boss_hit)
			E.set_sound_emitter(_boss.boss.pivot.hit_sound, _boss.boss.solid.entity)
			E.set_sound_receiver(camera, 50)
		end
		E.play_sound(_boss.boss.pivot.hit_sound)

		_boss.boss.pivot.health = _boss.boss.pivot.health - _boss.boss.pivot.damage_taken
		player.update_stat("damage_dealt", _boss.boss.pivot.damage_taken)

		if _boss.boss.pivot.health <= 0 then
			_boss.boss.pivot.damage_taken = 0
			E.set_brush_color(_boss.boss.pivot.brush.frame, 1.0, 0.0, 0.0, 1.0)
			E.parent_entity(_boss.boss.solid.entity, enemydeadgroup)
			_boss.change_state(_boss.states.kill)
		else
			E.set_brush_color(_boss.boss.pivot.brush.frame, 1.0, 1.0, 1.0, 1.0)
		end
		
		_boss.boss.pivot.hit_frame_counter = 1
	elseif _boss.boss.pivot.hit_frame_counter < _boss.consts.hit_frame_maxcount then
		_boss.boss.pivot.hit_frame_counter = _boss.boss.pivot.hit_frame_counter + 1
	else
		E.set_brush_color(_boss.boss.pivot.brush.frame, _boss.get_health_color())
		_boss.boss.pivot.hit_frame_counter = 0
		_boss.boss.pivot.damage_taken = 0
		_boss.change_state(_boss.states.chase_player)
	end
end,

kill = function()
	if E.get_entity_alpha(_boss.boss.solid.entity) == 100 then
		_boss.boss.pivot.kill_sound = E.load_sound(sound_files.boss_killed)
		E.set_sound_emitter(_boss.boss.pivot.kill_sound, _boss.boss.solid.entity)
		E.set_sound_receiver(camera, 50)
		E.play_sound(_boss.boss.pivot.kill_sound)
		E.set_entity_alpha(_boss.boss.solid.entity, E.get_entity_alpha(_boss.boss.solid.entity)-0.01)
	elseif E.get_entity_alpha(_boss.boss.solid.entity) > 0 then
		E.set_entity_alpha(_boss.boss.solid.entity, E.get_entity_alpha(_boss.boss.solid.entity)-0.01)
	else
		if _boss.boss.pivot.kill_sound then E.stop_sound(_boss.boss.pivot.kill_sound) E.free_sound(_boss.boss.pivot.kill_sound) end
		if _boss.boss.pivot.hit_sound then E.stop_sound(_boss.boss.pivot.hit_sound) E.free_sound(_boss.boss.pivot.hit_sound) end

		player.update_stat("enemies_killed", 1)
		
		local sx, sy, sz = E.get_entity_scale(_boss.boss.frame.entity)
		E.set_entity_scale(_boss.boss.frame.entity, sx, sy/8, sz)

		local minx, miny, minz, maxx, maxy, maxz = E.get_entity_bound(_boss.boss.frame.entity)
		E.set_entity_geom_type(_boss.boss.frame.entity, E.geom_type_box, maxx-minx, (maxy-miny)/8, maxz-minz)
		set_geom_attr(_boss.boss.frame.entity, {cat=0,col=0,cal=0,res=0})
		
		_boss.boss.fall_time = 0
		E.delete_entity(_boss.boss.solid.entity)
		_boss.change_state(_boss.states.fall)
	end
end,

fall = function(dt)
	_boss.boss.fall_time = _boss.boss.fall_time + dt
	local x, y, z = E.get_entity_position(_boss.boss.frame.entity)
	if y > 0.85 then
		E.set_entity_position(_boss.boss.frame.entity, x, y-(_boss.boss.fall_time*0.16), z)
	else
		E.set_entity_position(_boss.boss.frame.entity, x, 0.85, z)
		_boss.change_state(_boss.states.deactivate)
		final_obj_revealed = true
		E.play_sound(sound_final_obj_appear)
		E.set_entity_flags(final_obj, E.entity_flag_hidden, false)
	end
end,

fire = function()
	if _boss.boss.pivot.stats.fire.counter < _boss.boss.pivot.stats.fire.delay then
		_boss.boss.pivot.stats.fire.counter = _boss.boss.pivot.stats.fire.counter + 1
	else
		_boss.add_shot()
		_boss.boss.pivot.stats.fire.counter = 0
	end

	if _boss.boss.pivot.stats.fire.spawn_counter < _boss.boss.pivot.stats.fire.spawn_delay then
		_boss.boss.pivot.stats.fire.spawn_counter = _boss.boss.pivot.stats.fire.spawn_counter + 1
	else
		E.play_sound(_boss.spawn_sound)
		_enemy.add(_boss.boss.pivot.stats.fire.spawn_enemy, {_boss.boss.pivot.pos[1], 4, _boss.boss.pivot.pos[3]})
		_boss.boss.pivot.stats.fire.spawn_counter = 0
	end
end,

create_shot = function(x, y, z, color)
	local shot_scale = 0.04
	local shot = E.create_clone(_enemy.base_shot)
	E.set_entity_position(shot, x, y, z)
	E.set_entity_scale(shot, shot_scale, shot_scale, shot_scale)
	E.set_entity_flags(shot, E.entity_flag_billboard, true)
		
	local minx, miny, minz, maxx, maxy, maxz = E.get_entity_bound(shot)
	E.set_entity_geom_type(shot, E.geom_type_box, (maxx-minx)*shot_scale, (maxy-miny)*shot_scale, (maxz-minz)*shot_scale)
	set_geom_attr(shot, {cat=cat_bullet, 
						col=cat_player + cat_weapon + cat_wall,
						res=0, 
						cal=cat_player + cat_weapon + cat_wall})
	E.parent_entity(shot, enemyfire)
	return shot
end,

add_shot = function()
	local shot = {}
	shot.entity = _boss.create_shot(_boss.boss.pivot.pos[1], player.entity.pivot.pos[2]+0.5, _boss.boss.pivot.pos[3], _boss.boss.pivot.stats.color)

	shot.life = _boss.boss.pivot.stats.fire.life
	shot.damage = _boss.boss.pivot.stats.fire.damage
	shot.dz=_boss.boss.pivot.stats.fire.speed*60
	shot.pos={_boss.boss.pivot.pos[1], _boss.boss.pivot.pos[2]-0.7, _boss.boss.pivot.pos[3]}
	shot.vect=_boss.boss.pivot.vect

	shot.sound = E.load_sound(sound_files.boss_shoot)
	E.set_sound_emitter(shot.sound, shot.entity)
	E.set_sound_receiver(camera, 50)
	E.play_sound(shot.sound)

	table.insert(_boss.shots, shot)
end,

step_shot = function(id, shot, dt)
   if shot.life > 0 then
      shot.pos[1], shot.pos[2], shot.pos[3]=vector_position(0, 0, shot.dz*dt, shot.vect, shot.pos)
      E.set_entity_position(shot.entity, shot.pos[1], shot.pos[2], shot.pos[3])
      shot.life = shot.life - 1
   else
      _boss.del_shot(id, shot)
   end
end,

del_shot = function(id, shot)
	E.stop_sound(shot.sound)
	E.free_sound(shot.sound)
	E.delete_entity(shot.entity)
	table.remove(_boss.shots, id)
end,

get_health_color = function ()
	local alpha = 1.0
	local lower = _boss.boss.pivot.health/_boss.boss.pivot.stats.max_health
	local raise = (_boss.boss.pivot.stats.max_health-_boss.boss.pivot.health)/_boss.boss.pivot.stats.max_health
	if     _boss.boss.pivot.stats.color == "green"  then return  raise, lower,     0.0, alpha
	elseif _boss.boss.pivot.stats.color == "blue"   then return  raise,   0.0,   lower, alpha
	elseif _boss.boss.pivot.stats.color == "yellow" then return    1.0, lower,     0.0, alpha
	elseif _boss.boss.pivot.stats.color == "purple" then return    1.0,   0.0,   lower, alpha
	elseif _boss.boss.pivot.stats.color == "cyan"   then return  raise, lower,   lower, alpha
	elseif _boss.boss.pivot.stats.color == "orange" then return    1.0, lower/2,   0.0, alpha
	elseif _boss.boss.pivot.stats.color == "white"  then return    1.0, lower,   lower, alpha
	elseif _boss.boss.pivot.stats.color == "black"  then return  raise,   0.0,     0.0, alpha
	end
end
}