if not FUNC_LUA then dofile("func.lua") end

ENEMY_LUA = true

_enemy = {
states = {	idle = 1,			--default state when player is not around
			alert = 2,			--player is within view range. Enemy checking if anything is blocking its view of player
			chase_player = 3,	--player is within view range and enemy can see player.
			chase_memory = 4,	--player is within view range but enemy cannot see player. Enemy chases player's last viewable location
			melee = 5,
			hit = 6,
			kill = 7,
			fall = 8,
			deactivate = 9
		  },
consts={shikigami={	file=enemy_files.shikigami,
					stats={	max_health=50,
							range=100,
							ai=2,
							color="purple",
							fire = {canfire=true, can_create_spawns=false, delay=120, counter=0, speed=0.9, life=80, damage=10.8},
							dist={120, 10},
							spin=120,
							peripheral=70,
							speed=15
						  },
					solidgeom={	type=E.geom_type_sphere,
								size={0.7},
								attr={	cat=cat_enemy,
										col=cat_sslash+cat_floor,
										res=cat_floor,
										cal=cat_sslash,
										mas=20, bou=0.2, fri=1}},
					framegeom={	type=E.geom_type_sphere,
								size={2.9},
								attr={	cat=cat_enemy_frame,
										col=cat_floor+cat_wall,
										res=cat_floor,
										cal=cat_wall,
										mas=20, bou=0.40, fri=1}},
					enemycolgeom={type=E.geom_type_sphere,
								size={4},
								attr={	cat=cat_player_enemy,
										col=cat_player_enemy,
										res=0,
										cal=cat_player_enemy}},
					scale=3},
		tro = {	file=enemy_files.tro,
					stats={ max_health=100,
							range=150,
							ai=3,
							color="blue",
							fire = {canfire=true, can_create_spawns=false, delay=200, counter=0, speed=0.75, life=60, damage=9},
							dist={100, 15},
							spin=50,
							peripheral=70,
							speed=15
						  },
					solidgeom={	type=E.geom_type_sphere,
								size={1.1},
								attr={	cat=cat_enemy,
										col=cat_sslash+cat_floor,
										res=cat_floor,
										cal=cat_sslash,
										mas=20, bou=0.5, fri=1}},
					framegeom={	type=E.geom_type_sphere,
								size={2.9},
								attr={	cat=cat_enemy_frame,
										col=cat_floor+cat_wall,
										res=cat_floor,
										cal=cat_wall,
										mas=20, bou=0.80, fri=1}},
					enemycolgeom={	type=E.geom_type_sphere,
								size={4},
								attr={	cat=cat_player_enemy,
										col=cat_player_enemy,
										res=0,
										cal=cat_player_enemy}},
					scale=3},
		lil_spiky={file=enemy_files.lil_spiky,
					stats={ max_health=35,
							range=200,
							ai=4,
							color="white",
							fire = {canfire=true, can_create_spawns=false, delay=150, counter=0, speed=0.8, life=70, damage=3},
							dist={70, 10},
							spin=90,
							peripheral=100,
							speed=25
						  },
					solidgeom={	type=E.geom_type_sphere,
								size={1.85},
								attr={	cat=cat_enemy,
										col=cat_sslash+cat_floor,
										res=cat_floor,
										cal=cat_sslash,
										mas=20, bou=0.1, fri=1}},
					framegeom={	type=E.geom_type_sphere,
								size={1.85},
								attr={	cat=cat_enemy_frame,
										col=cat_floor+cat_wall,
										res=cat_floor,
										cal=cat_wall,
										mas=20, bou=0.15, fri=1}},
					enemycolgeom={	type=E.geom_type_sphere,
								size={4},
								attr={	cat=cat_player_enemy,
										col=cat_player_enemy,
										res=0,
										cal=cat_player_enemy}},
					scale=0.8},
		sight_shot_speed=2.25,
		sight_shot_delay=2,
		hit_frame_maxcount=3,
		melee_min_dist=10,
		melee_max_dist=12
},
enemies = {},
shots = {},
sight_shots = {},
base_shot = create_image_sprite(enemy_shot_staticball_file, {rx=0,ry=0,rz=0}, 1, {x=0,y=0,z=0}, true, clone_basegroup),
fsm_mat = {
					--idle  alert  chase_player  chase_memory  melee  hit  kill  fall  deactivate
--[[idle]]			{   0,    1,        0,            0,         0,    1,    0,    0,       0    };
--[[alert]]			{   1,    0,        1,            0,         0,    1,    0,    0,       0    };
--[[chase_player]]	{   1,    0,        0,            1,         1,    1,    0,    0,       0    };
--[[chase_memory]]	{   0,    1,        1,            0,         1,    1,    0,    0,       0    };
--[[melee]]			{   0,    1,        0,            0,         0,    1,    0,    0,       0    };
--[[hit]]			{   0,    0,        1,            0,         1,    1,    1,    0,       0    };
--[[kill]]			{   0,    0,        0,            0,         0,    0,    0,    1,       0    };
--[[fall]]			{   0,    0,        0,            0,         0,    0,    0,    0,       1    };
--[[deactivate]]	{   0,    0,        0,            0,         0,    0,    0,    0,       0    }},

do_states = function (dt)
	table.foreach(_enemy.enemies, function(id, value) _enemy.do_state(id, value, dt) end)
	table.foreach(_enemy.shots, function(i, v) _enemy.step_shot(i, v, dt) end)
	table.foreach(_enemy.sight_shots, function(i, v) _enemy.step_sight_shot(i, v, dt) end)
end,

do_state = function (id, value, dt)
	if	   value.pivot.state==_enemy.states.idle 			then _enemy.idle(value, dt)
	elseif value.pivot.state==_enemy.states.alert 			then _enemy.alert(id, value, dt)
	elseif value.pivot.state==_enemy.states.chase_player 	then _enemy.chase_player(id, value, dt)
	elseif value.pivot.state==_enemy.states.chase_memory	then _enemy.chase_memory(id, value, dt)
	elseif value.pivot.state==_enemy.states.melee 			then _enemy.melee(id, value, dt)
	elseif value.pivot.state==_enemy.states.hit				then _enemy.hit(id, value)
	elseif value.pivot.state==_enemy.states.kill			then _enemy.kill(value)
	elseif value.pivot.state==_enemy.states.fall			then _enemy.fall(value, dt)
	end
end,

set_initial_state = function(enemy)
	if enemy.pivot.state == nil then
		enemy.pivot.state = _enemy.states.idle
	end
end,

change_state = function(enemy, ts)
	if _enemy.fsm_mat[enemy.pivot.state][ts] == 1 then
		if ts == _enemy.states.melee then 
			table.insert(player.target, enemy.pivot.id)
		end
		if enemy.pivot.state == _enemy.states.melee then 
			for i,v in pairs(player.target) do
				if v == enemy.pivot.id then	table.remove(player.target, i) break end
			end
		end
		if (enemy.pivot.damage_taken>0 and ts==_enemy.states.hit) then
			enemy.pivot.hit_frame_counter = 0
			enemy.pivot.state = ts
		elseif enemy.pivot.damage_taken==0 then
			enemy.pivot.state = ts
		end
	end
end,

idle = function(enemy, dt)
	_VP.refresh(enemy)
	local dx=player.entity.pivot.pos[1]-enemy.pivot.pos[1]
	local dz=player.entity.pivot.pos[3]-enemy.pivot.pos[3]
	local dist=math.sqrt(dx^2+dz^2)
	if dist<=enemy.pivot.stats.dist[1] then	
		_enemy.change_state(enemy, _enemy.states.alert)
	end
end,

alert = function(id, enemy, dt)
	_VP.refresh(enemy)
	local dx=player.entity.pivot.pos[1]-enemy.pivot.pos[1]
	local dz=player.entity.pivot.pos[3]-enemy.pivot.pos[3]
	local dist=math.sqrt(dx^2+dz^2)
	if dist<=enemy.pivot.stats.dist[1] then
		local tr, ty=get_rotation({{dz/dist,0,dx/dist},{0,1,0},{dx/dist,0,dz/dist}})
		local lr, ly=get_rotation(enemy.pivot.vect)
		lr=enemy.pivot.stats.spin*dt
		tr=ty-ly
		if tr>180 then
			tr=-360+tr
		elseif tr<-180 then
			tr=360+tr
		end
		if math.abs(tr)<enemy.pivot.stats.peripheral then
			enemy.pivot.turn=0
			if math.abs(tr)<=lr then
				_VP.set_entity_rotation(enemy, 0, ty, 0)
			elseif tr>0 then
				_VP.turn_entity(enemy, 0, lr, 0)
			else
				_VP.turn_entity(enemy, 0, -lr, 0)
			end
		elseif enemy.pivot.turn==0 then
			if tr>=0 then enemy.pivot.turn=1 else enemy.pivot.turn=-1 end
		end
	else
		_enemy.change_state(enemy, _enemy.states.idle)
	end
	if enemy.pivot.turn~=0 then
		_VP.turn_entity(enemy, 0, enemy.pivot.turn*enemy.pivot.stats.spin*dt, 0)
	end
	_enemy.fire_sight_shot(id, enemy)
end,

chase_player=function(id, enemy, dt)
	_VP.refresh(enemy)
	local dx=player.entity.pivot.pos[1]-enemy.pivot.pos[1]
	local dz=player.entity.pivot.pos[3]-enemy.pivot.pos[3]
	local dist=math.sqrt(dx^2+dz^2)
	if dist<=enemy.pivot.stats.dist[1] then
		if dist<=_enemy.consts.melee_min_dist then
			enemy.pivot.id = id
			_enemy.change_state(enemy, _enemy.states.melee)
			return
		else
			_enemy.chase(id, enemy, dt, dx, dz, dist, true)
		end
	else
		_enemy.change_state(enemy, _enemy.states.idle)
	end
	if enemy.pivot.turn~=0 then
		_VP.turn_entity(enemy, 0, enemy.pivot.turn*enemy.pivot.stats.spin*dt, 0)
	end
	_enemy.fire_sight_shot(id, enemy)
end,

chase_memory=function(id, enemy, dt)
	_VP.refresh(enemy)
	local dx=player.entity.pivot.pos[1]-enemy.pivot.pos[1]
	local dz=player.entity.pivot.pos[3]-enemy.pivot.pos[3]
	local dist=math.sqrt(dx^2+dz^2)
	if dist<=enemy.pivot.stats.dist[1] then
		if dist<=_enemy.consts.melee_min_dist then
			enemy.pivot.id = id
			_enemy.change_state(enemy, _enemy.states.melee)
			return
		else
			local tr, ty=get_rotation({{dz/dist,0,dx/dist},{0,1,0},{dx/dist,0,dz/dist}})
			local lr, ly=get_rotation(enemy.pivot.vect)
			lr=enemy.pivot.stats.spin*dt
			tr=ty-ly
			if tr>180 then
				tr=-360+tr
			elseif tr<-180 then
				tr=360+tr
			end
			if math.abs(tr)<enemy.pivot.stats.peripheral then
				enemy.pivot.turn=0
				if math.abs(tr)<=lr then	_VP.set_entity_rotation(enemy, 0, ty, 0)
				elseif tr>0 then			_VP.turn_entity(enemy, 0, lr, 0)
				else						_VP.turn_entity(enemy, 0, -lr, 0)
				end
				_enemy.fire_sight_shot(id, enemy)
				--_enemy.change_state(enemy, _enemy.states.chase_player)
				return
			end
		end
	end
	local dx=enemy.pivot.last_mem_pos[1]-enemy.pivot.pos[1]
	local dz=enemy.pivot.last_mem_pos[3]-enemy.pivot.pos[3]
	local dist=math.sqrt(dx^2+dz^2)
	if dist > 1 then
		_enemy.chase(id, enemy, dt, dx, dz, dist, false)
	else
		_enemy.change_state(enemy, _enemy.states.alert)
	end
	if enemy.pivot.turn~=0 then
		_VP.turn_entity(enemy, 0, enemy.pivot.turn*enemy.pivot.stats.spin*dt, 0)
	end
	_enemy.fire_sight_shot(id, enemy)
end,

chase = function(id, enemy, dt, dx, dz, dist, dist_min)
	local tr, ty=get_rotation({{dz/dist,0,dx/dist},{0,1,0},{dx/dist,0,dz/dist}})
	local lr, ly=get_rotation(enemy.pivot.vect)
	lr=enemy.pivot.stats.spin*dt
	tr=ty-ly
	if tr>180 then
		tr=-360+tr
	elseif tr<-180 then
		tr=360+tr
	end
	if math.abs(tr)<enemy.pivot.stats.peripheral then
		enemy.pivot.turn=0
		if math.abs(tr)<=lr then
			_VP.set_entity_rotation(enemy, 0, ty, 0)
		elseif tr>0 then
			_VP.turn_entity(enemy, 0, lr, 0)
		else
			_VP.turn_entity(enemy, 0, -lr, 0)
		end
		if (dist_min and dist>=enemy.pivot.stats.dist[2]) or not dist_min then 
			_VP.set_entity_position(enemy, vector_position(0, 0, enemy.pivot.stats.speed*dt, enemy.pivot.vect, enemy.pivot.pos))
		end
		_enemy.fire(enemy)
	elseif enemy.pivot.turn==0 then
		if tr>=0 then enemy.pivot.turn=1 else enemy.pivot.turn=-1 end
	end
end,

melee = function(id, enemy, dt)
	_VP.refresh(enemy)
	local dx=player.entity.pivot.pos[1]-enemy.pivot.pos[1]
	local dz=player.entity.pivot.pos[3]-enemy.pivot.pos[3]
	local dist=math.sqrt(dx^2+dz^2)
	if dist>_enemy.consts.melee_max_dist then
		enemy.pivot.id = id
		_enemy.change_state(enemy, _enemy.states.alert)
	else
		local tr, ty=get_rotation({{0,0,0},{0,1,0},{dx/dist,0,dz/dist}})
		local lr, ly=get_rotation(enemy.pivot.vect)
		lr=enemy.pivot.stats.spin*dt
		tr=ty-ly
		if tr>180 then
			tr=tr-360
		elseif tr<-180 then
			tr=tr+360
		end
		if math.abs(tr)<=lr then
			_VP.set_entity_rotation(enemy, 0, ty, 0)
			if dist>_enemy.consts.melee_min_dist then
				_VP.set_entity_position(enemy, vector_position(0,0, enemy.pivot.stats.speed*dt, enemy.pivot.vect, enemy.pivot.pos))
			end
		elseif tr>0 then
			_VP.turn_entity(enemy, 0, lr, 0)
		else
			_VP.turn_entity(enemy, 0, -lr, 0)
		end
		_enemy.fire(enemy)
	end
end,

set_last_mem_pos = function(enemy, ploc)
	enemy.pivot.last_mem_pos = ploc
end,

fire_sight_shot = function(id, enemy)
	if enemy.pivot.sight_shot_counter >= _enemy.consts.sight_shot_delay then
		_enemy.add_sight_shot(id, enemy)
		enemy.pivot.sight_shot_counter = 0
	else
		enemy.pivot.sight_shot_counter = enemy.pivot.sight_shot_counter + 1
	end
end,

create_sight_shot = function(x, z)
	local shot = E.create_pivot()
	E.set_entity_position(shot, x, player.entity.pivot.pos[2], z)
	
	E.set_entity_geom_type(shot, E.geom_type_sphere, 1.7)
	set_geom_attr(shot, {cat=cat_sight_shot, 
						 col=cat_player + cat_wall + cat_enemy,
						 res=0,
						 cal=cat_player + cat_wall + cat_enemy})

	E.parent_entity(shot, enemysightshotgroup)
	return shot
end,

add_sight_shot = function(id, enemy)
	local shot = {}

	shot.entity = _enemy.create_sight_shot(enemy.pivot.pos[1], enemy.pivot.pos[3])

	shot.life = enemy.pivot.stats.dist[1]
	shot.dz	  = _enemy.consts.sight_shot_speed*60
	shot.pos  = {enemy.pivot.pos[1], player.entity.pivot.pos[2], enemy.pivot.pos[3]}

	shot.id	 = id

	table.insert(_enemy.sight_shots, shot)
end,

step_sight_shot = function(id, shot, dt)
	if shot.life > 0 then
		local dx=player.entity.pivot.pos[1]-shot.pos[1]
		local dz=player.entity.pivot.pos[3]-shot.pos[3]
		local dh=math.sqrt(dx^2+dz^2)
		
		if dh < 1 then
			shot.pos[1], shot.pos[2], shot.pos[3] = player.entity.pivot.pos[1], player.entity.pivot.pos[2], player.entity.pivot.pos[3]
		else
			shot.pos[1], shot.pos[2], shot.pos[3]=vector_position(0, 0, shot.dz*dt, {{0,0,0},{0,0,0},{(dx/dh),0,(dz/dh)}}, shot.pos)
		end
		E.set_entity_position(shot.entity, shot.pos[1], shot.pos[2], shot.pos[3])
		shot.life = shot.life - 1
	else
		_enemy.del_sight_shot(id, shot)
	end
end,

del_sight_shot = function(id, shot)
   E.delete_entity(shot.entity)
   table.remove(_enemy.sight_shots, id)
end,

add = function (enemy_type, pos)
	local enemy=_VP.create_virtual_pivot(enemygroup)
	_VP.set_entity_position(enemy, pos[1], pos[2], pos[3])
	local data, mesh_num
	if enemy_type == "shikigami" then
		data=_enemy.consts.shikigami
		mesh_num = 1
	elseif enemy_type == "tro" then
		data=_enemy.consts.tro
		mesh_num = 1
	elseif enemy_type == "lil_spiky" then
		data=_enemy.consts.lil_spiky
		mesh_num = 0
	end
	
	enemy.solid = _VP.create_object(enemy, data.file, {0,0,0}, data.solidgeom, nil, true)
	E.set_entity_scale(enemy.solid.entity, data.scale, data.scale, data.scale)
	
	enemy.frame = _VP.create_object(enemy, data.file, {0,0,0}, data.framegeom, nil, true)
	E.set_entity_scale(enemy.frame.entity, data.scale+0.01, data.scale+0.01, data.scale+0.01)
	E.set_entity_flags(enemy.frame.entity, E.entity_flag_wireframe, true)
	
	enemy.enemy_col = _VP.create_pivot(enemy, {0,0,0}, data.enemycolgeom)

	enemy.pivot.stats=data.stats
	enemy.pivot.health=data.stats.max_health
	enemy.pivot.last_mem_pos = {0, 0, 0}
	enemy.pivot.sight_shot_counter=0
	enemy.pivot.hit_frame_counter=0
	enemy.pivot.damage_taken=0
	local r, g, b, a = _enemy.get_health_color(enemy.pivot)
	enemy.pivot.brush={	frame=_enemy.create_brush(enemy.frame.entity, false, r, g, b, a, mesh_num)}
	_enemy.set_initial_state(enemy)
	enemy.pivot.x_pos=pos[1]
	enemy.pivot.y_pos=pos[2]
	if math.random()>=0.5 then enemy.pivot.turn=1 else enemy.pivot.turn=-1 end
	table.insert(_enemy.enemies, enemy)
	
	--E.set_entity_flags(enemy.solid.entity, E.entity_flag_visible_geom, true)
end,

create_brush = function (enemy_entity, unlit, r, g, b, a, mesh_num)
	mesh_num = mesh_num or 0
	local enemy_brush = E.create_brush()
	E.set_mesh(enemy_entity, mesh_num, enemy_brush)
	E.set_brush_flags(enemy_brush, E.brush_flag_unlit, unlit)
	E.set_brush_color(enemy_brush, r, g, b, a)
	return enemy_brush
end,

hit = function (id, enemy)
	if enemy.pivot.hit_frame_counter == 0 then
		if not enemy.pivot.hit_sound then 
			enemy.pivot.hit_sound = E.load_sound(sound_files.enemy_hit)
			E.set_sound_emitter(enemy.pivot.hit_sound, enemy.solid.entity)
			E.set_sound_receiver(camera, 50)
		end
		E.play_sound(enemy.pivot.hit_sound)
		
		enemy.pivot.health = enemy.pivot.health - enemy.pivot.damage_taken
		player.update_stat("damage_dealt", enemy.pivot.damage_taken)

		if enemy.pivot.health <= 0 then
			enemy.pivot.damage_taken = 0
			E.set_brush_color(enemy.pivot.brush.frame, 1.0, 0.0, 0.0, 1.0)
			E.parent_entity(enemy.solid.entity, enemydeadgroup)
			_enemy.change_state(enemy, _enemy.states.kill)
		else
			E.set_brush_color(enemy.pivot.brush.frame, 1.0, 1.0, 1.0, 1.0)
		end
		
		enemy.pivot.hit_frame_counter = 1
	elseif enemy.pivot.hit_frame_counter < _enemy.consts.hit_frame_maxcount then
		enemy.pivot.hit_frame_counter = enemy.pivot.hit_frame_counter + 1
	else
		E.set_brush_color(enemy.pivot.brush.frame, _enemy.get_health_color(enemy.pivot))
		enemy.pivot.hit_frame_counter = 0
		enemy.pivot.damage_taken = 0
		
		local dx=player.entity.pivot.pos[1]-enemy.pivot.pos[1]
		local dz=player.entity.pivot.pos[3]-enemy.pivot.pos[3]
		local dist=math.sqrt(dx^2+dz^2)
		if dist<=_enemy.consts.melee_min_dist then
			enemy.pivot.id = id
			_enemy.change_state(enemy, _enemy.states.melee)
		else
			_enemy.change_state(enemy, _enemy.states.chase_player)
		end
	end
end,

kill = function(enemy)
	if E.get_entity_alpha(enemy.solid.entity) == 100 then
		if player.target[1] then
			for i,v in pairs(player.target) do
				if v == enemy.pivot.id then	table.remove(player.target, i) break end
			end
		end
		enemy.pivot.kill_sound = E.load_sound(sound_files.enemy_killed)
		E.set_sound_emitter(enemy.pivot.kill_sound, enemy.solid.entity)
		E.set_sound_receiver(camera, 50)
		E.play_sound(enemy.pivot.kill_sound)
		E.set_entity_alpha(enemy.solid.entity, E.get_entity_alpha(enemy.solid.entity)-0.01)
	elseif E.get_entity_alpha(enemy.solid.entity) > 0 then
		E.set_entity_alpha(enemy.solid.entity, E.get_entity_alpha(enemy.solid.entity)-0.01)
	else
		if enemy.pivot.kill_sound then E.stop_sound(enemy.pivot.kill_sound) E.free_sound(enemy.pivot.kill_sound) end
		if enemy.pivot.hit_sound then E.stop_sound(enemy.pivot.hit_sound) E.free_sound(enemy.pivot.hit_sound) end
		
		E.delete_entity(enemy.solid.entity)
		player.update_stat("enemies_killed", 1)
		
		local sx, sy, sz = E.get_entity_scale(enemy.frame.entity)
		E.set_entity_scale(enemy.frame.entity, sx, sy/8, sz)

		local minx, miny, minz, maxx, maxy, maxz = E.get_entity_bound(enemy.frame.entity)
		E.set_entity_geom_type(enemy.frame.entity, E.geom_type_box, maxx-minx, (maxy-miny)/8, maxz-minz)
		set_geom_attr(enemy.frame.entity, {cat=0,col=0,cal=0,res=0})
		
		enemy.fall_time = 0
		_enemy.change_state(enemy, _enemy.states.fall)
	end
end,

fall = function(enemy, dt)
	enemy.fall_time = enemy.fall_time + dt
	local x, y, z = E.get_entity_position(enemy.frame.entity)
	if y > 0.85 then
		E.set_entity_position(enemy.frame.entity, x, y-(enemy.fall_time*0.16), z)
	else
		E.set_entity_position(enemy.frame.entity, x, 0.85, z)
		_enemy.change_state(enemy, _enemy.states.deactivate)
	end
end,

fire = function(enemy)
	if not enemy.pivot.stats.fire.canfire then return end

	if enemy.pivot.stats.fire.counter < enemy.pivot.stats.fire.delay then
		enemy.pivot.stats.fire.counter = enemy.pivot.stats.fire.counter + 1
	else
		_enemy.add_shot(enemy)
		enemy.pivot.stats.fire.counter = 0
	end

	if enemy.pivot.stats.fire.can_create_spawns then
		if enemy.pivot.stats.fire.spawn_counter < enemy.pivot.stats.fire.spawn_delay then
			enemy.pivot.stats.fire.spawn_counter = enemy.pivot.stats.fire.spawn_counter + 1
		else
			_enemy.add(enemy.pivot.stats.fire.spawn_enemy, {enemy.pivot.pos[1], 4, enemy.pivot.pos[3]})
			enemy.pivot.stats.fire.spawn_counter = 0
		end
	end
end,

create_shot = function(x, y, z, color)
	local shot_scale = 0.04
	local shot = E.create_clone(_enemy.base_shot)
	E.set_entity_position(shot, x, y, z)
	E.set_entity_scale(shot, shot_scale, shot_scale, shot_scale)
	E.set_entity_flags(shot, E.entity_flag_billboard, true)

	local minx, miny, minz, maxx, maxy, maxz = E.get_entity_bound(shot)
	E.set_entity_geom_type(shot, E.geom_type_box, (maxx-minx)*shot_scale, (maxy-miny)*shot_scale, (maxz-minz)*shot_scale)
	set_geom_attr(shot, {cat=cat_bullet, 
						col=cat_player + cat_weapon + cat_wall,
						res=0, 
						cal=cat_player + cat_weapon + cat_wall})
						
	E.parent_entity(shot, enemyfire)
	return shot
end,

add_shot = function(enemy)
	local shot = {}
	shot.entity = _enemy.create_shot(enemy.pivot.pos[1], player.entity.pivot.pos[2]+0.5, enemy.pivot.pos[3], enemy.pivot.stats.color)

	shot.life = enemy.pivot.stats.fire.life
	shot.damage = enemy.pivot.stats.fire.damage
	shot.dz=enemy.pivot.stats.fire.speed*60
	shot.pos={enemy.pivot.pos[1], player.entity.pivot.pos[2]+0.5, enemy.pivot.pos[3]}
	shot.vect={{0,0,0},{0,1,0},{enemy.pivot.vect[3][1],0,enemy.pivot.vect[3][3]}}

	shot.sound = E.load_sound(sound_files.enemy_shoot)
	E.set_sound_emitter(shot.sound, shot.entity)
	E.set_sound_receiver(camera, 50)
	E.play_sound(shot.sound)

	table.insert(_enemy.shots, shot)
end,

step_shot = function(id, shot, dt)
   if shot.life > 0 then
      shot.pos[1], shot.pos[2], shot.pos[3]=vector_position(0, 0, shot.dz*dt, shot.vect, shot.pos)
      E.set_entity_position(shot.entity, shot.pos[1], shot.pos[2], shot.pos[3])
      shot.life = shot.life - 1
   else
      _enemy.del_shot(id, shot)
   end
end,

del_shot = function(id, shot)
	E.stop_sound(shot.sound)
	E.free_sound(shot.sound)
	E.delete_entity(shot.entity)
	table.remove(_enemy.shots, id)
end,

get_health_color = function (enemy)
   local alpha = 1.0
   local lower = enemy.health/enemy.stats.max_health
   local raise = (enemy.stats.max_health-enemy.health)/enemy.stats.max_health
   if     enemy.stats.color == "green"  then return  raise, lower,     0.0, alpha
   elseif enemy.stats.color == "blue"   then return  raise,   0.0,   lower, alpha
   elseif enemy.stats.color == "yellow" then return    1.0, lower,     0.0, alpha
   elseif enemy.stats.color == "purple" then return    1.0,   0.0,   lower, alpha
   elseif enemy.stats.color == "cyan"   then return  raise, lower,   lower, alpha
   elseif enemy.stats.color == "orange" then return    1.0, lower/2,   0.0, alpha
   elseif enemy.stats.color == "white"  then return    1.0, lower,   lower, alpha
   elseif enemy.stats.color == "black"  then return  raise,   0.0,     0.0, alpha
   end
end
}