FUNC_LUA = true

_VP={
create_virtual_pivot=function(parent)
	local vp={	pivot={	entity=E.create_pivot(),
						pos={0,0,0},
						vect={{1,0,0}, {0,1,0}, {0,0,1}}},
				parent=parent}
	E.parent_entity(vp.pivot.entity, vp.parent)

	return vp
end,

create_object=function(vp, file, pos, geom, rot, body)
	local p=pos or {0,0,0}
	local r=rot or {0,0,0}
	local object={	entity=E.create_object(file),
					pos=p,
					rot=r,
					parent=vp}
	E.parent_entity(object.entity, vp.parent)
	--E.set_entity_rotation(object.entity, get_rotation(vp.pivot.vect))
	E.turn_entity(object.entity, r[1], r[2], r[3])
	E.set_entity_position(object.entity, vector_position(p[1], p[2], p[3], vp.pivot.vect, vp.pivot.pos))
	if body then
		E.set_entity_body_type(object.entity, true)
		E.set_entity_body_attr(object.entity, E.body_attr_gravity, false)
	end
	if geom then
		E.set_entity_geom_type(object.entity, geom.type, geom.size[1], geom.size[2], geom.size[3])
		set_geom_attr(object.entity, geom.attr)
	end

	return object
end,

create_pivot=function(vp, pos, geom, rot)
	local p=pos or {0,0,0}
	local r=rot or {0,0,0}
	local object={	entity=E.create_pivot(),
					pos=p,
					rot=r,
					parent=vp}
	E.parent_entity(object.entity, vp.parent)
	E.set_entity_rotation(object.entity, get_rotation(vp.pivot.vect))
	E.turn_entity(object.entity, r[1], r[2], r[3])
	E.set_entity_position(object.entity, vector_position(p[1], p[2], p[3], vp.pivot.vect, vp.pivot.pos))
	if geom then
		E.set_entity_geom_type(object.entity, geom.type, geom.size[1], geom.size[2], geom.size[3])
		set_geom_attr(object.entity, geom.attr)
	end

	return object
end,

attach_entity=function(vp, object, pos, rot)
	local p=pos or {0,0,0}
	local r=rot or {0,0,0}
	E.set_entity_rotation(object, get_rotation(vp.pivot.vect))
	E.turn_entity(object, r[1], r[2], r[3])
	E.set_entity_position(object, vector_position(p[1], p[2], p[3], vp.pivot.vect, vp.pivot.pos))
	
	return {entity=object, pos=p, rot=r, parent=vp}
end,

set_entity_position=function(vp, x, y, z)
	vp.pivot.pos={x, y, z}
	E.set_entity_position(vp.pivot.entity, x, y, z)
	local id, child
	for id, child in pairs(vp) do
		if id~="pivot" and id~="parent" then
			E.set_entity_position(child.entity, vector_position(child.pos[1], child.pos[2], child.pos[3], vp.pivot.vect, vp.pivot.pos))
		end
	end
end,

set_entity_rotation=function(vp, x, y, z)
	E.set_entity_rotation(vp.pivot.entity, x, y, z)
	local xv, yv, zv=E.get_entity_x_vector(vp.pivot.entity)
	vp.pivot.vect[1]={xv,yv,zv}
	xv, yv, zv=E.get_entity_y_vector(vp.pivot.entity)
	vp.pivot.vect[2]={xv,yv,zv}
	xv, yv, zv=E.get_entity_z_vector(vp.pivot.entity)
	vp.pivot.vect[3]={xv,yv,zv}
	local id, child
	for id, child in pairs(vp) do
		if id~="pivot" and id~="parent" then
			E.set_entity_rotation(child.entity, x, y, z)
			E.turn_entity(child.entity, child.rot[1], child.rot[2], child.rot[3])
			E.set_entity_position(child.entity,
				vector_position(child.pos[1], child.pos[2], child.pos[3], vp.pivot.vect, vp.pivot.pos))
		end
	end
end,

turn_entity=function(vp, x, y, z)
	E.turn_entity(vp.pivot.entity, x, y, z)
	local xv, yv, zv=E.get_entity_x_vector(vp.pivot.entity)
	vp.pivot.vect[1]={xv,yv,zv}
	xv, yv, zv=E.get_entity_y_vector(vp.pivot.entity)
	vp.pivot.vect[2]={xv,yv,zv}
	xv, yv, zv=E.get_entity_z_vector(vp.pivot.entity)
	vp.pivot.vect[3]={xv,yv,zv}
	local id, child
	for id, child in pairs(vp) do
		if id~="pivot" and id~="parent" then
			if child.rot[1]==0 and child.rot[2]==0 and child.rot[3]==0 then
				E.turn_entity(child.entity, x, y, z)
			else
				E.set_entity_rotation(child.entity, get_rotation(vp.pivot.vect))
				E.turn_entity(child.entity, child.rot[1], child.rot[2], child.rot[3])
			end
			E.set_entity_position(child.entity,
				vector_position(child.pos[1], child.pos[2], child.pos[3], vp.pivot.vect, vp.pivot.pos))
		end
	end
end,

refresh=function(vp)
	E.set_entity_position(vp.pivot.entity, vp.pivot.pos[1], vp.pivot.pos[2], vp.pivot.pos[3])
	_VP.set_entity_rotation(vp, get_rotation(vp.pivot.vect))
end
}

function vector_position(dx, dy, dz, v_space, origin)
	local start=origin or {0,0,0}

	return	start[1]+(dx*v_space[1][1])+(dy*v_space[2][1])+(dz*v_space[3][1]),
			start[2]+(dx*v_space[1][2])+(dy*v_space[2][2])+(dz*v_space[3][2]),
			start[3]+(dx*v_space[1][3])+(dy*v_space[2][3])+(dz*v_space[3][3])
end

function get_rotation(v_space)
	if v_space[1][1]==1 then
		if v_space[2][2]==1 then
			return 0, 0, 0
		else
			local rot=math.deg(math.acos(v_space[3][3]))
			if v_space[3][2]>0 then rot=-rot end
			return rot, 0, 0
		end
	elseif v_space[2][2]==1 then
		local rot=math.deg(math.acos(v_space[3][3]))
		if v_space[3][1]<0 then rot=-rot end
		return 0, rot, 0
	elseif v_space[3][3]==1 then
		local rot=math.deg(math.acos(v_space[2][2]))
		if v_space[2][1]>0 then rot=-rot end
		return 0, 0, rot
	else
		local x, y, z
		if math.abs(v_space[3][1])==1 then
			if v_space[3][1]==1 then
				y=90
				z=math.deg(math.acos(-v_space[1][3]))
			else
				y=-90
				z=math.deg(math.acos(v_space[1][3]))
			end
			if v_space[1][2]<0 then z=-z end
			return 0, y, z
		else
			local h=math.sqrt(1-(v_space[3][1]^2+v_space[3][3]^2-1)/(v_space[3][1]^2-1))
			x=math.deg(math.acos(h))
			if v_space[3][3]<0 then
				if v_space[3][2]>0 then x=-180+x
				else x=180-x end
			elseif v_space[3][2]>0 then x=-x
			end
			y=math.deg(math.asin(v_space[3][1]))
			
			return x, y, 0
		end
	end
end

function load_sounds()
	music_explore 	= E.load_sound(music_files.explore)
	music_melee		= E.load_sound(music_files.melee)
	
	sound_sek_pickup 	= E.load_sound(sound_files.sek_pickup)
	sound_fak_pickup 	= E.load_sound(sound_files.fak_pickup)
		
	sound_player_defend	= E.load_sound(sound_files.player_defend)
	sound_player_hit 	= E.load_sound(sound_files.player_hit)
	sound_player_killed = E.load_sound(sound_files.player_killed)
	
	sound_sslash_move 	= E.load_sound(sound_files.sslash_move)
	sound_sslash_hit_barrier = E.load_sound(sound_files.sslash_hit_barrier)
	
	sound_enemy_shoot 	= E.load_sound(sound_files.enemy_shoot)
	sound_enemy_hit 	= E.load_sound(sound_files.enemy_hit)
	sound_enemy_killed 	= E.load_sound(sound_files.enemy_killed)
	
	sound_boss_shoot	= E.load_sound(sound_files.boss_shoot)
	sound_boss_spawn	= E.load_sound(sound_files.boss_spawn)
	sound_boss_hit		= E.load_sound(sound_files.boss_hit)
	sound_boss_killed	= E.load_sound(sound_files.boss_killed)
	
	sound_final_obj_appear = E.load_sound(sound_files.final_obj_appear)
end

function set_geom_attr(entity, attr)
   if entity   == nil then return nil end
   if attr.cat ~= nil then E.set_entity_geom_attr(entity, E.geom_attr_category, attr.cat) end
   if attr.col ~= nil then E.set_entity_geom_attr(entity, E.geom_attr_collider, attr.col) end
   if attr.res ~= nil then E.set_entity_geom_attr(entity, E.geom_attr_response, attr.res) end
   if attr.cal ~= nil then E.set_entity_geom_attr(entity, E.geom_attr_callback, attr.cal) end
   if attr.mas ~= nil then E.set_entity_geom_attr(entity, E.geom_attr_mass,     attr.mas) end
   if attr.bou ~= nil then E.set_entity_geom_attr(entity, E.geom_attr_bounce,   attr.bou) end
   if attr.fri ~= nil then E.set_entity_geom_attr(entity, E.geom_attr_friction, attr.fri) end
   if attr.erp ~= nil then E.set_entity_geom_attr(entity, E.geom_attr_soft_erp, attr.erp) end
   if attr.cfm ~= nil then E.set_entity_geom_attr(entity, E.geom_attr_soft_cfm, attr.cfm) end
   return entity
end

function get_rgb_from_colorname(color)
   local alpha = 1.0
   if     color == "green"  then return 0.0, 1.0, 0.0, alpha
   elseif color == "blue"   then return 0.0, 0.0, 1.0, alpha
   elseif color == "yellow" then return 1.0, 1.0, 0.0, alpha
   elseif color == "purple" then return 1.0, 0.0, 1.0, alpha
   elseif color == "cyan"   then return 0.0, 1.0, 1.0, alpha
   elseif color == "orange" then return 1.0, 0.5, 0.0, alpha
   elseif color == "white"  then return 1.0, 1.0, 1.0, alpha
   elseif color == "black"  then return 0.0, 0.0, 0.0, alpha
   end
end

function create_sprite(brush, rot, scale, pos, billboard, parent)
	local sprite = E.create_sprite(brush)

	E.set_entity_rotation(sprite, rot.rx, rot.ry, rot.rz)
	E.set_entity_scale(sprite, scale, scale, scale)
	E.set_entity_position(sprite, pos.x, pos.y, pos.z)

	E.set_entity_flags(sprite, E.entity_flag_billboard, billboard)

	if not parent then 	E.parent_entity(sprite, walldecorgroup)
	else				E.parent_entity(sprite, parent)
	end

	return sprite
end

function create_image_sprite(image_file, rot, scale, pos, billboard, parent, transparent)
   local brush = E.create_brush()

   E.set_brush_flags(brush, E.brush_flag_unlit, true)
   if transparent == nil then E.set_brush_flags(brush, E.brush_flag_transparent, true)
   else E.set_brush_flags(brush, E.brush_flag_transparent, transparent)
   end
   E.set_brush_color(brush, 1.0, 1.0, 1.0, 1.0)
   E.set_brush_image(brush, E.create_image(image_file))

   return create_sprite(brush, rot, scale, pos, billboard, parent)
end


function create_color_brush(red, green, blue, alpha)
   local brush = E.create_brush()
   E.set_brush_color(brush, red, green, blue, alpha)
   return brush
end

function create_image_brush(imgfile, alpha, sky)
   alpha = alpha or 1.0
   if sky == nil then sky = true end

   image = (type(imgfile) == "string") and E.create_image(imgfile) or imgfile

   local brush = E.create_brush()
   if sky then
      E.set_brush_flags(brush, E.brush_flag_unlit+E.brush_flag_transparent+E.brush_flag_sky_map_0, true)
   else
      E.set_brush_flags(brush, E.brush_flag_unlit+E.brush_flag_transparent, true)
   end
   E.set_brush_color(brush, 1.0, 1.0, 1.0, alpha)
   E.set_brush_image(brush, image)

   return brush
end

function attach_image_brush(imgfile, obj, alpha)
   alpha = alpha or 1.0

   local image = (type(imgfile) == "string") and E.create_image(imgfile) or imgfile

   local brush = E.get_mesh(obj, 0)
   E.set_brush_flags(brush, E.brush_flag_unlit+E.brush_flag_transparent+E.brush_flag_sky_map_0, true)
   E.set_brush_color(brush, 1.0, 1.0, 1.0, alpha)
   E.set_brush_image(brush, image)
end

function convert_keyboard()
	--convert keyboard input
	if input.key.w then
		if not input.key.s then
			if input.key.a and input.key.d then
				input.x=0
				input.y=0
			elseif input.key.a then
				input.x=0-math.sqrt(0.5)
				input.y=math.sqrt(0.5)
			elseif input.key.d then
				input.x=math.sqrt(0.5)
				input.y=math.sqrt(0.5)
			else
				input.x=0
				input.y=1
			end
		else
			if input.key.a and input.key.d then
				input.x=0
				input.y=0
			elseif input.key.a then
				input.x=-1
				input.y=0
			elseif input.key.d then
				input.x=1
				input.y=0
			else
				input.x=0
				input.y=0
			end
		end
	elseif input.key.s then
		if input.key.a and input.key.d then
			input.x=0
			input.y=-1
		elseif input.key.a then
			input.x=0-math.sqrt(0.5)
			input.y=0-math.sqrt(0.5)
		elseif input.key.d then
			input.x=math.sqrt(0.5)
			input.y=0-math.sqrt(0.5)
		else
			input.x=0
			input.y=-1
		end
	elseif input.key.a then
		if input.key.d then
			input.x=0
			input.y=0
		else
			input.x=-1
			input.y=0
		end
	elseif input.key.d then
		input.x=1
		input.y=0
	else
		input.x=0
		input.y=0
	end
	if input.key.q then input.joy.x=-1
	elseif input.key.e then input.joy.x=1
	else input.joy.x=0
	end
	if input.key.left then
		if not input.key.right then input.turn=-1
		else input.turn=0 end
	elseif input.key.right then input.turn=1
	else input.turn=0 end
end

function make_final_objective(pos)
	final_obj = E.create_object(final_objective_file)
	local scale = {10, 10, 10}
	E.set_entity_scale(final_obj, scale[1], scale[2], scale[3])
	E.set_entity_position(final_obj, pos[1], pos[2], pos[3])
	
	local minx, miny, minz, maxx, maxy, maxz = E.get_entity_bound(final_obj)
	E.set_entity_geom_type(final_obj, E.geom_type_box, (maxx-minx)*scale[1], (maxy-miny)*scale[2], (maxz-minz)*scale[3])
	set_geom_attr(final_obj, {cat=cat_final_obj, 
							  col=cat_player,
							  res=0, 
							  cal=cat_player})

	E.set_entity_flags(final_obj, E.entity_flag_hidden, true)
	final_obj_revealed = false
	E.parent_entity(final_obj, finalobjgroup)
end
