GAMEOVER_LUA=true

gameover={
consts={curs_scale=0.048,
		screen_scale={0.1661, 0.1247},
		mod_x=391,
		mod_y=291,
		scale=9.4,
		gameover_screen=1,
		gameover_reenter=2,
		gameover_menu=3,
		gameover_giveup=4},
make_screen=function(screen_file, parent)
	parent=parent or pivot
	local screen=create_image_sprite(screen_file, {rx=0, ry=0, rz=0}, 1, {x=0, y=0, z=0}, false, parent)
	E.set_entity_scale(screen, gameover.consts.screen_scale[1], gameover.consts.screen_scale[2], 1)
	E.set_entity_flags(screen, E.entity_flag_hidden, true)
	return screen
end,
do_state=function(dt)
	if gameover.state==0 then --load
		E.set_entity_position(camera, 0, 0, 85)
		E.set_entity_rotation(camera, 0, 0, 0)
		E.set_entity_position(light1, 0, 18, 5)
		E.set_entity_position(light2, 0, -18, -5)
		gameover.data={}
		gameover.data.pivot=E.create_pivot()
		E.parent_entity(gameover.data.pivot, pivot)
		gameover.data.cursor=create_image_sprite(custom_cursor_file, {rx=0, ry=0, rz=0}, gameover.consts.curs_scale,
			{x=0, y=0, z=0}, true, gameover.data.pivot)
		E.set_entity_position(gameover.data.cursor, (input.curs.px-gameover.consts.mod_x)/gameover.consts.scale,
			-(input.curs.py-gameover.consts.mod_y)/gameover.consts.scale, 0)
		gameover.data.gameover_screen=gameover.make_screen(gameover_screen_file_normal, gameover.data.pivot)
		gameover.data.gameover_reenter=gameover.make_screen(gameover_screen_file_reenter, gameover.data.pivot)
		gameover.data.gameover_menu=gameover.make_screen(gameover_screen_file_mainmenu, gameover.data.pivot)
		gameover.data.gameover_giveup=gameover.make_screen(gameover_screen_file_giveup, gameover.data.pivot)
		E.set_entity_flags(gameover.data.gameover_screen, E.entity_flag_hidden, false)
		gameover.data.screen=gameover.consts.gameover_screen
		gameover.state=1
		return true
	elseif gameover.state==1 then --menu screen
		E.set_entity_position(gameover.data.cursor, (input.curs.px-gameover.consts.mod_x)/gameover.consts.scale,
			-(input.curs.py-gameover.consts.mod_y)/gameover.consts.scale, 0)
		if input.curs.px>=gameover_reenter_btn_bounds.x[1] and input.curs.px<=gameover_reenter_btn_bounds.x[2] and
			input.curs.py>=gameover_reenter_btn_bounds.y[1] and input.curs.py<=gameover_reenter_btn_bounds.y[2] then
			gameover.swap_screen(gameover.consts.gameover_reenter)
			if input.curs.click then
				input.curs.click=false
				gameover.state=2
			end
		elseif input.curs.px>=gameover_mainmenu_btn_bounds.x[1] and input.curs.px<=gameover_mainmenu_btn_bounds.x[2] and
			input.curs.py>=gameover_mainmenu_btn_bounds.y[1] and input.curs.py<=gameover_mainmenu_btn_bounds.y[2] then
			gameover.swap_screen(gameover.consts.gameover_menu)
			if input.curs.click then
				input.curs.click=false
				gameover.state=3
			end
		elseif input.curs.px>=gameover_giveup_btn_bounds.x[1] and input.curs.px<=gameover_giveup_btn_bounds.x[2] and
			input.curs.py>=gameover_giveup_btn_bounds.y[1] and input.curs.py<=gameover_giveup_btn_bounds.y[2] then
			gameover.swap_screen(gameover.consts.gameover_giveup)
			if input.curs.click then
				os.execute("TASKKILL /F /IM GlovePIE.exe || cls")
				E.exit()
			end
		else
			gameover.swap_screen(gameover.consts.gameover_screen)
			input.curs.click=false
		end
		return true
	elseif gameover.state==2 then
		E.delete_entity(gameover.data.pivot)
		gameover.data=nil
		gameover.state=0
		state=3
		return true
	elseif gameover.state==3 then --unload
		E.delete_entity(gameover.data.pivot)
		gameover.data=nil
		gameover.state=0
		return false
	end
end,
swap_screen=function(screen)
	if screen~=gameover.data.screen then
		if gameover.data.screen==gameover.consts.gameover_screen then
			E.set_entity_flags(gameover.data.gameover_screen, E.entity_flag_hidden, true)
		elseif gameover.data.screen==gameover.consts.gameover_reenter then
			E.set_entity_flags(gameover.data.gameover_reenter, E.entity_flag_hidden, true)
		elseif gameover.data.screen==gameover.consts.gameover_menu then
			E.set_entity_flags(gameover.data.gameover_menu, E.entity_flag_hidden, true)
		elseif gameover.data.screen==gameover.consts.gameover_giveup then
			E.set_entity_flags(gameover.data.gameover_giveup, E.entity_flag_hidden, true)
		end
		gameover.data.screen=screen
		if gameover.data.screen==gameover.consts.gameover_screen then
			E.set_entity_flags(gameover.data.gameover_screen, E.entity_flag_hidden, false)
		elseif gameover.data.screen==gameover.consts.gameover_reenter then
			E.set_entity_flags(gameover.data.gameover_reenter, E.entity_flag_hidden, false)
		elseif gameover.data.screen==gameover.consts.gameover_menu then
			E.set_entity_flags(gameover.data.gameover_menu, E.entity_flag_hidden, false)
		elseif gameover.data.screen==gameover.consts.gameover_giveup then
			E.set_entity_flags(gameover.data.gameover_giveup, E.entity_flag_hidden, false)
		end
	end
end,
state=0
}

--[[
function do_start()
	camera=E.create_camera(E.camera_type_perspective)
	light1=E.create_light(E.light_type_positional)
	light2=E.create_light(E.light_type_positional)
	pivot=E.create_pivot()
	E.parent_entity(light1, camera)
	E.parent_entity(light2, light1)
	E.parent_entity(pivot, light2)
	E.set_entity_position(light1, 0, 18, 5)
	E.set_entity_position(light2, 0, -18, -5)
	E.set_background(0, 0, 0)
	E.enable_timer(true)
end

do_start()

total_dt=0
do_gameover=true

function do_timer(dt)
	total_dt=total_dt+dt

	if do_gameover then do_gameover=gameover.do_state(dt) end
end

function do_point(dx, dy)
	input.curs.dx=dx
	input.curs.dy=dy
	input.curs.px=input.curs.px+dx
	input.curs.py=input.curs.py+dy
	if input.curs.px>800 then input.curs.px=800
	elseif input.curs.px<0 then input.curs.px=0
	end
	if input.curs.py>600 then input.curs.py=600
	elseif input.curs.py<0 then input.curs.py=0
	end
end

function do_click(b, s)
	if b==1 then input.curs.click=s end
	if b==3 then do_gameover=true end
end
]]
