INTRO_LUA=true

intro={
consts={delay=5.7,
		fade_rate=0.3},
do_state=function(dt)
	if input.key.space or input.key.p or input.curs.click then
		input.key.space=false
		input.key.p=false
		input.curs.click=false
		intro.state=4
	end
	if intro.state==0 then --load
		E.set_entity_position(camera, 0, 0, 85)
		E.set_entity_rotation(camera, 0, 0, 0)
		E.set_entity_position(light1, 0, 18, 5)
		E.set_entity_position(light2, 0, -18, -5)
		intro.company={}
		intro.company.name= {	E.create_object(U_file),
								E.create_object(N_file),
								E.create_object(C_file),
								E.create_object(E_file),
								E.create_object(R_file),
								E.create_object(T_file),
								E.create_object(A_file),
								E.create_object(I_file),
								nil,
								nil,
								nil,
								nil,
								nil,
								E.create_object(L_file),
								nil,
								nil,
								E.create_object(Y_file),
								nil,
								E.create_object(G_file),
								nil,
								E.create_object(M_file),
								nil,
								E.create_object(S_file)}
		intro.company.name[9]=E.create_clone(intro.company.name[2])
		intro.company.name[11]=E.create_clone(intro.company.name[5])
		intro.company.name[12]=E.create_clone(intro.company.name[4])
		intro.company.name[13]=E.create_clone(intro.company.name[7])
		intro.company.name[15]=E.create_clone(intro.company.name[8])
		intro.company.name[16]=E.create_clone(intro.company.name[6])
		intro.company.name[20]=E.create_clone(intro.company.name[7])
		intro.company.name[22]=E.create_clone(intro.company.name[4])
		intro.company.brush=E.create_brush()
		intro.company.pivot = E.create_pivot()
		E.parent_entity(intro.company.pivot, light2)
		for i=1, #intro.company.name do
			if intro.company.name[i] then
				E.parent_entity		  (intro.company.name[i], intro.company.pivot)
				E.set_entity_body_type(intro.company.name[i], true)
				E.set_entity_scale	  (intro.company.name[i], 1.8, 1.8, 1.8)
				E.set_entity_position (intro.company.name[i], i*3.65-44, i*4+40, 0)
				E.set_mesh			  (intro.company.name[i], 0, intro.company.brush)
				E.set_entity_geom_type(intro.company.name[i], E.geom_type_box, 1.5, 0.5, 1.5)
				set_geom_attr		  (intro.company.name[i], {	cat=cat_comp_lettes,
																col=cat_imag_border,
																res=cat_imag_border,
																mas=2, bou=0.5, fri=1000})
			end
		end
		E.set_brush_color(intro.company.brush, 1, 1, 1, 1)
		-- create imaginary floor for letters to fall onto
		intro.company.floor = E.create_pivot()
		E.parent_entity(intro.company.floor, intro.company.pivot)
		E.set_entity_geom_type(intro.company.floor, E.geom_type_plane, 0, 1, 0, 0)
		E.set_entity_position(intro.company.floor, 0, -5, 0)
		set_geom_attr(intro.company.floor, {cat=cat_imag_border,
											col=cat_comp_letters,
											res=cat_comp_letters})
		-- motto
		intro.company.alpha = 0.0
		E.set_typeface(company_intro_font)
		intro.company.motto = E.create_string("B r i n g i n g   U R   G a m e s   T o   Y o u")
		E.parent_entity(intro.company.motto, intro.company.pivot)
		intro.company.motto_brush = E.create_brush()
		E.set_brush_color(intro.company.motto_brush, 1.0, 1.0, 1.0, 0)
		E.set_brush_flags(intro.company.motto_brush, E.brush_flag_unlit, true)
		E.set_string_fill(intro.company.motto, intro.company.motto_brush)
		E.set_entity_scale(intro.company.motto, 2, 2, 2)
		E.set_entity_position(intro.company.motto, -40, -5, 0)
		intro.start_dt=total_dt
		intro.state=1
		return true
	elseif intro.state==1 then --drop
		if total_dt-intro.start_dt>=intro.consts.delay then intro.state=2 end
		return true
	elseif intro.state==2 then --fade in
		intro.company.alpha=intro.company.alpha+intro.consts.fade_rate*dt
		if intro.company.alpha>=1 then
			intro.company.alpha=1
			E.set_brush_color(intro.company.motto_brush, 1, 1, 1, 1)
			intro.state=3
		else
			E.set_brush_color(intro.company.motto_brush, 1, 1, 1, intro.company.alpha)
		end
		return true
	elseif intro.state==3 then --fade out
		intro.company.alpha=intro.company.alpha-intro.consts.fade_rate*dt
		if intro.company.alpha<=0 then
			intro.company.alpha=0
			E.set_brush_color(intro.company.brush, 1, 1, 1, 0)
			E.set_brush_color(intro.company.motto_brush, 1, 1, 1, 0)
			intro.state=4
		else
			E.set_brush_color(intro.company.brush, 1, 1, 1, intro.company.alpha)
			E.set_brush_color(intro.company.motto_brush, 1, 1, 1, intro.company.alpha)
		end
		return true
	elseif intro.state==4 then --unload
		E.delete_entity(intro.company.pivot)
		E.delete_brush(intro.company.brush)
		E.delete_brush(intro.company.motto_brush)
		intro.company=nil
		intro.state=0
		return false
	end
end,
state=0
}

--[[
function do_start()
	camera=E.create_camera(E.camera_type_perspective)
	light1=E.create_light(E.light_type_positional)
	light2=E.create_light(E.light_type_positional)
	pivot=E.create_pivot()
	E.parent_entity(light1, camera)
	E.parent_entity(light2, light1)
	E.parent_entity(pivot, light2)
	E.set_entity_position(light1, 0, 18, 5)
	E.set_entity_position(light2, 0, -18, -5)
	E.set_background(0, 0, 0)
	E.enable_timer(true)
end

do_start()

total_dt=0
do_intro=true

function do_timer(dt)
	total_dt=total_dt+dt
	
	if do_intro then do_intro=intro.do_state(dt) end
end

function do_keyboard(k, s)
	if k==E.key_space then input.key.space=s end
end
]]
