ITEMS_LUA = true

function create_item(item_type, item_size)
	local file
	
	if item_type == "fak" then
		if item_size == "small" then file = firstaidkit_small_file else file = firstaidkit_large_file end
	else
		if item_size == "small" then file = saberenergykit_small_file else file = saberenergykit_large_file	end
	end

	local item = E.create_object(file)
	E.parent_entity(item, clone_basegroup)
	return item
end

_item={
consts={	recover_max=50,
			recover_min=20,
			inc_saber_energy_small=10,
			inc_saber_energy_large=20
},

small_fak_obj = create_item("fak", "small"),
large_fak_obj = create_item("fak", "large"),
small_sek_obj = create_item("sek", "small"),
large_sek_obj = create_item("sek", "large"),
firstaidkits = {},
saberenergykits = {},

create_firstaidkit = function (faktype, x, y, z)
	local fak
	if faktype == "small" then	fak = E.create_clone(_item.small_fak_obj)
	else						fak = E.create_clone(_item.large_fak_obj)
	end
	E.set_entity_position(fak, x, y, z)

	local minx, miny, minz, maxx, maxy, maxz = E.get_entity_bound(fak)
	E.set_entity_geom_type(fak, E.geom_type_box, maxx-minx, maxy-miny, maxz-minz)
	set_geom_attr(fak, {cat=cat_fak,
					   col=cat_player_fak,
					   res=0,
					   cal=cat_player_fak})

	E.parent_entity(fak, itemgroup)

	return fak
end,

add_firstaidkit = function (faktype, pos)
	local firstaidkit = {}

	firstaidkit.entity = _item.create_firstaidkit(faktype, pos.x, pos.y+0.6, pos.z)
	if faktype == "small" then firstaidkit.recover = _item.consts.recover_min
	else					   firstaidkit.recover = _item.consts.recover_max
	end
	firstaidkit.brush = E.get_mesh(firstaidkit.entity, 0)
	E.set_brush_color(firstaidkit.brush, 1.0, 1.0, 1.0, 1.0)
	--E.set_brush_flags(firstaidkit.brush, E.brush_flag_unlit, true)

	table.insert(_item.firstaidkits, firstaidkit)
end,

del_firstaidkit = function (id, firstaidkit)
	E.play_sound(sound_fak_pickup)
	E.delete_entity(firstaidkit.entity)
	table.remove(_item.firstaidkits, id)
end,

create_saberenergykit = function (sektype, x, y, z)
	local sek
	if sektype == "small" then	sek = E.create_clone(_item.small_sek_obj)
	else						sek = E.create_clone(_item.large_sek_obj)
	end

	E.set_entity_position(sek, x, y, z)
	local minx, miny, minz, maxx, maxy, maxz = E.get_entity_bound(sek)
	E.set_entity_geom_type(sek, E.geom_type_box, maxx-minx, maxy-miny, maxz-minz)
	set_geom_attr(sek, {cat=cat_sek,
					   col=cat_player_sek,
					   res=0,
					   cal=cat_player_sek})

	E.parent_entity(sek, itemgroup)

	return sek
end,

add_saberenergykit = function (sektype, pos)
	local saberenergykit = {}

	saberenergykit.entity = _item.create_saberenergykit(sektype, pos.x, pos.y+0.6, pos.z)
	if sektype == "small" then saberenergykit.add_energy = _item.consts.inc_saber_energy_small
	else					   saberenergykit.add_energy = _item.consts.inc_saber_energy_large
	end
	saberenergykit.brush = E.get_mesh(saberenergykit.entity, 0)
	E.set_brush_color(saberenergykit.brush, 1.0, 1.0, 1.0, 1.0)
	--E.set_brush_flags(saberenergykit.brush, E.brush_flag_unlit, true)

	table.insert(_item.saberenergykits, saberenergykit)
end,

del_saberenergykit = function (id, saberenergykit)
	E.play_sound(sound_sek_pickup)
	E.delete_entity(saberenergykit.entity)
	table.remove(_item.saberenergykits, id)
end
}
