if not PLAYER_LUA	then dofile("player.lua")	end
if not ENEMY_LUA	then dofile("enemy.lua")	end
if not ITEMS_LUA	then dofile("items.lua")	end
if not ROOMS_LUA	then dofile("rooms.lua")	end

LEVEL_LUA = true

function level_setup(dt)
	if total_frames == 0 then
		if not wall_types then wall_types = make_walltypes() end
		pivot_setup()
		checkpoint_setup()
		player.create_entity()
		if lastckpt == -1 then	player.entity.pivot.pos = {600, 3, 300}
		else					player.entity.pivot.pos = {checkpoints[lastckpt].pos[1], 3, checkpoints[lastckpt].pos[3]}
		end
		player_last_pos = {player.entity.pivot.pos[1], player.entity.pivot.pos[3]}
		avatar_setup(player.entity.pivot.pos)
		enemies_setup()
		items_setup()
		final_objective_setup()
	elseif total_frames < 40 then
		walls_setup()
	elseif total_frames >= 60 then
		spin_camera(dt)
	end
end

function radar_setup()
	radar = {}
	radar.scale = 0.0006
	radar.hide = create_image_sprite(radar_files.hide, {rx=0, ry=0, rz=0}, radar.scale, {x=0, y=0, z=0}, false, playergroup)
	radar.player_pos = create_image_sprite(radar_files.player_pos, {rx=0, ry=0, rz=0}, radar.scale, {x=0, y=0, z=0}, false, playergroup)
	radar.map = create_image_sprite(radar_files.map, {rx=0, ry=0, rz=0}, radar.scale, {x=0, y=0, z=0}, false, playergroup)
	if lastckpt == -1 then
		radar.map_range_s0 = 0.664
		radar.map_range_s1 = 0.764
		radar.map_range_t0 = 0.261
		radar.map_range_t1 = 0.351
	elseif lastckpt == 1 then
		radar.map_range_s0 = 0.40501
		radar.map_range_s1 = 0.50507
		radar.map_range_t0 = 0.20883
		radar.map_range_t1 = 0.29883
	else
		radar.map_range_s0 = 0.49891
		radar.map_range_s1 = 0.59891
		radar.map_range_t0 = 0.50515
		radar.map_range_t1 = 0.59515
	end
	
	player.entity.radar_hide = _VP.attach_entity(player.entity, radar.hide, {-0.8, 1.448, 0})
	player.entity.radar_map =_VP.attach_entity(player.entity, radar.map, {-0.8, 1.448, 0})
	player.entity.radar_player_pos = _VP.attach_entity(player.entity, radar.player_pos, {-0.8, 1.448, 0})
		
	E.set_sprite_range(radar.map, radar.map_range_s0, radar.map_range_s1, radar.map_range_t0, radar.map_range_t1)
end

function update_radar(pmove)
	-- rotate map
	local x, y, z = get_rotation(player.entity.pivot.vect)
	player.entity.radar_map.rot = {0, 0, -y}
	
	-- move map
	local diff = {}
	diff.x = (pmove.after.x - pmove.before.x) * (radar.scale-.000085)
	diff.z = (pmove.after.z - pmove.before.z) * (radar.scale-.000085)
	radar.map_range_s0 = radar.map_range_s0 + diff.x
	radar.map_range_s1 = radar.map_range_s1 + diff.x
	radar.map_range_t0 = radar.map_range_t0 - diff.z
	radar.map_range_t1 = radar.map_range_t1 - diff.z
	E.set_sprite_range(radar.map, radar.map_range_s0, radar.map_range_s1, radar.map_range_t0, radar.map_range_t1)
end

function avatar_setup(pos)
	avatar=E.create_object(avatar_file)
	E.set_entity_scale(avatar, 1.5, 1.5, 1.5)
	E.set_entity_position(avatar, pos[1], pos[2], pos[3])
	E.set_entity_rotation(avatar, 0, 180, 0)
	
	vp=_VP.create_virtual_pivot(pivot)
	vp.camera=_VP.attach_entity(vp, camera, {0, 6, 20})
	_VP.set_entity_position(vp, pos[1], pos[2], pos[3])
	message_setup()
	_VP.turn_entity(vp, 0, 180, 0)
	
	E.parent_entity(avatar, avatargroup)
end

function message_setup()
	boot_up_strs_group = E.create_pivot()
	E.parent_entity(boot_up_strs_group, avatargroup)
	boot_up_strs_brush = E.create_brush()
	E.set_typeface(load_level_font)
	for i=1,#boot_up_messages do
		boot_up_strs[i] = E.create_string(boot_up_messages[i])
		E.set_entity_scale(boot_up_strs[i], 0.02, 0.02, 0.02)
		E.set_entity_position(boot_up_strs[i], 0, (12-i)*.025+0.74, 0)
		E.set_entity_flags(boot_up_strs[i], E.entity_flag_hidden, true)
		E.set_string_fill(boot_up_strs[i], boot_up_strs_brush)
		E.parent_entity(boot_up_strs[i], boot_up_strs_group)
	end
	E.set_brush_color(boot_up_strs_brush, 1.0, 1.0, 1.0, 1.0)
	E.set_brush_flags(boot_up_strs_brush, E.brush_flag_unlit, true)
	vp.boot_up_strs = _VP.attach_entity(vp, boot_up_strs_group, {-0.543, 4.83, 18.9})
	boot_up_str_delays = {0, 12, 15, 30, 30, 30, 30, 18, 18, 18, 18}
	boot_up_str_delay_index = 1
	boot_up_str_delay_counter = 0
end

function spin_camera(dt)
	if boot_up_str_delay_counter >= boot_up_str_delays[boot_up_str_delay_index] then
		E.set_entity_flags(boot_up_strs[boot_up_str_delay_index], E.entity_flag_hidden, false)
		boot_up_str_delay_counter = 0
		if boot_up_str_delay_index < #boot_up_strs then
			boot_up_str_delay_index = boot_up_str_delay_index + 1
		end
	else
		boot_up_str_delay_counter = boot_up_str_delay_counter + 1
	end
	local mult = 45.2
	if vp.camera.pos[3]~=0 then
		vp_change_pos(vp.camera,dt)
		vp_change_pos(vp.boot_up_strs, dt)
		if vp.camera.pos[3]<0 then vp.camera.pos[3]=0 end
		if vp.camera.pos[2]<2 then vp.camera.pos[2]=2 end
		_VP.turn_entity(vp, 0, mult*dt, 0)
	elseif vp.pivot.vect[1][1]~=1 then
		local x, y, z=get_rotation(vp.pivot.vect)
		if y<180 and y>0+mult*dt then
			_VP.set_entity_rotation(vp, 0, 0, 0)
		else _VP.turn_entity(vp, 0, mult*dt, 0)
		end
	else
		E.delete_entity(avatargroup)
		E.delete_entity(vp.boot_up_strs.entity)
		vp.boot_up_strs = nil
		radar_setup()
		game.state = game.states.play
	end
end

function vp_change_pos(object, dt)
	object.pos[2] = object.pos[2]-dt
	object.pos[3] = object.pos[3]-5*dt
end

function pivot_setup()
	screen_overlay_pivot 	= E.create_pivot()
	walldecorgroup 			= E.create_pivot()
	sslashburnmarkgroup 	= E.create_pivot()
	sslashexpoflashgroup 	= E.create_pivot()
	playergroup 			= E.create_pivot()
	stringgroup 			= E.create_pivot()
	bulletgroup				= E.create_pivot()
	enemyfire   			= E.create_pivot()
	enemysightshotgroup		= E.create_pivot()
	enemydeadgroup 			= E.create_pivot()
	enemygroup  			= E.create_pivot()
	wallgroup   			= E.create_pivot()
	itemgroup   			= E.create_pivot()
	ckptgroup				= E.create_pivot()
	avatargroup				= E.create_pivot()
	finalobjgroup			= E.create_pivot()
	custom_cursor			= E.create_pivot()
	
	E.parent_entity(custom_cursor, pivot)
	E.parent_entity(screen_overlay_pivot, pivot)
	E.parent_entity(finalobjgroup, pivot)
	E.parent_entity(playergroup, pivot)
	E.parent_entity(bulletgroup, pivot)
	E.parent_entity(enemyfire, pivot)
	E.parent_entity(enemysightshotgroup, pivot)
	E.parent_entity(stringgroup, pivot)
	E.parent_entity(sslashexpoflashgroup, pivot)
	E.parent_entity(sslashburnmarkgroup, pivot)
	E.parent_entity(enemydeadgroup, pivot)
	E.parent_entity(walldecorgroup, pivot)
	E.parent_entity(enemygroup, pivot)
	E.parent_entity(wallgroup, pivot)
	E.parent_entity(itemgroup, pivot)
	E.parent_entity(ckptgroup, pivot)
	E.parent_entity(avatargroup, pivot)
end

function enemies_setup()
	local y = 4
	_enemy.add("tro",   {600, y, -200})
	_enemy.add("tro", {600, y,  -670})

	_enemy.add("tro", {320, y,  -980})
	_enemy.add("tro", {-140, y, 980})
	_enemy.add("tro", {100, y,  -700})
	_enemy.add("tro", {-400, y,  -700})
	_enemy.add("tro", {-720, y,  -700})
	_enemy.add("tro", {-400, y,  -200})
	_enemy.add("tro", {-400, y,  300})

	_enemy.add("shikigami",{-680,  y+.7,  300})
	_enemy.add("shikigami",{440,  y+.7,  400})
	_enemy.add("shikigami",{580,  y+.7,  640})
	_enemy.add("shikigami",{440,  y+.7,  -80})
	_enemy.add("shikigami",{440,  y+.7,  -500})
	_enemy.add("shikigami",{80,  y+.7,  -500})
	_enemy.add("shikigami",{-180,  y+.7,  -80})
	_enemy.add("shikigami",{250,  y+.7,  50})
	_enemy.add("shikigami",{305,  y+.7,  325})
	_enemy.add("shikigami",{255,  y+.7,   325})

	_enemy.add("lil_spiky", {60,  y,  100})
	_enemy.add("lil_spiky", {160,  y,  20})
	_enemy.add("lil_spiky", {0,  y,  0})
	_enemy.add("lil_spiky", {-60,  y,  120})
	_enemy.add("lil_spiky", {0,  y,  -80})
	_enemy.add("lil_spiky", {0,  y,  80})
	_enemy.add("lil_spiky", {-155,  y,  100})
	_enemy.add("lil_spiky", {-125,  y,  100})
	_boss.make({-140, y+3.5, 280})
end

function walls_setup()
	-- wall texture types
	local green  = wall_types.green
	local blue   = wall_types.blue
	local red    = wall_types.red
	local yellow = wall_types.yellow
	local white  = wall_types.white

	-- wall decor types
	local urgname_green  = wall_decor.urgamesname_green
	local urgname_blue   = wall_decor.urgamesname_blue
	local urgname_red    = wall_decor.urgamesname_red
	local urgname_yellow = wall_decor.urgamesname_yellow
	local urgname_white  = wall_decor.urgamesname_white
	local glow_ring		 = wall_decor.glow_ring
	local glow_box		 = wall_decor.glow_box
	local glow_star		 = wall_decor.glow_star

if total_frames == 5 then
	add_room2(red, {w=10, h=20, d=10}, {x=600, y=0, z=-700},{})

	add_room(red, {w=140, h=20, d=140}, {x=600, y=0, z=300}, {front={50}})	
	add_hallway(red, 0, {w=20, h=20, d=360}, {x=600, y=0, z=50})
	add_room(red, {w=140, h=20, d=140}, {x=600, y=0, z=-200}, {front={50}, back={50}})	
	add_hallway(red, 0, {w=20, h=20, d=360}, {x=600, y=0, z=-450})
	add_room(red, {w=140, h=20, d=140}, {x=600, y=0, z=-700}, {left={450/13, 850/13}, back={50}})
	add_hallway(red, 90, {w=20, h=20, d=360}, {x=350,y=0, z=-680})

elseif total_frames == 10 then	
	add_room2(white, {w=10, h=20, d=10}, {x=300, y=0, z=-980}, {})

	add_L_joint(white, 0, {w=80, h=20, d=40, lw=20, _w=20}, {x=450, y=0, z=-710})
	add_T_joint(white, 270, {w=100, h=20, d=60, topw=20, stemw=20}, {x=460, y=0, z=-800})
	add_L_joint(white, 180, {w=100, h=20, d=140, lw=20, _w=20}, {x=470, y=0, z=-990})
	add_room(white, {w=140, h=20, d=140}, {x=300, y=0, z=-980}, {right={50}, left={50}})
	add_T_joint(white, 0, {w=140, h=20, d=40, topw=20, stemw=20}, {x=340, y=0, z=-800})
	--add_hallway(white, 90, {w=60, h=20, d=40}, {x=-240,y=0, z=-405})
	add_wall(white, 90, {w=20, h=20, d=6}, {x=270, y=0, z=-800})
	add_L_joint(white, 90, {w=60, h=20, d=180, lw=20, _w=20}, {x=350, y=0, z=-710})
	add_hallway(white, 90, {w=20, h=20, d=300}, {x=80,y=0, z=-980})
	add_room(white, {w=140, h=20, d=140}, {x=-140, y=0, z=-980}, {right={50}, left={450/13, 1050/13}})
	add_L_joint(white, 270, {w=180, h=20, d=200, lw=20, _w=20}, {x=-410, y=0, z=-950})
	--add_L_joint(white, 270, {w=95, h=20, d=230, lw=20, _w=20}, {x=-770, y=0, z=-520})
	add_hallway(white, 90, {w=20, h=20, d=340}, {x=-380,y=0, z=-1000})
	add_room(white, {w=100, h=20, d=100}, {x=-600, y=0, z=-1000}, {right={50}, back={50}})

elseif total_frames == 15 then
	add_room2(red, {w=5, h=20, d=5}, {x=100, y=0, z=-725}, {})
	add_room2(red, {w=5, h=20, d=5}, {x=100, y=0, z=-675}, {})
	
	add_room(red, {w=140, h=20, d=140}, {x=100, y=0, z=-700}, {right={450/13, 850/13}, left={50}})
	add_hallway(red, 90, {w=20, h=20, d=360}, {x=-150,y=0, z=-700})
	add_room(red, {w=140, h=20, d=140}, {x=-400, y=0, z=-700}, {left={450/13, 850/13}, right={50}, front={50}, back={50}})

	add_L_joint(white, 0, {w=80, h=20, d=60, lw=20, _w=20}, {x=-550, y=0, z=-710})
	add_L_joint(white, 180, {w=40, h=20, d=40, lw=20, _w=20}, {x=-530, y=0, z=-810})
	add_L_joint(white, 270, {w=60, h=20, d=80, lw=20, _w=20}, {x=-550, y=0, z=-690})
	add_L_joint(white, 90, {w=40, h=20, d=100, lw=20, _w=20}, {x=-530, y=0, z=-590})
	add_T_joint(white, 180, {w=60, h=20, d=160, topw=20, stemw=20}, {x=-600, y=0, z=-800})
	add_T_joint(white, 0, {w=60, h=20, d=360, topw=20, stemw=20}, {x=-660, y=0, z=-600})
	add_L_joint(white, 0, {w=40, h=20, d=40, lw=20, _w=20}, {x=-730, y=0, z=-590})
	add_L_joint(white, 270, {w=40, h=20, d=100, lw=20, _w=20}, {x=-730, y=0, z=-810})
	add_room(white, {w=140, h=20, d=140}, {x=-720, y=0, z=-700}, {front={50}, back={50}})


--elseif total_frames == 60 then
	add_room2(red, {w=5, h=20, d=5}, {x=-440, y=0, z=-240}, {})
	add_room2(red, {w=5, h=20, d=5}, {x=-440, y=0, z=-160}, {})
	add_room2(red, {w=5, h=20, d=5}, {x=-360, y=0, z=-240}, {})
	add_room2(red, {w=5, h=20, d=5}, {x=-360, y=0, z=-160}, {})

	add_hallway(red, 0, {w=20, h=20, d=360}, {x=-400,y=0, z=-450})
	add_room(red, {w=140, h=20, d=140}, {x=-400, y=0, z=-200}, {front={50}, back={50}, right={50}, left={50}})
	add_hallway(red, 0, {w=20, h=20, d=120}, {x=-400,y=0, z=-70})
	add_room(red, {w=140, h=20, d=140}, {x=-400, y=0, z=300}, {front={50}, left={50}, right={450/13, 850/13}})
	add_L_joint(red, 180, {w=80, h=20, d=180, lw=20, _w=20}, {x=-250, y=0, z=-205})
	add_T_joint(red, 90, {w=140, h=20, d=80, topw=20, stemw=20}, {x=-400, y=0, z=60})
	add_T_joint(red, 270, {w=180, h=20, d=80, topw=20, stemw=20}, {x=-260, y=0, z=60})
	add_hallway(red, 0, {w=20, h=20, d=100}, {x=-400,y=0, z=180})
	--add_hallway(red, 0, {w=20, h=20, d=80}, {x=-600,y=0, z=210})
	--add_hallway(red, 0, {w=20, h=20, d=80}, {x=-520,y=0, z=210})
	add_L_joint(red, 90, {w=140, h=20, d=80, lw=20, _w=20}, {x=-250, y=0, z=290})

elseif total_frames == 20 then	
	add_hallway(white, 90, {w=20, h=20, d=140}, {x=-540,y=0, z=-200})
	add_room(white, {w=100, h=20, d=100}, {x=-660, y=0, z=-200}, {front={50}, back={50}, right={50}})
	add_hallway(white, 0, {w=20, h=20, d=380}, {x=-660,y=0, z=40})
	--add_T_joint(white, 90, {w=200, h=20, d=115, topw=20, stemw=20}, {x=-760, y=0, z=0})
	add_T_joint(white, 0, {w=140, h=20, d=100, topw=20, stemw=20}, {x=-540, y=0, z=300})
	add_room(white, {w=140, h=20, d=140}, {x=-680, y=0, z=300}, {front={850/13}, right={50}, left={50}, back={450/13, 1050/13}})
	add_T_joint(white, 270, {w=100, h=20, d=60, topw=20, stemw=20}, {x=-540, y=0, z=440})
	--add_L_joint(white, 90, {w=40, h=20, d=40, lw=20, _w=20}, {x=-675, y=0, z=390})
	add_L_joint(white, 0, {w=60, h=20, d=80, lw=20, _w=20}, {x=-650, y=0, z=450})
	add_L_joint(white, 90, {w=80, h=20, d=100, lw=20, _w=20}, {x=-690, y=0, z=450})
	add_hallway(white, 90, {w=20, h=20, d=40}, {x=-770,y=0, z=300})
	add_wall(white, 90, {w=20, h=20, d=6}, {x=-790, y=0, z=440})
	add_wall(white, 90, {w=20, h=20, d=6}, {x=-790, y=0, z=300})
	--add_L_joint(white, 0, {w=200, h=20, d=135, lw=20, _w=20}, {x=-685, y=0, z=560})
	add_hallway(white, 0, {w=20, h=20, d=100}, {x=-540,y=0, z=540})
	add_room(white, {w=100, h=20, d=100}, {x=-540, y=0, z=640}, {front={50}, right={50}})
	add_hallway(white, 90, {w=20, h=20, d=140}, {x=-420,y=0, z=640})

--elseif total_frames == 80 then	
	add_room2(yellow, {w=120, h=20, d=120}, {x=80, y=0, z=400}, {right={50}, left={50}})	

	add_L_joint(yellow, 180, {w=80, h=20, d=40, lw=20, _w=20}, {x=-250, y=0, z=310})
	add_T_joint(yellow, 90, {w=100, h=20, d=280, topw=20, stemw=20}, {x=-260, y=0, z=400})

	--add_L_joint(yellow, 0, {w=140, h=20, d=65, lw=20, _w=20}, {x=-525, y=0, z=415})
	add_room(yellow, {w=140, h=20, d=140}, {x=80, y=0, z=400}, {right={50}, left={50}})	
	add_hallway(yellow, 90, {w=20, h=20, d=220}, {x=260,y=0, z=400})
	add_room(yellow, {w=140, h=20, d=140}, {x=440, y=0, z=400}, {front={50}, back={50}, left={50}})

	add_T_joint(white, 180, {w=180, h=20, d=200, topw=20, stemw=20}, {x=-260, y=0, z=640})
	add_hallway(white, 90, {w=20, h=20, d=100}, {x=-120 ,y=0, z=640})
	add_room(white, {w=140, h=20, d=140}, {x=0, y=0, z=640}, {right={50}, left={50}})	
	add_T_joint(white, 180, {w=140, h=20, d=180, topw=20, stemw=20}, {x=440, y=0, z=640})
	--add_L_joint(white, 0, {w=200, h=20, d=100, lw=20, _w=20}, {x=-120, y=0, z=560})
	add_hallway(white, 90, {w=20, h=20, d=300}, {x=220 ,y=0, z=640})
	add_room(white, {w=140, h=20, d=140}, {x=580, y=0, z=640}, {front={50}, back={50}, right={50}, left={50}})	
	add_L_joint(white, 0, {w=140, h=20, d=80, lw=20, _w=20}, {x=570, y=0, z=790})
	add_L_joint(white, 270, {w=80, h=20, d=140, lw=20, _w=20}, {x=570, y=0, z=490})
	add_hallway(white, 90, {w=20, h=20, d=60}, {x=680 ,y=0, z=640})
	add_wall(white, 90, {w=20, h=20, d=6}, {x=710, y=0, z=500})
	add_wall(white, 90, {w=20, h=20, d=6}, {x=710, y=0, z=640})
	add_wall(white, 90, {w=20, h=20, d=6}, {x=710, y=0, z=780})

	add_wall(white, 0, {w=100, h=20, d=6}, {x=0, y=0, z=640})
	add_wall(white, 90, {w=100, h=20, d=6}, {x=-45, y=0, z=640})
	add_wall(white, 90, {w=100, h=20, d=6}, {x=-15, y=0, z=640})
	add_wall(white, 90, {w=100, h=20, d=6}, {x=15, y=0, z=640})
	add_wall(white, 90, {w=100, h=20, d=6}, {x=45, y=0, z=640})

elseif total_frames == 25 then
	add_room2(yellow, {w=5, h=20, d=5}, {x=440, y=0, z=-60}, {})	
	add_room2(yellow, {w=5, h=20, d=5}, {x=465, y=0, z=-85}, {})	
	add_room2(yellow, {w=5, h=20, d=5}, {x=465, y=0, z=-35}, {})	
	add_room2(yellow, {w=5, h=20, d=5}, {x=415, y=0, z=-85}, {})	
	add_room2(yellow, {w=5, h=20, d=5}, {x=415, y=0, z=-35}, {})	
	add_room2(yellow, {w=20, h=20, d=20}, {x=-260, y=0, z=-360}, {back={50}})
	add_room2(yellow, {w=80, h=20, d=80}, {x=-80, y=0, z=-260}, {left={50}})
	add_room2(yellow, {w=60, h=20, d=60}, {x=-80, y=0, z=-260}, {front={50}})
	add_room2(yellow, {w=40, h=20, d=40}, {x=-80, y=0, z=-260}, {back={50}})
	
	add_hallway(yellow, 0, {w=20, h=20, d=320}, {x=440,y=0, z=170})
	add_room(yellow, {w=140, h=20, d=140}, {x=440, y=0, z=-60}, {front={50}, back={50}})	
	add_hallway(yellow, 0, {w=20, h=20, d=300}, {x=440,y=0, z=-280})
	add_room(yellow, {w=140, h=20, d=140}, {x=440, y=0, z=-500}, {back={50}, left={50}})
	add_T_joint(yellow, 0, {w=220, h=20, d=80, topw=20, stemw=20}, {x=260, y=0, z=-500})
	add_L_joint(yellow, 90, {w=80, h=20, d=120, lw=20, _w=20}, {x=270, y=0, z=-350})
	--add_hallway(yellow, 90, {w=20, h=20, d=120}, {x=-225,y=0, z=-150})
	add_room(yellow, {w=140, h=20, d=140}, {x=80, y=0, z=-500}, {front={50}, back={50}, left={50}, right={50}})
	add_L_joint(yellow, 270, {w=80, h=20, d=280, lw=20, _w=20}, {x=-270, y=0, z=-510})
	add_room(yellow, {w=140, h=20, d=140}, {x=-260, y=0, z=-360}, {front={50}, right={50}, left={50}})
	add_room(yellow, {w=100, h=20, d=100}, {x=-200, y=0, z=-600}, {left={50}, right={50}})
	add_L_joint(yellow, 0, {w=40, h=20, d=140, lw=20, _w=20}, {x=-370, y=0, z=-350})
	add_L_joint(yellow, 270, {w=120, h=20, d=120, lw=20, _w=20}, {x=-370, y=0, z=-610})
	add_L_joint(yellow, 180, {w=240, h=20, d=40, lw=20, _w=20}, {x=90, y=0, z=-610})
	add_T_joint(yellow, 0, {w=60, h=20, d=120, topw=20, stemw=20}, {x=-160, y=0, z=-360})
	add_L_joint(yellow, 0, {w=40, h=20, d=80, lw=20, _w=20}, {x=-170, y=0, z=-170})
	--add_T_joint(yellow, 180, {w=70, h=20, d=40, topw=20, stemw=20}, {x=-335, y=0, z=-65})
	add_X_joint(yellow, {w=140, h=20, d=140, cs1w=20, cs2w=20}, {x=80, y=0, z=-360})
	add_hallway(yellow, 90, {w=20, h=20, d=140}, {x=-60,y=0, z=-360})
	add_L_joint(yellow, 90, {w=40, h=20, d=120, lw=20, _w=20}, {x=90, y=0, z=-250})
	add_room(yellow, {w=100, h=20, d=100}, {x=-80, y=0, z=-260}, {right={50}})

--elseif total_frames == 100 then
	add_room2(green, {w=5, h=20, d=5}, {x=280, y=0, z=300}, {})
	add_room2(green, {w=5, h=20, d=5}, {x=305, y=0, z=300}, {})
	add_room2(green, {w=5, h=20, d=5}, {x=330, y=0, z=300}, {})
	add_room2(green, {w=5, h=20, d=5}, {x=255, y=0, z=300}, {})
	add_room2(green, {w=5, h=20, d=5}, {x=230, y=0, z=300}, {})
	add_room2(green, {w=5, h=20, d=5}, {x=280, y=0, z=325}, {})
	add_room2(green, {w=5, h=20, d=5}, {x=280, y=0, z=350}, {})
	add_room2(green, {w=5, h=20, d=5}, {x=280, y=0, z=275}, {})
	add_room2(green, {w=5, h=20, d=5}, {x=280, y=0, z=250}, {})
	
	add_hallway(green, 90, {w=20, h=20, d=100}, {x=160,y=0, z=-180})
	add_hallway(green, 90, {w=20, h=20, d=100}, {x=-80,y=0, z=-180})
	add_T_joint(green, 0, {w=140, h=20, d=60, topw=20, stemw=20}, {x=40, y=0, z=-180})
	add_room(green, {w=60, h=20, d=60}, {x=40, y=0, z=-100}, {right={10}, left={10}, front={50}})
	add_wall(green, 90, {w=20, h=20, d=6}, {x=70, y=0, z=-95})
	add_wall(green, 90, {w=20, h=20, d=6}, {x=10, y=0, z=-95})
	add_hallway(green, 90, {w=20, h=20, d=140}, {x=-60,y=0, z=-80})
	add_room(green, {w=100, h=20, d=100}, {x=-180, y=0, z=-80}, {back={50/9, 50}, right={50}})
	add_hallway(green, 0, {w=20, h=20, d=140}, {x=-180,y=0, z=40})
	add_hallway(green, 0, {w=20, h=20, d=140}, {x=-220,y=0, z=40})
	add_room(green, {w=60, h=20, d=60}, {x=-200, y=0, z=140}, {front={10,90}})
	--add_L_joint(green, 0, {w=20, h=20, d=100, lw=20, _w=20}, {x=-495, y=0, z=185})
	--add_L_joint(green, 90, {w=200, h=20, d=20, lw=20, _w=20}, {x=-455, y=0, z=185})
	--add_L_joint(green, 180, {w=40, h=20, d=40, lw=20, _w=20}, {x=-390, y=0, z=-70})
	--add_L_joint(green, 0, {w=50, h=20, d=60, lw=20, _w=20}, {x=-400, y=0, z=30})
	add_room(green, {w=140, h=20, d=140}, {x=280, y=0, z=-180}, {left={50}, back={450/13, 1050/13}})
	add_L_joint(green, 180, {w=160, h=20, d=100, lw=20, _w=20}, {x=230, y=0, z=-90})
	add_hallway(green, 0, {w=20, h=20, d=120}, {x=260,y=0, z=-50})
	add_room(green, {w=80, h=20, d=80}, {x=250, y=0, z=50}, {front={50/7, 450/7}})
	add_hallway(green, 0, {w=20, h=20, d=340}, {x=320,y=0, z=60})
	
	add_room(green, {w=140, h=20, d=140}, {x=280, y=0, z=300}, {front={250/13, 1050/13}})

--[[
	add_hallway(green, 0, {w=20, h=20, d=180}, {x=-195,y=0, z=165})
	add_room(green, {w=200, h=20, d=100}, {x=-195, y=0, z=305}, {left={50}, front={50}})
	add_room(green, {w=60, h=20, d=60}, {x=-235, y=0, z=155}, {front={10, 90}})
	add_hallway(green, 0, {w=20, h=20, d=50}, {x=-215,y=0, z=100})
	add_T_joint(green, 180, {w=60, h=20, d=15, topw=20, stemw=20}, {x=-320, y=0, z=45})
	add_T_joint(green, 0, {w=60, h=20, d=15, topw=20, stemw=20}, {x=-320, y=0, z=25})
	add_hallway(green, 90, {w=20, h=20, d=45}, {x=-267.5,y=0, z=25})
	add_hallway(green, 90, {w=20, h=20, d=70}, {x=-385,y=0, z=45})
	add_L_joint(green, 180, {w=40, h=20, d=85, lw=20, _w=20}, {x=-250, y=0, z=40})
--]]

elseif total_frames == 30 then

	add_T_joint(blue, 270, {w=60, h=20, d=40, topw=20, stemw=20}, {x=180, y=0, z=80})
	add_L_joint(blue, 0, {w=40, h=20, d=40, lw=20, _w=20}, {x=170, y=0, z=150})
	add_L_joint(blue, 180, {w=40, h=20, d=40, lw=20, _w=20}, {x=250, y=0, z=130})
	add_T_joint(blue, 270, {w=60, h=20, d=40, topw=20, stemw=20}, {x=240, y=0, z=200})
	add_L_joint(blue, 270, {w=40, h=20, d=40, lw=20, _w=20}, {x=170, y=0, z=190})

	--add_L_joint(blue, 270, {w=60, h=20, d=40, lw=20, _w=20}, {x=110, y=0, z=70})
	add_T_joint(blue, 0, {w=60, h=20, d=60, topw=20, stemw=20}, {x=120, y=0, z=80})
	add_T_joint(blue, 270, {w=60, h=20, d=40, topw=20, stemw=20}, {x=120, y=0, z=160})
	add_X_joint(blue, {w=60, h=20, d=60, cs1w=20, cs2w=20}, {x=60, y=0, z=160})
	add_L_joint(blue, 0, {w=40, h=20, d=40, lw=20, _w=20}, {x=50, y=0, z=230})
	add_room(blue, {w=60, h=20, d=60}, {x=120, y=0, z=220}, {left={50}, front={50}})
	add_L_joint(blue, 90, {w=60, h=20, d=100, lw=20, _w=20}, {x=190, y=0, z=290})
	add_L_joint(blue, 0, {w=80, h=20, d=40, lw=20, _w=20}, {x=10, y=0, z=290})
	add_T_joint(blue, 270, {w=60, h=20, d=60, topw=20, stemw=20}, {x=20, y=0, z=220})
	add_wall(blue, 90, {w=20, h=20, d=6}, {x=-30, y=0, z=220})
	add_hallway(blue, 0, {w=20, h=20, d=20}, {x=20,y=0, z=180})
	add_wall(blue, 0, {w=20, h=20, d=6}, {x=20, y=0, z=150})
	add_ceilorfloor("floor", blue, 0, {w=20, h=20, d=6}, {x=0, y=0, z=0}, {x=20, y=0, z=160})	
	add_ceilorfloor("ceiling", blue, 0, {w=20, h=20, d=6}, {x=0, y=20, z=0}, {x=20, y=0, z=160})

--elseif total_frames == 120 then

	add_T_joint(blue, 180, {w=60, h=20, d=30, topw=20, stemw=20}, {x=-20, y=0, z=160})
	add_X_joint(blue, {w=40, h=20, d=40, cs1w=20, cs2w=20}, {x=-20, y=0, z=120})
	add_hallway(blue, 90, {w=20, h=20, d=40}, {x=-70,y=0, z=160})
	add_hallway(blue, 90, {w=20, h=20, d=30}, {x=-55,y=0, z=120})
	add_hallway(blue, 90, {w=20, h=20, d=30}, {x=15,y=0, z=120})
	add_wall(blue, 90, {w=20, h=20, d=6}, {x=-90, y=0, z=160})
	add_wall(blue, 90, {w=20, h=20, d=6}, {x=-70, y=0, z=120})
	add_wall(blue, 90, {w=20, h=20, d=6}, {x=-90, y=0, z=80})
	add_L_joint(blue, 180, {w=80, h=20, d=30, lw=20, _w=20}, {x=-10, y=0, z=70})
	add_room(blue, {w=60, h=20, d=60}, {x=60, y=0, z=100}, {left={10}, front={90}, right={90}, back={50}})
	add_wall(blue, 90, {w=20, h=20, d=6}, {x=30, y=0, z=105})
	add_T_joint(blue, 0, {w=60, h=20, d=80, topw=20, stemw=20}, {x=80, y=0, z=0})
	add_hallway(blue, 90, {w=20, h=20, d=20}, {x=120,y=0, z=0})
	add_room(blue, {w=60, h=20, d=60}, {x=160, y=0, z=20}, {left={90}, back={90}})
	add_room(blue, {w=100, h=20, d=100}, {x=0, y=0, z=0}, {left={50}, right={50}})
	add_L_joint(blue, 270, {w=200, h=20, d=110, lw=20, _w=40}, {x=-160, y=0, z=-10})
	add_room(blue, {w=180, h=40, d=180}, {x=-140, y=0, z=280}, {front={50}})
	add_wall(blue, 0, {w=10, h=20, d=6}, {x=-140, y=20, z=190})

	add_room2(blue, {w=10, h=20, d=10}, {x=-155, y=0, z=40}, {})
	add_room2(blue, {w=10, h=20, d=10}, {x=-155, y=0, z=80}, {})
	add_room2(blue, {w=10, h=20, d=10}, {x=-155, y=0, z=120}, {})
	add_room2(blue, {w=10, h=20, d=10}, {x=-125, y=0, z=40}, {})
	add_room2(blue, {w=10, h=20, d=10}, {x=-125, y=0, z=80}, {})
	add_room2(blue, {w=10, h=20, d=10}, {x=-125, y=0, z=120}, {})
end
end

function checkpoint_setup()
	checkpoints = {{pos={80, 10, 400}, size={140, 20, 140}};
				   {pos={280, 10, -180}, size={140, 20, 140}};
				  }
	make_checkpoints();
end

function make_checkpoints()
	for i=1,#checkpoints do
		checkpoints[i].entity = E.create_pivot();
		E.set_entity_geom_type(checkpoints[i].entity, E.geom_type_box, checkpoints[i].size[1], checkpoints[i].size[2], checkpoints[i].size[3])
		set_geom_attr(checkpoints[i].entity, {cat=cat_ckpt, col=cat_player_ckpt, res=0, cal=cat_player_ckpt})
		E.set_entity_position(checkpoints[i].entity, checkpoints[i].pos[1], checkpoints[i].pos[2], checkpoints[i].pos[3])
		E.parent_entity(checkpoints[i].entity, ckptgroup)
	end
end

function items_setup()
   _item.add_firstaidkit("small", {x=-335, y=0.5, z=-135})
   _item.add_firstaidkit("large", {x=80,  y=0.5, z=465})
   _item.add_firstaidkit("small", {x=-80, y=0.5, z=-260})
   _item.add_firstaidkit("large", {x=-260,  y=0.5, z=-360})
   _item.add_firstaidkit("small", {x=-660, y=0, z=-200})
   _item.add_firstaidkit("large", {x=-785, y=0, z=440})
   _item.add_firstaidkit("small", {x=-85, y=0, z=80})
   _item.add_firstaidkit("large", {x=-200, y=0, z=140})
   _item.add_firstaidkit("large", {x=705, y=0, z=780})
   _item.add_firstaidkit("small", {x=0, y=0, z=635})
   _item.add_firstaidkit("large", {x=-140, y=0, z=280})

   _item.add_saberenergykit("small", {x=665, y=0.5, z=-765})
   _item.add_saberenergykit("large", {x=-465,  y=0.5, z=-265})
   _item.add_saberenergykit("small", {x=-600, y=0.5, z=-1000})
   _item.add_saberenergykit("large", {x=275,  y=0.5, z=-800})
   _item.add_saberenergykit("small", {x=-25, y=0, z=220})
   _item.add_saberenergykit("large", {x=-85, y=0, z=160})
   _item.add_saberenergykit("small", {x=345, y=0, z=365})
   _item.add_saberenergykit("small", {x=215, y=0, z=365})
   _item.add_saberenergykit("large", {x=705, y=0, z=500})
   _item.add_saberenergykit("large", {x=0, y=0, z=645})
end

function final_objective_setup()
	make_final_objective({-140, 10, 280})
end
