PLAYER_LUA = true

player={
--[[STATES
	0 = interupted
	1 = explore
	2 = melee
--]]
stats ={dist_travelled=0,
		damage_taken=0,
		damage_dealt=0,
		enemies_killed=0,
		saber_energy_used=0,
		weapon_of_choice = {low=0, high=0, extreme=0}
},
consts={max_health=100,
		size = {x=4,
				y=6,
				z=2},
		walk_vel=-21,
		run_vel=-40,
		strafe_vel=25,
		rstrafe_vel=42,
		rot_speed=-75,
		spin_speed=-180,
		accel=70,
		periphery=5,
		melee_stop=8
},

create_entity = function (x, y, z)
	local lx = x or 0
	local ly = y or 3
	local lz = z or 0

	player.entity=_VP.create_virtual_pivot(playergroup)
	player.entity.hit_col=_VP.create_pivot(player.entity, {0,0,0},
											{type=E.geom_type_sphere, size={player.consts.size.x/2},
												attr={	cat=cat_player,
														col=cat_bullet,
														res=0,
														cal=cat_bullet}})
	player.entity.wall_col=_VP.create_pivot(player.entity, {0,0,0},
											{type=E.geom_type_sphere, size={player.consts.size.x/2},
												attr={	cat=cat_player_wall,
														col=cat_wall,
														res=0,
														cal=cat_wall}})
	player.entity.fak_col=_VP.create_pivot(player.entity, {0,0,0},
											{type=E.geom_type_box,
												size={player.consts.size.x, player.consts.size.y, player.consts.size.z},
												attr={	cat=cat_player_fak,
														col=cat_fak,
														res=0,
														cal=cat_fak}})
	player.entity.sek_col=_VP.create_pivot(player.entity, {0,0,0},
											{type=E.geom_type_box,
												size={player.consts.size.x, player.consts.size.y, player.consts.size.x},
												attr={	cat=cat_player_sek,
														col=cat_sek,
														res=0,
														cal=cat_sek}})
	player.entity.ckpt_col=_VP.create_pivot(player.entity, {0,0,0},
											{type=E.geom_type_sphere, size={player.consts.size.x/2},
												attr={	cat=cat_player_ckpt,
														col=cat_ckpt,
														res=0,
														cal=cat_ckpt}})
	player.entity.enemy_col=_VP.create_pivot(player.entity, {0,0,0},
											{type=E.geom_type_sphere,
												size={4},
												attr={	cat=cat_player_enemy,
														col=cat_player_enemy,
														res=0,
														cal=cat_player_enemy}})
	player.entity.finalobj_col=_VP.create_pivot(player.entity, {0,0,0},
											{type=E.geom_type_sphere, size={player.consts.size.x/2},
												attr={	cat=cat_player_finalobj,
														col=cat_final_obj,
														res=0,
														cal=cat_final_obj}})
	player.entity.fpv=_VP.attach_entity(player.entity, camera, {0,2,2})
	_VP.set_entity_position (player.entity, lx, ly, lz)
	player.health=player.consts.max_health
	player.state=1
	player.target={}
	player.turn=0
	player.vect={	z_max=0,
					x_max=0,
					z=0,
					x=0}
	player.weapon.create_entity()
	player.play_music(0)
	player.set_up_stat_strs()
end,

reset = function()
	player.health=player.consts.max_health
	player.weapon.energy = player.weapon.consts.max_energy
	player.state=1
end,

do_state = function (dt)
	_VP.refresh(player.entity)
	if #player.target==0 then player.play_music(0) else player.play_music(1) end
	if player.state==1 then player.explore(dt)
	elseif player.state==2 then player.melee(dt)
	end
end,

explore = function (dt)
	player.turn=0
	player.primary=nil
	if input.turn ~= 0 then
		if input.key.space then 	_VP.turn_entity(player.entity, 0, input.turn*player.consts.spin_speed*dt, 0)
		else 						_VP.turn_entity(player.entity, 0, input.turn*player.consts.rot_speed*dt, 0)
		end
	end
	if math.abs(input.x)<0.15 then input.x=0 end
	if math.abs(input.y)<0.15 then input.y=0 end
	if input.key.space then
		player.vect.z_max=input.y*player.consts.run_vel
		player.vect.x_max=input.x*player.consts.rstrafe_vel
	else
		player.vect.z_max=input.y*player.consts.walk_vel
		player.vect.x_max=input.x*player.consts.strafe_vel
	end
	if player.vect.z~=player.vect.z_max then
		if player.vect.z>player.vect.z_max then
			player.vect.z=player.vect.z-(player.consts.accel*dt)
			if player.vect.z<player.vect.z_max then player.vect.z=player.vect.z_max end
		else
			player.vect.z=player.vect.z+(player.consts.accel*dt)
			if player.vect.z>player.vect.z_max then player.vect.z=player.vect.z_max end
		end
	end
	if player.vect.x~=player.vect.x_max then
		if player.vect.x>player.vect.x_max then
			player.vect.x=player.vect.x-(player.consts.accel*dt)
			if player.vect.x<player.vect.x_max then player.vect.x=player.vect.x_max end
		else
			player.vect.x=player.vect.x+(player.consts.accel*dt)
			if player.vect.x>player.vect.x_max then player.vect.x=player.vect.x_max end
		end
	end
	if input.key.z then player.vect.z=80 end
	_VP.set_entity_position(player.entity, vector_position(player.vect.x*dt, 0, player.vect.z*dt, player.entity.pivot.vect, player.entity.pivot.pos))
	if #player.target~=0 then
		for i, v in pairs(player.target) do
			local dx=_enemy.enemies[v].pivot.pos[1]-player.entity.pivot.pos[1]
			local dz=_enemy.enemies[v].pivot.pos[3]-player.entity.pivot.pos[3]
			local dh=math.sqrt(dx^2+dz^2)
			local temp, ry, ty
			temp, ry=get_rotation(player.entity.pivot.vect)
			temp, ty=get_rotation({{0,0,0},{0,1,0},{-(dx/dh),0,-(dz/dh)}})
			temp=ty-ry
			if math.abs(temp)>180 then
				if temp>0 then temp=temp-360
				else temp=temp+360 end
			end
			if math.abs(temp)<=player.consts.periphery then
				player.primary=v
				break
			end
		end
		if input.key.c then
			player.state=2
			input.key.c=false
		end
	end
	player.weapon.do_state(dt)
end,

melee=function(dt)
	if #player.target==0 or input.key.c then
		input.key.c=false
		player.state=1
		player.explore(dt)
		return
	end
	player.primary=nil
	if math.abs(input.turn)>0.15 then
		if math.abs(input.turn)>math.abs(player.turn) or (input.turn<0 and player.turn>0) or (input.turn>0 and player.turn<0) then
			player.turn=input.turn
		end
		_VP.turn_entity(player.entity, 0, player.turn*player.consts.spin_speed*dt, 0)
		for i, v in pairs(player.target) do
			local dx=_enemy.enemies[v].pivot.pos[1]-player.entity.pivot.pos[1]
			local dz=_enemy.enemies[v].pivot.pos[3]-player.entity.pivot.pos[3]
			local dh=math.sqrt(dx^2+dz^2)
			local temp, ry, ty
			temp, ry=get_rotation(player.entity.pivot.vect)
			temp, ty=get_rotation({{0,0,0},{0,1,0},{-(dx/dh),0,-(dz/dh)}})
			temp=ty-ry
			if math.abs(temp)>180 then
				if temp>0 then temp=temp-360
				else temp=temp+360 end
			end
			if math.abs(temp)<=player.consts.periphery then
				player.primary=v
				break
			end
		end
	elseif player.turn~=0 then
		for i, v in pairs(player.target) do
			local dx=_enemy.enemies[v].pivot.pos[1]-player.entity.pivot.pos[1]
			local dz=_enemy.enemies[v].pivot.pos[3]-player.entity.pivot.pos[3]
			local dh=math.sqrt(dx^2+dz^2)
			local temp, ry, ty
			temp, ry=get_rotation(player.entity.pivot.vect)
			temp, ty=get_rotation({{0,0,0},{0,1,0},{-(dx/dh),0,-(dz/dh)}})
			temp=ty-ry
			if input.turn>0 then
				if temp>0 then temp=temp-360 end
			else
				if temp<0 then temp=temp+360 end
			end
			if math.abs(temp)<=math.abs(player.turn*player.consts.spin_speed*dt) then
				player.primary=v
				_VP.set_entity_rotation(player.entity, 0, ty, 0)
				player.turn=0
				break
			elseif math.abs(temp)<=player.consts.periphery then
				player.primary=v
				_VP.turn_entity(player.entity, 0, player.turn*player.consts.spin_speed*dt, 0)
				break
			end
		end
		if not player.primary then
			_VP.turn_entity(player.entity, 0, player.turn*player.consts.spin_speed*dt, 0)
		end
	else
		local npt=0
		local min_rot=181
		local dx=0
		local dz=0
		local dh=0
		for i, v in pairs(player.target) do
			dx=player.entity.pivot.pos[1]-_enemy.enemies[v].pivot.pos[1]
			dz=player.entity.pivot.pos[3]-_enemy.enemies[v].pivot.pos[3]
			dh=math.sqrt(dx^2+dz^2)
			local temp, ry, ty
			temp, ry=get_rotation(player.entity.pivot.vect)
			temp, ty=get_rotation({{0,0,0},{0,1,0},{(dx/dh),0,(dz/dh)}})
			temp=ty-ry
			if math.abs(temp)>180 then
				if temp>0 then temp=temp-360
				else temp=temp+360 end
			end
			if math.abs(temp)<=math.abs(player.consts.spin_speed*dt) then
				player.primary=v
				_VP.set_entity_rotation(player.entity, 0, ty, 0)
				break
			elseif math.abs(temp)<math.abs(min_rot) then
				min_rot=temp
				npt=v
			end
		end
		if player.primary then
			if math.abs(input.x)<0.15 then input.x=0 end
			if math.abs(input.y)<0.15 then input.y=0 end
			if input.key.space then
				player.vect.z_max=input.y*player.consts.run_vel
				player.vect.x_max=input.x*player.consts.rstrafe_vel
			else
				player.vect.z_max=input.y*player.consts.walk_vel
				player.vect.x_max=input.x*player.consts.strafe_vel
			end
			if player.vect.z_max<0 and dh+(player.vect.z_max*dt)<player.consts.melee_stop then player.vect.z_max=0 end
			if player.vect.z~=player.vect.z_max then
				if player.vect.z>player.vect.z_max then
					player.vect.z=player.vect.z-(player.consts.accel*dt)
					if player.vect.z<player.vect.z_max then player.vect.z=player.vect.z_max end
				else
					player.vect.z=player.vect.z+(player.consts.accel*dt)
					if player.vect.z>player.vect.z_max then player.vect.z=player.vect.z_max end
				end
			end
			if player.vect.x~=player.vect.x_max then
				if player.vect.x>player.vect.x_max then
					player.vect.x=player.vect.x-(player.consts.accel*dt)
					if player.vect.x<player.vect.x_max then player.vect.x=player.vect.x_max end
				else
					player.vect.x=player.vect.x+(player.consts.accel*dt)
					if player.vect.x>player.vect.x_max then player.vect.x=player.vect.x_max end
				end
			end
			if input.key.z then player.vect.z=80 end
			local rot=math.acos(dz/dh)
			if dx<0 then rot=-rot end
			rot=rot+(player.vect.x*dt)/dh
			dh=dh+(player.vect.z*dt)
			_VP.set_entity_position(player.entity, _enemy.enemies[player.primary].pivot.pos[1]+(math.sin(rot)*dh),
				player.entity.pivot.pos[2], _enemy.enemies[player.primary].pivot.pos[3]+(math.cos(rot)*dh))
			_VP.set_entity_rotation(player.entity, 0, math.deg(rot), 0)
		else
			if min_rot>0 then _VP.turn_entity(player.entity, 0, -player.consts.spin_speed*dt, 0)
			else _VP.turn_entity(player.entity, 0, player.consts.spin_speed*dt, 0)
			end
			if math.abs(min_rot)<=player.consts.periphery then player.primary=npt end
		end
	end
	player.weapon.do_state(dt)
end,

hit = function (damage)
	if game.state == game_state.play then
		if total_dt<player.weapon.defense.d_time then
			E.play_sound(sound_player_defend)
		else
			E.play_sound(sound_player_hit)
		end
	end
	if total_dt<player.weapon.defense.d_time then
		E.set_entity_flags(player.entity.enemy_col.entity, E.entity_flag_visible_geom, true)
	else
		if player.health > damage then
			player.health = player.health - damage
			player.update_stat("damage_taken", damage)
		else
			E.play_sound(sound_player_killed)
			-- hack: in future, get rid of if statement
			if game.state == game.states.play then
				game.state = game.states.death_overlay_fall_setup
			end
		end
	end
end,

recover_health = function (recover)
	if player.health < player.consts.max_health then
		player.health = player.health + recover
		if player.health>player.consts.max_health then
			player.health=player.consts.max_health
		end
		return true
	else
		return false
	end
end,

get_health_color = function ()
   return (100-player.health)/100, player.health/100, player.health/50, 1.0
end,

set_up_stat_strs = function()
	player.stat_strs = {}
	player.stat_str_brush = E.create_brush()
	player.stat_strs_pos = {{-0.6, 1.460, 0.12},
							{-0.6, 1.405, 0.12},
							{-0.6, 1.350, 0.12},
							{ 0.2, 1.460, 0.12},
							{ 0.2, 1.405, 0.12},
							{ 0.2, 1.350, 0.12}}
	local pos_count=1
	E.set_typeface(player_stats_font)
	for i,v in pairs(player.stats) do
		player.stat_strs[i] = E.create_string("")
		E.set_string_fill(player.stat_strs[i], player.stat_str_brush)
		E.set_entity_scale(player.stat_strs[i], 0.03, 0.03, 0.03)
		player.entity["stat_str_"..i] = _VP.attach_entity(player.entity, player.stat_strs[i], player.stat_strs_pos[pos_count])
		E.set_entity_flags(player.stat_strs[i], E.entity_flag_hidden, true)
		E.parent_entity(player.stat_strs[i], stringgroup)
		pos_count = pos_count + 1
	end
	E.set_brush_color(player.stat_str_brush, 1.0, 1.0, 1.0, 0.75)
	E.set_brush_flags(player.stat_str_brush, E.brush_flag_unlit, true)
end,

update_stat = function(stat, amount)
	if 	   stat == "dist_travelled" then			player.stats.dist_travelled = player.stats.dist_travelled + amount
	elseif stat == "damage_taken" then				player.stats.damage_taken = player.stats.damage_taken + amount
	elseif stat == "damage_dealt" then				player.stats.damage_dealt = player.stats.damage_dealt + amount
	elseif stat == "enemies_killed" then			player.stats.enemies_killed = player.stats.enemies_killed + amount
	elseif stat == "saber_energy_used" then			player.stats.saber_energy_used = player.stats.saber_energy_used + amount
	elseif stat == "weapon_of_choice low" then		player.stats.weapon_of_choice.low = player.stats.weapon_of_choice.low + amount
	elseif stat == "weapon_of_choice high" then		player.stats.weapon_of_choice.high = player.stats.weapon_of_choice.high + amount
	elseif stat == "weapon_of_choice extreme" then	player.stats.weapon_of_choice.extreme = player.stats.weapon_of_choice.extreme + amount
	end
end,

reset_stats = function()
	player.stats.dist_travelled=0
	player.stats.damage_taken=0
	player.stats.damage_dealt=0
	player.stats.enemies_killed=0
	player.stats.saber_energy_used=0
	player.stats.weapon_of_choice.low=0
	player.stats.weapon_of_choice.high=0
	player.stats.weapon_of_choice.extreme=0
end,

display_all_stats = function()
	local woc_l = player.stats.weapon_of_choice.low
	local woc_h = player.stats.weapon_of_choice.high
	local woc_e = player.stats.weapon_of_choice.extreme
	local woc = (woc_l>woc_h and ((woc_l>woc_e and "Low") or "Extreme")) or ((woc_h>woc_e and "High") or "Extreme")
	E.set_string_text(player.stat_strs.dist_travelled, "Distance Travelled:  "..tostring(math.floor(player.stats.dist_travelled*10)/10))
	E.set_string_text(player.stat_strs.damage_taken, "Damage Taken:   "..tostring(math.floor(player.stats.damage_taken)))
	E.set_string_text(player.stat_strs.damage_dealt, "Damage Dealt:         "..tostring(math.floor(player.stats.damage_dealt)))
	E.set_string_text(player.stat_strs.enemies_killed, "Enemies Killed:         "..tostring(player.stats.enemies_killed))
	E.set_string_text(player.stat_strs.saber_energy_used, "Saber Energy Used: "..tostring(player.stats.saber_energy_used))
	if woc_l==0 and woc_h==0 and woc_e==0 then	E.set_string_text(player.stat_strs.weapon_of_choice, "Weapon of Choice: None")
	else										E.set_string_text(player.stat_strs.weapon_of_choice, "Weapon of Choice: "..woc.." Power Shot")
	end
	for i,v in pairs(player.stat_strs) do
		E.set_entity_flags(player.stat_strs[i], E.entity_flag_hidden, false)
	end
end,

hide_all_stats = function()
	for i,v in pairs(player.stat_strs) do
		E.set_entity_flags(player.stat_strs[i], E.entity_flag_hidden, true)
	end
end,

play_music = function(music)
	if music == 1 then return end
	if player.music ~= music then
		if music == 0 then
			E.set_sound_amplitude(music_explore, .4)
			E.loop_sound(music_explore)
			player.music=0
		else
			E.set_sound_amplitude(music_melee, .5)
			E.loop_sound(music_melee)
			player.music=1
		end
	end
end,

god_mode = function()
	player.consts.max_health = 10000
	player.health = 10000
end,


weapon={
--[[
SECTORS
	top center = 1
	top right = 2
	center right = 3
	bottom right = 4
	bottom center = 5
	bottom left = 6
	center left = 7
	top left = 8
--]]
consts={max_energy = 100,
		energy_rec = 3.2,
		scale = {0.7, 1.9, 0.7},
		geom={	type=E.geom_type_box,
				size={3, 3, 3},
				attr={	cat=cat_weapon,
						col=cat_enemy+cat_bullet,
						res=0,
						cal=cat_enemy+cat_bullet}},
		saber_scale={0.5,1.7,1.7},
		arm_scale={0.5, 0.5, 0.5},
		aura={	counter = 0,
				delay = 0,
				scale_step = 0.011,
				scale_limit = 1.09},
		dtime=1
},

create_entity = function ()
	player.entity.weapon = _VP.create_pivot(player.entity, {0,0,0}, player.weapon.consts.geom)

	player.weapon.arm= E.create_object(player_arm_file)
	player.weapon.saber	= E.create_object(saber_file)
	E.parent_entity(player.weapon.arm,player.entity.weapon.entity)
	E.parent_entity(player.weapon.saber, player.entity.weapon.entity)
	E.set_entity_scale(player.weapon.arm, player.weapon.consts.arm_scale[1], player.weapon.consts.arm_scale[2], player.weapon.consts.arm_scale[3])
	E.set_entity_scale(player.weapon.saber,	player.weapon.consts.saber_scale[1], player.weapon.consts.saber_scale[2], player.weapon.consts.saber_scale[3])

	player.weapon.arm_brush = E.create_brush()
	E.set_mesh(player.weapon.arm, 0, player.weapon.arm_brush)

	player.weapon.saber_brush = E.get_mesh(player.weapon.saber, 0)
	E.set_brush_flags(player.weapon.saber_brush, E.brush_flag_unlit, true)

	player.weapon.auras = {}
	local pwca = player.weapon.consts.aura
	pwca.alpha_step = pwca.scale_step / (pwca.scale_limit - 1)
	
	player.weapon.energy=player.weapon.consts.max_energy
	
	player.weapon.aura_obj = E.create_object(saber_file)
	E.parent_entity(player.weapon.aura_obj, clone_basegroup)
	E.set_entity_position(player.weapon.aura_obj, 0, -50, 0)

	player.weapon.state=1
	player.weapon.strike={	start=0, --[[strike starting sector--]]
							speed=0,
							target=0}
	player.weapon.defense={	sector=0,
							d_time=0}
	player.weapon.lx=1
	player.weapon.ly=1
end,

do_state=function(dt)
	if player.weapon.state==1 then player.weapon.idle(dt)
	elseif player.weapon.state==2 then player.weapon.attack(dt)
	elseif player.weapon.state==3 then player.weapon.animate_strike(dt)
	end
	player.weapon.recharge(dt)
	E.set_brush_color(player.weapon.arm_brush, player.get_health_color())
	player.weapon.show_energy()
	player.weapon.show_aura()
end,

show_aura = function()
	player.weapon.add_aura()
	table.foreach(player.weapon.auras, player.weapon.step_aura)
end,

add_aura = function()
	local aura = {}
	aura.entity = E.create_clone(player.weapon.aura_obj)
	E.set_entity_scale(aura.entity, player.weapon.consts.saber_scale[1], player.weapon.consts.saber_scale[2], player.weapon.consts.saber_scale[3])
	_VP.attach_entity(player.entity, aura.entity, player.entity.weapon.pos, player.entity.weapon.rot)
	E.set_entity_alpha(aura.entity, 1.0)

	aura.scale = 1
	aura.alpha = 1.0
	E.parent_entity(aura.entity, playergroup)

	table.insert(player.weapon.auras, aura)
end,

step_aura = function(id, aura)
	local consts = player.weapon.consts
	aura.scale = aura.scale + consts.aura.scale_step
	if aura.scale < consts.aura.scale_limit then
		E.set_entity_scale(aura.entity, consts.saber_scale[1]*aura.scale, consts.saber_scale[2]*aura.scale,	consts.saber_scale[3]*aura.scale)
		aura.alpha = aura.alpha - consts.aura.alpha_step
		E.set_entity_alpha(aura.entity, aura.alpha)
	else
		player.weapon.del_aura(id, aura)
	end
end,

del_aura = function(id, aura)
	E.delete_entity(aura.entity)
	table.remove(player.weapon.auras, id)
end,

set_position_rotation=function()
	local x=qp-player.weapon.lx*qp-0.01
	local y=-qp+player.weapon.ly*qp+0.01
	local z=math.sqrt(1-x^2-y^2)
	player.entity.weapon.rot[1], player.entity.weapon.rot[2]=get_rotation({{0,0,0},{0,0,0},{x,y,z}})
	player.entity.weapon.rot[3]=90*(player.weapon.ly-1)
	player.entity.weapon.pos[1]=-1.2+player.weapon.lx*2.8
	player.entity.weapon.pos[2]=2.7-player.weapon.ly*1.8
	player.entity.weapon.pos[3]=-2+math.abs(player.entity.weapon.pos[1])/3+math.abs(player.entity.weapon.pos[2]-2)/2
end,

idle = function (dt)
	local cx=input.curs.px/800
	local cy=input.curs.py/600
	local dx=cx-player.weapon.lx
	local dz=cy-player.weapon.ly
	local dh=math.sqrt(dx^2+dz^2)
	if dh<=2*dt then
		player.weapon.lx=cx
		player.weapon.ly=cy
	else
		player.weapon.lx=player.weapon.lx+(dx/dh)*2*dt
		player.weapon.ly=player.weapon.ly+(dz/dh)*2*dt
	end
	if input.curs.click then player.weapon.state=2 end
	player.weapon.set_position_rotation()
end,

attack=function(dt)
	local target
	if not input.curs.click then
		if player.weapon.defense.d_time~=0 then
			player.weapon.defense={sector=0, d_time=0}
			E.set_entity_flags(player.entity.enemy_col.entity, E.entity_flag_visible_geom, false)
		end
		player.weapon.strike={start=0, speed=0, target=0}
		player.weapon.state=1
		player.weapon.idle(dt)
		return
	elseif player.weapon.lx<0.2 then
		if player.weapon.ly<0.2 then
			if player.weapon.defense.d_time==0 or player.weapon.defense.sector~=8 then
				player.weapon.defense.d_time=total_dt+player.weapon.consts.dtime
				player.weapon.defense.sector=8
			elseif player.weapon.defense.d_time<total_dt then
				E.set_entity_flags(player.entity.enemy_col.entity, E.entity_flag_visible_geom, false)
			end
			player.weapon.strike.start=8
			if input.key.u then target=0
			elseif input.key.i then target=1
			elseif input.key.o then target=2
			elseif input.key.j then target=0
			elseif input.key.l then target=2
			elseif input.key.n then target=4
			elseif input.key.m then target=4
			elseif input.key.comma then target=4
			else target=0
			end
		elseif player.weapon.ly>0.4 and player.weapon.ly<0.6 then
			if player.weapon.defense.d_time==0 or player.weapon.defense.sector~=7 then
				player.weapon.defense.d_time=total_dt+player.weapon.consts.dtime
				player.weapon.defense.sector=7
			elseif player.weapon.defense.d_time<total_dt then
				E.set_entity_flags(player.entity.enemy_col.entity, E.entity_flag_visible_geom, false)
			end
			player.weapon.strike.start=7
			if input.key.u then target=8
			elseif input.key.i then target=1
			elseif input.key.o then target=2
			elseif input.key.j then target=0
			elseif input.key.l then target=3
			elseif input.key.n then target=6
			elseif input.key.m then target=6
			elseif input.key.comma then target=5
			else target=0
			end
		elseif player.weapon.ly>0.8 then
			if player.weapon.defense.d_time==0 or player.weapon.defense.sector~=6 then
				player.weapon.defense.d_time=total_dt+player.weapon.consts.dtime
				player.weapon.defense.sector=6
			elseif player.weapon.defense.d_time<total_dt then
				E.set_entity_flags(player.entity.enemy_col.entity, E.entity_flag_visible_geom, false)
			end
			player.weapon.strike.start=6
			if input.key.u then target=8
			elseif input.key.i then target=1
			elseif input.key.o then target=2
			elseif input.key.j then target=0
			elseif input.key.l then target=4
			elseif input.key.n then target=0
			elseif input.key.m then target=0
			elseif input.key.comma then target=5
			else target=0
			end
		else
			if player.weapon.defense.d_time~=0 then
				player.weapon.defense={sector=0, d_time=0}
				E.set_entity_flags(player.entity.enemy_col.entity, E.entity_flag_visible_geom, false)
			end
			if input.key.u then target=8
			elseif input.key.i then target=1
			elseif input.key.o then target=2
			elseif input.key.j then target=0
			elseif input.key.l then target=3
			elseif input.key.n then target=6
			elseif input.key.m then target=6
			elseif input.key.comma then target=5
			else target=0
			end
		end
	elseif player.weapon.lx>0.4 and player.weapon.lx<0.6 then
		if player.weapon.ly<0.2 then
			if player.weapon.defense.d_time==0 or player.weapon.defense.sector~=1 then
				player.weapon.defense.d_time=total_dt+player.weapon.consts.dtime
				player.weapon.defense.sector=1
			elseif player.weapon.defense.d_time<total_dt then
				E.set_entity_flags(player.entity.enemy_col.entity, E.entity_flag_visible_geom, false)
			end
			player.weapon.strike.start=1
			if input.key.u then target=8
			elseif input.key.i then target=0
			elseif input.key.o then target=2
			elseif input.key.j then target=8
			elseif input.key.l then target=2
			elseif input.key.n then target=5
			elseif input.key.m then target=5
			elseif input.key.comma then target=5
			else target=0
			end
		elseif player.weapon.ly>0.4 and player.weapon.ly<0.6 then
			if player.weapon.defense.d_time~=0 then
				player.weapon.defense={sector=0, d_time=0}
				E.set_entity_flags(player.entity.enemy_col.entity, E.entity_flag_visible_geom, false)
			end
			if player.weapon.strike.start~=0 then
				target=0
				if player.primary then
					if player.weapon.strike.start==8 or player.weapon.strike.start==1 or player.weapon.strike.start==2
						or player.weapon.strike.start==7 or player.weapon.strike.start==3 then
						_enemy.enemies[player.primary].pivot.damage_taken=2*player.weapon.strike.speed+10
						_enemy.change_state(_enemy.enemies[player.primary], _enemy.states.hit)
						input.curs.click=false
						player.weapon.state=3
					end
				elseif player.weapon.strike.start==8 then
					_sslash.add(1, player.weapon.strike.speed)
					input.curs.click=false
					player.weapon.state=3
				elseif player.weapon.strike.start==1 then
					_sslash.add(3, player.weapon.strike.speed)
					input.curs.click=false
					player.weapon.state=3
				elseif player.weapon.strike.start==2 then
					_sslash.add(2, player.weapon.strike.speed)
					input.curs.click=false
					player.weapon.state=3
				end
			elseif input.key.u then target=8
			elseif input.key.i then target=1
			elseif input.key.o then target=2
			elseif input.key.j then target=7
			elseif input.key.l then target=3
			elseif input.key.n then target=6
			elseif input.key.m then target=5
			elseif input.key.comma then target=4
			else target=0
			end
		elseif player.weapon.ly>0.8 then
			if player.weapon.defense.d_time==0 or player.weapon.defense.sector~=5 then
				player.weapon.defense.d_time=total_dt+player.weapon.consts.dtime
				player.weapon.defense.sector=5
			elseif player.weapon.defense.d_time<total_dt then
				E.set_entity_flags(player.entity.enemy_col.entity, E.entity_flag_visible_geom, false)
			end
			player.weapon.strike.start=5
			if input.key.u then target=8
			elseif input.key.i then target=1
			elseif input.key.o then target=2
			elseif input.key.j then target=6
			elseif input.key.l then target=4
			elseif input.key.n then target=6
			elseif input.key.m then target=0
			elseif input.key.comma then target=4
			else target=0
			end
		else
			if player.weapon.defense.d_time~=0 then
				player.weapon.defense={sector=0, d_time=0}
				E.set_entity_flags(player.entity.enemy_col.entity, E.entity_flag_visible_geom, false)
			end
			if input.key.u then target=8
			elseif input.key.i then target=1
			elseif input.key.o then target=2
			elseif input.key.j then target=7
			elseif input.key.l then target=3
			elseif input.key.n then target=6
			elseif input.key.m then target=5
			elseif input.key.comma then target=4
			else target=0
			end
		end
	elseif player.weapon.lx>0.8 then
		if player.weapon.ly<0.2 then
			if player.weapon.defense.d_time==0 or player.weapon.defense.sector~=2 then
				player.weapon.defense.d_time=total_dt+player.weapon.consts.dtime
				player.weapon.defense.sector=2
			elseif player.weapon.defense.d_time<total_dt then
				E.set_entity_flags(player.entity.enemy_col.entity, E.entity_flag_visible_geom, false)
			end
			player.weapon.strike.start=2
			if input.key.u then target=8
			elseif input.key.i then target=1
			elseif input.key.o then target=0
			elseif input.key.j then target=8
			elseif input.key.l then target=0
			elseif input.key.n then target=6
			elseif input.key.m then target=6
			elseif input.key.comma then target=6
			else target=0
			end
		elseif player.weapon.ly>0.4 and player.weapon.ly<0.6 then
			if player.weapon.defense.d_time==0 or player.weapon.defense.sector~=3 then
				player.weapon.defense.d_time=total_dt+player.weapon.consts.dtime
				player.weapon.defense.sector=3
			elseif player.weapon.defense.d_time<total_dt then
				E.set_entity_flags(player.entity.enemy_col.entity, E.entity_flag_visible_geom, false)
			end
			player.weapon.strike.start=3
			if input.key.u then target=8
			elseif input.key.i then target=1
			elseif input.key.o then target=2
			elseif input.key.j then target=7
			elseif input.key.l then target=0
			elseif input.key.n then target=5
			elseif input.key.m then target=4
			elseif input.key.comma then target=4
			else target=0
			end
		elseif player.weapon.ly>0.8 then
			if player.weapon.defense.d_time==0 or player.weapon.defense.sector~=4 then
				player.weapon.defense.d_time=total_dt+player.weapon.consts.dtime
				player.weapon.defense.sector=4
			elseif player.weapon.defense.d_time<total_dt then
				E.set_entity_flags(player.entity.enemy_col.entity, E.entity_flag_visible_geom, false)
			end
			player.weapon.strike.start=4
			if input.key.u then target=8
			elseif input.key.i then target=1
			elseif input.key.o then target=2
			elseif input.key.j then target=6
			elseif input.key.l then target=0
			elseif input.key.n then target=5
			elseif input.key.m then target=0
			elseif input.key.comma then target=0
			else target=0
			end
		else
			if player.weapon.defense.d_time~=0 then
				player.weapon.defense={sector=0, d_time=0}
				E.set_entity_flags(player.entity.enemy_col.entity, E.entity_flag_visible_geom, false)
			end
			if input.key.u then target=8
			elseif input.key.i then target=1
			elseif input.key.o then target=2
			elseif input.key.j then target=7
			elseif input.key.l then target=0
			elseif input.key.n then target=5
			elseif input.key.m then target=4
			elseif input.key.comma then target=4
			else target=0
			end
		end
	else
		if player.weapon.defense.d_time~=0 then
			player.weapon.defense={sector=0, d_time=0}
			E.set_entity_flags(player.entity.enemy_col.entity, E.entity_flag_visible_geom, false)
		end
		if input.key.u then target=8
		elseif input.key.i then target=1
		elseif input.key.o then target=2
		elseif input.key.j then target=7
		elseif input.key.l then target=3
		elseif input.key.n then target=6
		elseif input.key.m then target=5
		elseif input.key.comma then target=4
		else target=0
		end
	end
	if target~=0 then
		local speed
		if input.num[1] then speed=0.46
		elseif input.num[2] then speed=0.52
		elseif input.num[3] then speed=0.58
		elseif input.num[4] then speed=0.64
		elseif input.num[5] then speed=0.70
		elseif input.num[6] then speed=0.76
		elseif input.num[7] then speed=0.82
		elseif input.num[8] then speed=0.88
		elseif input.num[9] then speed=0.94
		elseif input.num[0] then speed=1
		else speed=0
		end
		if target==player.weapon.strike.target then
			if player.weapon.strike.speed<speed then player.weapon.strike.speed=speed end
		elseif player.weapon.strike.target==0 then
			player.weapon.strike.target=target
			player.weapon.strike.speed=speed
		elseif target==math.mod(player.weapon.strike.start+3, 8)+1 then
			player.weapon.strike.target=target
			if player.weapon.strike.speed<speed then player.weapon.strike.speed=speed end
		end
	end
	if player.weapon.animate(dt) then player.weapon.strike={start=0, speed=0, target=0} end
end,

animate_strike=function(dt)
	if player.weapon.animate(dt) then player.weapon.state=1 end
end,

animate=function(dt)
	local tx, ty
	if player.weapon.strike.target==0 then return true
	elseif player.weapon.strike.target==1 then
		tx=0.5
		ty=0.1
	elseif player.weapon.strike.target==2 then
		tx=0.9
		ty=0.1
	elseif player.weapon.strike.target==3 then
		tx=0.9
		ty=0.5
	elseif player.weapon.strike.target==4 then
		tx=0.9
		ty=0.9
	elseif player.weapon.strike.target==5 then
		tx=0.5
		ty=0.9
	elseif player.weapon.strike.target==6 then
		tx=0.1
		ty=0.9
	elseif player.weapon.strike.target==7 then
		tx=0.1
		ty=0.5
	elseif player.weapon.strike.target==8 then
		tx=0.1
		ty=0.1
	end
	local dx=tx-player.weapon.lx
	local dz=ty-player.weapon.ly
	local dh=math.sqrt(dx^2+dz^2)
	if dh<7*player.weapon.strike.speed*dt then
		player.weapon.lx=tx
		player.weapon.ly=ty
		player.weapon.set_position_rotation()
		player.weapon.strike={start=0, speed=0, target=0}
		return true
	else
		player.weapon.lx=player.weapon.lx+(dx/dh)*7*player.weapon.strike.speed*dt
		player.weapon.ly=player.weapon.ly+(dz/dh)*7*player.weapon.strike.speed*dt
		player.weapon.set_position_rotation()
		--code to set rotation  to direction of strike
		return false
	end
end,


inc_energy = function (inc)
	player.weapon.consts.max_energy = player.weapon.consts.max_energy + inc
	player.weapon.energy = player.weapon.consts.max_energy
end,

recharge = function (dt)
	player.weapon.energy=player.weapon.energy+player.weapon.consts.energy_rec*dt
	player.health = player.health+.32*dt
	if player.health > player.consts.max_health then player.health = player.consts.max_health end
	if player.weapon.energy>player.weapon.consts.max_energy then player.weapon.energy=player.weapon.consts.max_energy end
	player.weapon.show_energy()
end,

show_energy = function ()
--	local wce = player.weapon.energy/player.weapon.consts.max_energy
	if player.weapon.energy <= 100 then
		local wce = player.weapon.energy/100
		E.set_brush_color(player.weapon.saber_brush, 1 - wce, wce, 0.0, 1.0)
	else
		local wce = (player.weapon.energy-100)/100
		E.set_brush_color(player.weapon.saber_brush, 0.0, 1 - wce, wce, 1.0)
	end
end
}}