if not FUNC_LUA then dofile("func.lua") end

ROOMS_LUA = true

doorway_width = 10
gen_wall_depth = 10

function make_walltypes()
	local wall_type = {}
	wall_type.green  = E.create_object(wall_file)
	wall_type.blue   = E.create_object(wall_file)
	wall_type.red 	 = E.create_object(wall_file)
	wall_type.yellow = E.create_object(wall_file)
	wall_type.white  = E.create_object(wall_file)
	
	E.parent_entity(wall_type.green, clone_basegroup)
	E.parent_entity(wall_type.blue, clone_basegroup)
	E.parent_entity(wall_type.red, clone_basegroup)
	E.parent_entity(wall_type.yellow, clone_basegroup)
	E.parent_entity(wall_type.white, clone_basegroup)
	
	-- wall_type.greenbrush  = {}
	-- wall_type.bluebrush   = {}
	-- wall_type.redbrush    = {}
	-- wall_type.yellowbrush = {}
	-- wall_type.whitebrush  = {}
	
	-- for i=0,E.get_mesh_count(wall_type.blue) do
		-- make_wall_brush(wall_type, "green",i)
		-- make_wall_brush(wall_type, "blue",i)
		-- make_wall_brush(wall_type, "red",i)
		-- make_wall_brush(wall_type, "yellow",i)
		-- make_wall_brush(wall_type, "white",i)
	-- end

	return wall_type
end
function make_wall_brush(wall_type,walltype,i)
	wall_type[walltype.."brush"][i] = E.create_brush()
	E.set_mesh(wall_type[walltype], i, wall_type[walltype.."brush"][i])
	E.set_brush_image(wall_type[walltype.."brush"][i], E.create_image(wall_texture_files[walltype]))
	E.set_brush_flags(wall_type[walltype.."brush"][i], E.brush_flag_unlit+E.brush_flag_sky_map_0, true)
end
function add_wall(walltexture, rot_amount, scale, pos, adjusted_pos, decor, sprite_offset, struct_rot)
	local wall = {}

	wall.type = "innerwall"
	wall.texture = walltexture

	wall.entity = E.create_clone(walltexture)

	if not walk_thru_walls then
	  local minx, miny, minz, maxx, maxy, maxz = E.get_entity_bound(wall.entity)
	  E.set_entity_geom_type(wall.entity, E.geom_type_box, (maxx-minx)*scale.w, (maxy-miny)*scale.h, (maxz-minz)*scale.d)
	  set_geom_attr(wall.entity, {cat=cat_wall, 
								  col=cat_player_wall + cat_sslash + cat_enemy_frame,
								  res=0, 
								  cal=cat_player_wall + cat_sslash + cat_enemy_frame,
								  mas=75, bou=0.01, fri=10})
	end

	E.set_entity_scale(wall.entity, scale.w, scale.h, scale.d)  -- w=width, h=height, d=depth  --easier to envision then x, y, z
	E.set_entity_rotation(wall.entity, 0, rot_amount, 0)
	if adjusted_pos then
	  E.set_entity_position(wall.entity, adjusted_pos.x + pos.x, adjusted_pos.y + pos.y+(scale.h/2), adjusted_pos.z + pos.z)
	else
	  E.set_entity_position(wall.entity, pos.x, pos.y+(scale.h/2), pos.z)
	end

	if decor and decor.spec then
	  local x, y, z = E.get_entity_position(wall.entity)
	  local ap = decor.calc.adjpos
	  local ar = decor.calc.adjrot
	  create_image_sprite(decor.spec[1], {rx=0, ry=rot_amount+ar, rz=0}, decor.spec[3] or .1, {x = x+ap.x, y = y+ap.y, z = z+ap.z}, false)
	end
	
	--wall texture
	if wall_sprites then
		local x,y,z
		if adjusted_pos then
		  x=adjusted_pos.x + pos.x
		  y=adjusted_pos.y + pos.y+(scale.h/2)
		  z=adjusted_pos.z + pos.z
		else
		  x=pos.x
		  y=pos.y+(scale.h/2)
		  z=pos.z
		end
		local sprite_file
		if wall.texture == wall_types.red then			sprite_file = wall_texture_files.red
		elseif wall.texture == wall_types.green then	sprite_file = wall_texture_files.green
		elseif wall.texture == wall_types.blue then		sprite_file = wall_texture_files.blue
		elseif wall.texture == wall_types.yellow then	sprite_file = wall_texture_files.yellow
		elseif wall.texture == wall_types.white then	sprite_file = wall_texture_files.white
		end
		-- calc offset and rotation
		local closeness = 0.6
		local scale_adj = 50
		if sprite_offset == nil then
			if rot_amount==0 or rot_amount==180 or rot_amount==360 then
				sprite_texture_1 = create_image_sprite(sprite_file, {rx=0, ry=0, rz=0}, 1, {x=x, y=y, z=z+closeness}, false, walldecorgroup, false)
				sprite_texture_2 = create_image_sprite(sprite_file, {rx=0, ry=180, rz=0}, 1, {x=x, y=y, z=z-closeness}, false, walldecorgroup, false)
			else
				sprite_texture_1 = create_image_sprite(sprite_file, {rx=0, ry=90, rz=0}, 1, {x=x+closeness, y=y, z=z}, false, walldecorgroup, false)
				sprite_texture_2 = create_image_sprite(sprite_file, {rx=0, ry=270, rz=0}, 1, {x=x-closeness, y=y, z=z}, false, walldecorgroup, false)
			end
			E.set_entity_scale(sprite_texture_1, scale.w/128, scale.h/128, 1)
			E.set_entity_scale(sprite_texture_2, scale.w/128, scale.h/128, 1)
			E.set_sprite_range(sprite_texture_1, 0, scale.w/scale_adj, 0, scale.h/scale_adj)
			E.set_sprite_range(sprite_texture_2, 0, scale.w/scale_adj, 0, scale.h/scale_adj)
		else
			local spr_rot_amount=0
			struct_rot = struct_rot or 0
			if sprite_offset == "+z" then
				if 		struct_rot==  0 or struct_rot==360 then z=z+closeness
				elseif	struct_rot== 90 then x=x+closeness
				elseif 	struct_rot==180 then z=z-closeness
				elseif 	struct_rot==270 then x=x-closeness
				end
				spr_rot_amount=struct_rot
			elseif	sprite_offset == "-z" then
				if 		struct_rot==  0 or struct_rot==360 then z=z-closeness
				elseif	struct_rot== 90 then x=x-closeness
				elseif 	struct_rot==180 then z=z+closeness
				elseif 	struct_rot==270 then x=x+closeness
				end
				spr_rot_amount=180+struct_rot
			elseif	sprite_offset == "+x" then
				if 		struct_rot==  0 or struct_rot==360 then x=x+closeness
				elseif	struct_rot== 90 then z=z-closeness
				elseif 	struct_rot==180 then x=x-closeness
				elseif 	struct_rot==270 then z=z+closeness
				end
				spr_rot_amount=90+struct_rot
			elseif	sprite_offset == "-x" then
				if 		struct_rot==  0 or struct_rot==360 then x=x-closeness
				elseif	struct_rot== 90 then z=z+closeness
				elseif 	struct_rot==180 then x=x+closeness
				elseif 	struct_rot==270 then z=z-closeness
				end
				spr_rot_amount=-90+struct_rot
			end
			sprite_texture = create_image_sprite(sprite_file, {rx=0, ry=spr_rot_amount, rz=0}, 1, {x=x, y=y, z=z}, false, walldecorgroup, false)
			E.set_entity_scale(sprite_texture, scale.w/128, scale.h/128, 1)
			E.set_sprite_range(sprite_texture, 0, scale.w/scale_adj, 0, scale.h/scale_adj)
		end
	end
	
	E.parent_entity(wall.entity, wallgroup)

	table.insert(walls, wall)

	return wall.entity
end
function add_ceilorfloor(walltype, walltexture, rot_amount, scale, pos, adjusted_pos, decor, sprite_offset, struct_rot)
	local wall = {}

	wall.texture = walltexture

	wall.entity = E.create_clone(walltexture)
						 
	E.set_entity_scale(wall.entity, scale.w, scale.h, scale.d)
	E.set_entity_rotation(wall.entity, 90, 0, rot_amount)
	if adjusted_pos then
		E.set_entity_position(wall.entity, adjusted_pos.x + pos.x, adjusted_pos.y + pos.y, adjusted_pos.z + pos.z)
	else
		E.set_entity_position(wall.entity, pos.x, pos.y, pos.z)
	end

	if walltype == "floor" then
		wall.type = "floor"
		local minx, miny, minz, maxx, maxy, maxz = E.get_entity_bound(wall.entity)
		E.set_entity_geom_type(wall.entity, E.geom_type_box, (maxx-minx)*scale.w, (maxy-miny)*scale.h, (maxz-minz)*scale.d)
		set_geom_attr(wall.entity, {cat=cat_floor, 
								  col=cat_enemy_frame,
								  res=cat_enemy_frame, 
								  cal=0, 
								  mas=75, bou=0.01, fri=10})
		if decor and decor.spec then
			local x, y, z = E.get_entity_position(wall.entity)
			local ap = decor.calc.adjpos
			local ar = decor.calc.adjrot
			create_image_sprite(decor.spec[1], {rx=-90, ry=0, rz=rot_amount+ar}, decor.spec[3] or .1, {x=x+ap.x, y=y+ap.y, z=z+ap.z}, false)
		end
	elseif walltype == "ceiling" then
		wall.type = "ceiling"
		if decor and decor.spec then
			local x, y, z = E.get_entity_position(wall.entity)
			local ap = decor.calc.adjpos
			local ar = decor.calc.adjrot
			create_image_sprite(decor.spec[1], {rx=90, ry=0, rz=rot_amount+ar}, decor.spec[3] or .1, {x=x+ap.x, y=y+ap.y, z=z+ap.z}, false)
		end
	else
		return nil
	end
   
   --wall texture
	if wall_sprites then
		local x,y,z
		if adjusted_pos then
			x=adjusted_pos.x + pos.x
			y=adjusted_pos.y + pos.y
			z=adjusted_pos.z + pos.z
		else
			x=pos.x
			y=pos.y
			z=pos.z
		end
		local sprite_file
		if wall.texture == wall_types.red then			sprite_file = wall_texture_files.red
		elseif wall.texture == wall_types.green then	sprite_file = wall_texture_files.green
		elseif wall.texture == wall_types.blue then		sprite_file = wall_texture_files.blue
		elseif wall.texture == wall_types.yellow then	sprite_file = wall_texture_files.yellow
		elseif wall.texture == wall_types.white then	sprite_file = wall_texture_files.white
		end
		-- calc offset and rotation
		local closeness = 0.6
		local scale_adj = 50
		if sprite_offset == nil then
			if rot_amount==0 or rot_amount==180 or rot_amount==360 then
				sprite_texture_1 = create_image_sprite(sprite_file, {rx=90, ry=0, rz=0}, 1, {x=x, y=y-closeness, z=z}, false, walldecorgroup, false)
				sprite_texture_2 = create_image_sprite(sprite_file, {rx=90, ry=180, rz=0}, 1, {x=x, y=y+closeness, z=z}, false, walldecorgroup, false)
			else
				sprite_texture_1 = create_image_sprite(sprite_file, {rx=90, ry=0, rz=90}, 1, {x=x, y=y-closeness, z=z}, false, walldecorgroup, false)
				sprite_texture_2 = create_image_sprite(sprite_file, {rx=90, ry=180, rz=90}, 1, {x=x, y=y+closeness, z=z}, false, walldecorgroup, false)
			end
			E.set_entity_scale(sprite_texture_1, scale.w/128, scale.h/128, 1)
			E.set_entity_scale(sprite_texture_2, scale.w/128, scale.h/128, 1)
			E.set_sprite_range(sprite_texture_1, 0, scale.w/scale_adj, 0, scale.h/scale_adj)
			E.set_sprite_range(sprite_texture_2, 0, scale.w/scale_adj, 0, scale.h/scale_adj)
		else
			local spr_rot_amount=0
			struct_rot = struct_rot or 0
			if sprite_offset == "+y" then
				y=y+closeness
				spr_rot_amount=180
			elseif	sprite_offset == "-y" then
				y=y-closeness
				spr_rot_amount=0
			end
			if rot_amount==0 or rot_amount==180 or rot_amount==360 then
				sprite_texture = create_image_sprite(sprite_file, {rx=90, ry=spr_rot_amount, rz=0}, 1, {x=x, y=y, z=z}, false, walldecorgroup, false)
			else
				sprite_texture = create_image_sprite(sprite_file, {rx=90, ry=spr_rot_amount, rz=90}, 1, {x=x, y=y, z=z}, false, walldecorgroup, false)
			end
			E.set_entity_scale(sprite_texture, scale.w/128, scale.h/128, 1)
			E.set_sprite_range(sprite_texture, 0, scale.w/scale_adj, 0, scale.h/scale_adj)
		end
	end

	E.parent_entity(wall.entity, wallgroup)

	table.insert(walls, wall)
end
function add_hallway(walltexture, rot_amount, size, centerpos, decor)
   local wallpos = { left = {x=-(size.w/2), y=0, z=0};
                     right= {x=(size.w/2), y=0, z=0};
                     floor= {x=0, y=0, z=0};
                     ceil = {x=0, y=size.h, z=0};
                   }
   local wallscale={ left_right = {w=size.d, h=size.h, d=gen_wall_depth};
                     floor_ceil = {w=size.w, h=size.d, d=gen_wall_depth};
                   }
   decor = decor or {}
   local decorpos = {left =decor.left  and {x=decor_close_pos(false), y=0, z=decor_spec_pos(wallscale.left_right.w, decor.left, false)};
                     right=decor.right and {x=decor_close_pos(true), y=0, z=decor_spec_pos(wallscale.left_right.w, decor.right, true)};
                     floor=decor.floor and {x=0, y=decor_close_pos(false), z=decor_spec_pos(wallscale.floor_ceil.h, decor.floor, false)};
                     ceil =decor.ceil  and {x=0, y=decor_close_pos(true), z=decor_spec_pos(wallscale.floor_ceil.h, decor.ceil, false)};
                    }
   wallpos  = rotate_structure(rot_amount, wallpos)
   decorpos = rotate_structure(rot_amount, decorpos)

   add_wall(walltexture, 90+rot_amount, wallscale.left_right, wallpos.left,  centerpos, {spec=decor.left, calc={adjpos=decorpos.left, adjrot=0}}, "+x", rot_amount)
   add_wall(walltexture, 90+rot_amount, wallscale.left_right, wallpos.right, centerpos, {spec=decor.right,calc={adjpos=decorpos.right,adjrot=180}}, "-x", rot_amount)
   add_ceilorfloor("floor",   walltexture, 0+rot_amount, wallscale.floor_ceil, wallpos.floor, centerpos, {spec=decor.floor, calc={adjpos=decorpos.floor, adjrot=0}}, "+y", rot_amount)
   add_ceilorfloor("ceiling", walltexture, 0+rot_amount, wallscale.floor_ceil, wallpos.ceil,  centerpos, {spec=decor.ceil,  calc={adjpos=decorpos.ceil,  adjrot=180}}, "-y", rot_amount)
end
function add_room2(walltexture, size, centerpos, doors)
   if doors == nil then
      local wallpos = { left = {x=centerpos.x-(size.w/2), y=centerpos.y, z=centerpos.z};
                        right= {x=centerpos.x+(size.w/2), y=centerpos.y, z=centerpos.z};
                        front= {x=centerpos.x, y=centerpos.y, z=centerpos.z-(size.d/2)};
                        back = {x=centerpos.x, y=centerpos.y, z=centerpos.z+(size.d/2)};
                        floor= {x=centerpos.x, y=centerpos.y, z=centerpos.z};
                        ceil = {x=centerpos.x, y=centerpos.y+size.h, z=centerpos.z};
                      }
      local wallscale={ left_right = {w=size.d, h=size.h, d=gen_wall_depth};
                        front_back = {w=size.w, h=size.h, d=gen_wall_depth};
                        floor_ceil = {w=size.w, h=size.d, d=gen_wall_depth};
                      }
      add_wall(walltexture, 90, wallscale.left_right, wallpos.left)
      add_wall(walltexture, 90, wallscale.left_right, wallpos.right)
      add_wall(walltexture, 0, wallscale.front_back, wallpos.front)
      add_wall(walltexture, 0, wallscale.front_back, wallpos.back)
   else
      local num_frontwalls = get_num_walls(doors.front)
      local num_backwalls  = get_num_walls(doors.back)
      local num_leftwalls  = get_num_walls(doors.left)
      local num_rightwalls = get_num_walls(doors.right)
      local wallsscale = {}
      wallsscale.front = get_walls_scale("front/back", num_frontwalls, doors.front, size)
      wallsscale.back  = get_walls_scale("front/back", num_backwalls,  doors.back,  size)
      wallsscale.left  = get_walls_scale("left/right", num_leftwalls,  doors.left,  size)
      wallsscale.right = get_walls_scale("left/right", num_rightwalls, doors.right, size)
      wallsscale.floor_ceil = {w=size.w, h=size.d, d=gen_wall_depth}
      local wallspos = {}
      wallspos.front = get_walls_pos("front", num_frontwalls, doors.front, size, wallsscale.front, centerpos)
      wallspos.back  = get_walls_pos("back",  num_backwalls,  doors.back,  size, wallsscale.back,  centerpos)
      wallspos.left  = get_walls_pos("left",  num_leftwalls,  doors.left,  size, wallsscale.left,  centerpos)
      wallspos.right = get_walls_pos("right", num_rightwalls, doors.right, size, wallsscale.right, centerpos)
      wallspos.floor = {x=centerpos.x, y=centerpos.y, z=centerpos.z}
      wallspos.ceil  = {x=centerpos.x, y=centerpos.y+size.h, z=centerpos.z}
      for i=1,num_frontwalls do add_wall(walltexture, 0, wallsscale.front[i], wallspos.front[i]) end
      for i=1,num_backwalls  do add_wall(walltexture, 0, wallsscale.back[i],  wallspos.back[i])  end
      for i=1,num_leftwalls  do add_wall(walltexture,90, wallsscale.left[i],  wallspos.left[i])  end
      for i=1,num_rightwalls do add_wall(walltexture,90, wallsscale.right[i], wallspos.right[i]) end
   end
end

--The mother of all functions
function add_room(walltexture, size, centerpos, doors)
   if doors == nil then
      local wallpos = { left = {x=centerpos.x-(size.w/2), y=centerpos.y, z=centerpos.z};
                        right= {x=centerpos.x+(size.w/2), y=centerpos.y, z=centerpos.z};
                        front= {x=centerpos.x, y=centerpos.y, z=centerpos.z-(size.d/2)};
                        back = {x=centerpos.x, y=centerpos.y, z=centerpos.z+(size.d/2)};
                        floor= {x=centerpos.x, y=centerpos.y, z=centerpos.z};
                        ceil = {x=centerpos.x, y=centerpos.y+size.h, z=centerpos.z};
                      }
      local wallscale={ left_right = {w=size.d, h=size.h, d=gen_wall_depth};
                        front_back = {w=size.w, h=size.h, d=gen_wall_depth};
                        floor_ceil = {w=size.w, h=size.d, d=gen_wall_depth};
                      }
      add_wall(walltexture, 90, wallscale.left_right, wallpos.left)
      add_wall(walltexture, 90, wallscale.left_right, wallpos.right)
      add_wall(walltexture, 0, wallscale.front_back, wallpos.front)
      add_wall(walltexture, 0, wallscale.front_back, wallpos.back)
      add_ceilorfloor("floor", walltexture, 0, wallscale.floor_ceil, wallpos.floor, nil, nil, "+y")
      add_ceilorfloor("ceiling", walltexture, 0, wallscale.floor_ceil, wallpos.ceil, nil, nil, "-y")
   else
      local num_frontwalls = get_num_walls(doors.front)
      local num_backwalls  = get_num_walls(doors.back)
      local num_leftwalls  = get_num_walls(doors.left)
      local num_rightwalls = get_num_walls(doors.right)
      local wallsscale = {}
      wallsscale.front = get_walls_scale("front/back", num_frontwalls, doors.front, size)
      wallsscale.back  = get_walls_scale("front/back", num_backwalls,  doors.back,  size)
      wallsscale.left  = get_walls_scale("left/right", num_leftwalls,  doors.left,  size)
      wallsscale.right = get_walls_scale("left/right", num_rightwalls, doors.right, size)
      wallsscale.floor_ceil = {w=size.w, h=size.d, d=gen_wall_depth}
      local wallspos = {}
      wallspos.front = get_walls_pos("front", num_frontwalls, doors.front, size, wallsscale.front, centerpos)
      wallspos.back  = get_walls_pos("back",  num_backwalls,  doors.back,  size, wallsscale.back,  centerpos)
      wallspos.left  = get_walls_pos("left",  num_leftwalls,  doors.left,  size, wallsscale.left,  centerpos)
      wallspos.right = get_walls_pos("right", num_rightwalls, doors.right, size, wallsscale.right, centerpos)
      wallspos.floor = {x=centerpos.x, y=centerpos.y, z=centerpos.z}
      wallspos.ceil  = {x=centerpos.x, y=centerpos.y+size.h, z=centerpos.z}
      for i=1,num_frontwalls do add_wall(walltexture, 0, wallsscale.front[i], wallspos.front[i]) end
      for i=1,num_backwalls  do add_wall(walltexture, 0, wallsscale.back[i],  wallspos.back[i])  end
      for i=1,num_leftwalls  do add_wall(walltexture,90, wallsscale.left[i],  wallspos.left[i])  end
      for i=1,num_rightwalls do add_wall(walltexture,90, wallsscale.right[i], wallspos.right[i]) end
      add_ceilorfloor("floor", walltexture, 0, wallsscale.floor_ceil, wallspos.floor, nil, nil, "+y")
      add_ceilorfloor("ceiling", walltexture, 0, wallsscale.floor_ceil, wallspos.ceil, nil, nil, "-y")
   end
end
function get_num_walls(walldoors)
   local num_walls
   if walldoors then
      local num_doors = #walldoors
      if num_doors == 1 then
         if walldoors[1] > 0 and walldoors[1] < 100 then
            num_walls = 2
         else
            num_walls = 1
         end
      elseif num_doors == 2 then
         if walldoors[1] ~= 0 and walldoors[2] ~= 100 then
            num_walls = 3
         elseif (walldoors[1] == 0 and walldoors[2] ~= 100) or (walldoors[1] ~= 0 and walldoors[2] == 100) then
            num_walls = 2
         else
            num_walls = 1
         end
      end
   else
      num_walls = 1
   end
   return num_walls
end
function get_walls_scale(walltype, num_walls, walldoors, size)
   local width
   if walltype == "front/back" then width = size.w
   else                             width = size.d
   end

   if not walldoors then
      return {{w=width, h=size.h, d=gen_wall_depth}}
   end

   local wallscale = {}
   local num_doors = #walldoors
   if num_doors == 1 then
      if num_walls == 1 then
         wallscale = {{w=width-doorway_width, h=size.h, d=gen_wall_depth}}
      else
         local wall1_w = walldoors[1]*((width-doorway_width)/100)
         local wall2_w = width - wall1_w - doorway_width
         wallscale = {{w=wall1_w, h=size.h, d=gen_wall_depth};
                      {w=wall2_w, h=size.h, d=gen_wall_depth}}
      end
   elseif num_doors == 2 then
      if num_walls == 1 then
         wallscale = {{w=width-(doorway_width*2), h=size.h, d=gen_wall_depth}}
      elseif num_walls == 2 then
         if walldoors[1] == 0 then
            local wall1_w = (walldoors[2]*((width-doorway_width)/100))-doorway_width
            local wall2_w = width - wall1_w - (doorway_width*2)
            wallscale = {{w=wall1_w, h=size.h, d=gen_wall_depth};
                         {w=wall2_w, h=size.h, d=gen_wall_depth}}
         else
            local wall1_w = walldoors[1]*((width-doorway_width)/100)
            local wall2_w = width - wall1_w - (doorway_width*2)
            wallscale = {{w=wall1_w, h=size.h, d=gen_wall_depth};
                         {w=wall2_w, h=size.h, d=gen_wall_depth}}
         end
      else
         local wall1_w = walldoors[1]*((width-doorway_width)/100)
         local wall3_w = (100-walldoors[2])*((width-doorway_width)/100)
         local wall2_w = width - wall1_w - wall3_w - (doorway_width*2)
         wallscale = {{w=wall1_w, h=size.h, d=gen_wall_depth};
                      {w=wall2_w, h=size.h, d=gen_wall_depth};
                      {w=wall3_w, h=size.h, d=gen_wall_depth}}
      end
   end
   return wallscale
end
function get_walls_pos(walltype, num_walls, walldoors, roomsize, wallsize, pos)
   local wallpos = {}
   local num_doors
   if walldoors then
      num_doors = #walldoors
   end
   if walltype == "front" then
      if num_walls==1 then
         if not walldoors then
            wallpos = {{x=pos.x, y=pos.y, z=pos.z-(roomsize.d/2)}}
         elseif num_doors == 1 then
            if walldoors[1] == 0 then
               wallpos = {{x=(pos.x-(roomsize.w/2))+(wallsize[1].w/2), y=pos.y, z=pos.z-(roomsize.d/2)}}
            else
               wallpos = {{x=(pos.x+(roomsize.w/2))-(wallsize[1].w/2), y=pos.y, z=pos.z-(roomsize.d/2)}}
            end
         else
            wallpos = {{x=pos.x, y=pos.y, z=pos.z-(roomsize.d/2)}}
         end
      elseif num_walls == 2 then
         if num_doors == 1 then
            wallpos = {{x=(pos.x-(roomsize.w/2))+(wallsize[1].w/2), y=pos.y, z=pos.z-(roomsize.d/2)};
                       {x=(pos.x+(roomsize.w/2))-(wallsize[2].w/2), y=pos.y, z=pos.z-(roomsize.d/2)}}
         else
            if walldoors[1] == 0 then
               wallpos = {{x=(pos.x-(roomsize.w/2))+doorway_width+(wallsize[1].w/2), y=pos.y, z=pos.z-(roomsize.d/2)};
                          {x=(pos.x+(roomsize.w/2))-(wallsize[2].w/2), y=pos.y, z=pos.z-(roomsize.d/2)}}
            else
               wallpos = {{x=(pos.x-(roomsize.w/2))+(wallsize[1].w/2), y=pos.y, z=pos.z-(roomsize.d/2)};
                          {x=(pos.x+(roomsize.w/2)-doorway_width)-(wallsize[2].w/2), y=pos.y, z=pos.z-(roomsize.d/2)}}
            end
         end
      elseif num_walls == 3 then
         wallpos = {{x=(pos.x-(roomsize.w/2))+(wallsize[1].w/2), y=pos.y, z=pos.z-(roomsize.d/2)};
                    {x=(pos.x-(roomsize.w/2)) + wallsize[1].w + doorway_width + (wallsize[2].w/2), y=pos.y, z=pos.z-(roomsize.d/2)};
                    {x=(pos.x+(roomsize.w/2))-(wallsize[3].w/2), y=pos.y, z=pos.z-(roomsize.d/2)}}
      end
   elseif walltype == "back" then
      if num_walls==1 then
         if not walldoors then
            wallpos = {{x=pos.x, y=pos.y, z=pos.z+(roomsize.d/2)}}
         elseif num_doors == 1 then
            if walldoors[1] == 0 then
               wallpos = {{x=(pos.x-(roomsize.w/2))+(wallsize[1].w/2), y=pos.y, z=pos.z+(roomsize.d/2)}}
            else
               wallpos = {{x=(pos.x+(roomsize.w/2))-(wallsize[1].w/2), y=pos.y, z=pos.z+(roomsize.d/2)}}
            end
         else
            wallpos = {{x=pos.x, y=pos.y, z=pos.z+(roomsize.d/2)}}
         end
      elseif num_walls == 2 then
         if num_doors == 1 then
            wallpos = {{x=(pos.x-(roomsize.w/2))+(wallsize[1].w/2), y=pos.y, z=pos.z+(roomsize.d/2)};
                       {x=(pos.x+(roomsize.w/2))-(wallsize[2].w/2), y=pos.y, z=pos.z+(roomsize.d/2)}}
         else
            if walldoors[1] == 0 then
               wallpos = {{x=(pos.x-(roomsize.w/2))+doorway_width+(wallsize[1].w/2), y=pos.y, z=pos.z+(roomsize.d/2)};
                          {x=(pos.x+(roomsize.w/2))-(wallsize[2].w/2), y=pos.y, z=pos.z+(roomsize.d/2)}}
            else
               wallpos = {{x=(pos.x-(roomsize.w/2))+(wallsize[1].w/2), y=pos.y, z=pos.z+(roomsize.d/2)};
                          {x=(pos.x+(roomsize.w/2)-doorway_width)-(wallsize[2].w/2), y=pos.y, z=pos.z+(roomsize.d/2)}}
            end
         end
      elseif num_walls == 3 then
         wallpos = {{x=(pos.x-(roomsize.w/2))+(wallsize[1].w/2), y=pos.y, z=pos.z+(roomsize.d/2)};
                    {x=(pos.x-(roomsize.w/2)) + wallsize[1].w + doorway_width + (wallsize[2].w/2), y=pos.y, z=pos.z+(roomsize.d/2)};
                    {x=(pos.x+(roomsize.w/2))-(wallsize[3].w/2), y=pos.y, z=pos.z+(roomsize.d/2)}}
      end
   elseif walltype == "left" then
      if num_walls==1 then
         if not walldoors then
            wallpos = {{x=pos.x-(roomsize.w/2), y=pos.y, z=pos.z}}
         elseif num_doors == 1 then
            if walldoors[1] == 0 then
               wallpos = {{x=pos.x-(roomsize.w/2), y=pos.y, z=(pos.z-(roomsize.d/2))+(wallsize[1].w/2)}}
            else
               wallpos = {{x=pos.x-(roomsize.w/2), y=pos.y, z=(pos.z+(roomsize.d/2))-(wallsize[1].w/2)}}
            end
         else
            wallpos = {{x=pos.x-(roomsize.w/2), y=pos.y, z=pos.z}}
         end
      elseif num_walls == 2 then
         if num_doors == 1 then
            wallpos = {{x=pos.x-(roomsize.w/2), y=pos.y, z=(pos.z+(roomsize.d/2))-(wallsize[1].w/2)};
                       {x=pos.x-(roomsize.w/2), y=pos.y, z=(pos.z-(roomsize.d/2))+(wallsize[1].w/2)}}
         else
            if walldoors[1] == 0 then
               wallpos = {{x=pos.x-(roomsize.w/2), y=pos.y, z=(pos.z-(roomsize.d/2))+doorway_width+(wallsize[1].w/2)};
                          {x=pos.x-(roomsize.w/2), y=pos.y, z=(pos.z+(roomsize.d/2))-(wallsize[2].w/2)}}
            else
               wallpos = {{x=pos.x-(roomsize.w/2), y=pos.y, z=(pos.z-(roomsize.d/2))+(wallsize[1].w/2)};
                          {x=pos.x-(roomsize.w/2), y=pos.y, z=(pos.z+(roomsize.d/2)-doorway_width)-(wallsize[2].w/2)}}
            end
         end
      elseif num_walls == 3 then
         wallpos = {{x=pos.x-(roomsize.w/2), y=pos.y, z=(pos.z-(roomsize.d/2))+(wallsize[1].w/2)};
                    {x=pos.x-(roomsize.w/2), y=pos.y, z=(pos.z-(roomsize.d/2)) + wallsize[1].w + doorway_width + (wallsize[2].w/2)};
                    {x=pos.x-(roomsize.w/2), y=pos.y, z=(pos.z+(roomsize.d/2))-(wallsize[3].w/2)}}
      end
   else
      if num_walls==1 then
         if not walldoors then
            wallpos = {{x=pos.x+(roomsize.w/2), y=pos.y, z=pos.z}}
         elseif num_doors == 1 then
            if walldoors[1] == 0 then
               wallpos = {{x=pos.x+(roomsize.w/2), y=pos.y, z=(pos.z-(roomsize.d/2))+(wallsize[1].w/2)}}
            else
               wallpos = {{x=pos.x+(roomsize.w/2), y=pos.y, z=(pos.z+(roomsize.d/2))-(wallsize[1].w/2)}}
            end
         else
            wallpos = {{x=pos.x+(roomsize.w/2), y=pos.y, z=pos.z}}
         end
      elseif num_walls == 2 then
         if num_doors == 1 then
            wallpos = {{x=pos.x+(roomsize.w/2), y=pos.y, z=(pos.z+(roomsize.d/2))-(wallsize[1].w/2)};
                       {x=pos.x+(roomsize.w/2), y=pos.y, z=(pos.z-(roomsize.d/2))+(wallsize[1].w/2)}}
         else
            if walldoors[1] == 0 then
               wallpos = {{x=pos.x+(roomsize.w/2), y=pos.y, z=(pos.z-(roomsize.d/2))+doorway_width+(wallsize[1].w/2)};
                          {x=pos.x+(roomsize.w/2), y=pos.y, z=(pos.z+(roomsize.d/2))-(wallsize[2].w/2)}}
            else
               wallpos = {{x=pos.x+(roomsize.w/2), y=pos.y, z=(pos.z-(roomsize.d/2))+(wallsize[1].w/2)};
                          {x=pos.x+(roomsize.w/2), y=pos.y, z=(pos.z+(roomsize.d/2)-doorway_width)-(wallsize[2].w/2)}}
            end
         end
      elseif num_walls == 3 then
         wallpos = {{x=pos.x+(roomsize.w/2), y=pos.y, z=(pos.z-(roomsize.d/2))+(wallsize[1].w/2)};
                    {x=pos.x+(roomsize.w/2), y=pos.y, z=(pos.z-(roomsize.d/2)) + wallsize[1].w + doorway_width + (wallsize[2].w/2)};
                    {x=pos.x+(roomsize.w/2), y=pos.y, z=(pos.z+(roomsize.d/2))-(wallsize[3].w/2)}}
      end
   end
   return wallpos
end
function add_T_joint(walltexture, rot_amount, scale, pos, decor)
-- scale = {w, h, d, topw, stemw}
   local wallscale = {front    ={w=scale.w, h=scale.h, d=gen_wall_depth};
                      topback  ={w=(scale.w/2)-(scale.stemw/2), h=scale.h, d=gen_wall_depth};
                      stem     ={w=scale.d-scale.topw, h=scale.h, d=gen_wall_depth};
                      topfloorceil ={w=scale.w, h=scale.topw, d=gen_wall_depth};
                      stemfloorceil={w=scale.stemw, h=scale.d-scale.topw, d=gen_wall_depth}}
   local wallpos  = {front    ={x=0, y=0, z=-(scale.topw/2)};
                     backleft ={x=-(scale.stemw/2)-(wallscale.topback.w/2), y=0, z=(scale.topw/2)};
                     backright={x=(scale.stemw/2)+(wallscale.topback.w/2), y=0, z=(scale.topw/2)};
                     stemleft ={x=-scale.stemw/2, y=0, z=(scale.topw/2)+(wallscale.stem.w/2)};
                     stemright={x=scale.stemw/2, y=0, z=(scale.topw/2)+(wallscale.stem.w/2)};
                     topfloor ={x=0, y=0, z=0};
                     topceil  ={x=0, y=scale.h, z=0};
                     stemfloor={x=0, y=0, z=(scale.topw/2)+(wallscale.stemfloorceil.h/2)};
                     stemceil ={x=0, y=scale.h, z=(scale.topw/2)+(wallscale.stemfloorceil.h/2)}}
   decor = decor or {}
   local decorpos = {front    =decor.front     and {x=decor_spec_pos(wallscale.front.w, decor.front, true), y=0, z=decor_close_pos(false)};
                     backleft =decor.backleft  and {x=decor_spec_pos(wallscale.topback.w, decor.backleft, false), y=0, z=decor_close_pos(true)};
                     backright=decor.backright and {x=decor_spec_pos(wallscale.topback.w, decor.backright, false), y=0, z=decor_close_pos(true)};
                     stemleft =decor.stemleft  and {x=decor_close_pos(false), y=0, z=decor_spec_pos(wallscale.stem.w, decor.stemleft, false)};
                     stemright=decor.stemright and {x=decor_close_pos(true), y=0, z=decor_spec_pos(wallscale.stem.w, decor.stemright, true)};
                     topfloor =decor.topfloor  and {x=decor_spec_pos(wallscale.topfloorceil.w, decor.topfloor, false), y=decor_close_pos(false), z=0};
                     topceil  =decor.topceil   and {x=decor_spec_pos(wallscale.topfloorceil.w, decor.topceil, true), y=decor_close_pos(true), z=0};
                     stemfloor=decor.stemfloor and {x=0, y=decor_close_pos(false), z=decor_spec_pos(wallscale.stemfloorceil.h, decor.stemfloor, false)};
                     stemceil =decor.stemceil  and {x=0, y=decor_close_pos(true), z=decor_spec_pos(wallscale.stemfloorceil.h, decor.stemceil, false)}
                    }
   wallpos  = rotate_structure(rot_amount, wallpos)
   decorpos = rotate_structure(rot_amount, decorpos)

   add_wall(walltexture,  0+rot_amount, wallscale.front,   wallpos.front,     pos, {spec=decor.front,    calc={adjpos=decorpos.front,    adjrot=0}}, "+z", rot_amount)
   add_wall(walltexture,  0+rot_amount, wallscale.topback, wallpos.backleft,  pos, {spec=decor.backleft, calc={adjpos=decorpos.backleft, adjrot=180}}, "-z", rot_amount)
   add_wall(walltexture,  0+rot_amount, wallscale.topback, wallpos.backright, pos, {spec=decor.backright,calc={adjpos=decorpos.backright,adjrot=180}}, "-z", rot_amount)
   add_wall(walltexture, 90+rot_amount, wallscale.stem,    wallpos.stemleft,  pos, {spec=decor.stemleft, calc={adjpos=decorpos.stemleft, adjrot=0}}, "+x", rot_amount)
   add_wall(walltexture, 90+rot_amount, wallscale.stem,    wallpos.stemright, pos, {spec=decor.stemright,calc={adjpos=decorpos.stemright,adjrot=180}}, "-x", rot_amount)
   add_ceilorfloor("floor",   walltexture, 0+rot_amount, wallscale.topfloorceil,  wallpos.topfloor, pos, {spec=decor.topfloor, calc={adjpos=decorpos.topfloor, adjrot=0}}, "+y", rot_amount)
   add_ceilorfloor("ceiling", walltexture, 0+rot_amount, wallscale.topfloorceil,  wallpos.topceil,  pos, {spec=decor.topceil,  calc={adjpos=decorpos.topceil,  adjrot=180}}, "-y", rot_amount)
   add_ceilorfloor("floor",   walltexture, 0+rot_amount, wallscale.stemfloorceil, wallpos.stemfloor,pos, {spec=decor.stemfloor,calc={adjpos=decorpos.stemfloor,adjrot=0}}, "+y", rot_amount)
   add_ceilorfloor("ceiling", walltexture, 0+rot_amount, wallscale.stemfloorceil, wallpos.stemceil, pos, {spec=decor.stemceil, calc={adjpos=decorpos.stemceil, adjrot=180}}, "-y", rot_amount)
end
function add_X_joint(walltexture, scale, pos, decor)
-- scale = {w, h, d, cs1w, cs2w}
   local wallscale = {cs1={w=(scale.d/2)-(scale.cs2w/2), h=scale.h, d=gen_wall_depth};
                      cs2={w=(scale.w/2)-(scale.cs1w/2), h=scale.h, d=gen_wall_depth};
                      cs1floorceil={w=scale.cs1w, h=scale.d, d=gen_wall_depth};
                      cs2floorceil={w=(scale.w/2)-(scale.cs1w/2), h=scale.cs2w, d=gen_wall_depth}}
   local wallpos = {cs1topleft ={x=-(scale.cs1w/2), y=0, z=-(scale.cs2w/2)-(wallscale.cs1.w/2)};
                    cs1topright={x=(scale.cs1w/2), y=0, z=-(scale.cs2w/2)-(wallscale.cs1.w/2)};
                    cs1botleft ={x=-(scale.cs1w/2), y=0, z=(scale.cs2w/2)+(wallscale.cs1.w/2)};
                    cs1botright={x=(scale.cs1w/2), y=0, z=(scale.cs2w/2)+(wallscale.cs1.w/2)};
                    cs2lefttop ={x=-(scale.cs1w/2)-(wallscale.cs2.w/2), y=0, z=-(scale.cs2w/2)};
                    cs2leftbot ={x=-(scale.cs1w/2)-(wallscale.cs2.w/2), y=0, z=(scale.cs2w/2)};
                    cs2righttop={x=(scale.cs1w/2)+(wallscale.cs2.w/2), y=0, z=-(scale.cs2w/2)};
                    cs2rightbot={x=(scale.cs1w/2)+(wallscale.cs2.w/2), y=0, z=(scale.cs2w/2)};
                    cs1floor   ={x=0, y=0, z=0};
                    cs1ceil    ={x=0, y=scale.h, z=0};
                    cs2leftfloor ={x=-(scale.cs1w/2)-(wallscale.cs2.w/2), y=0, z=0};
                    cs2leftceil  ={x=-(scale.cs1w/2)-(wallscale.cs2.w/2), y=scale.h, z=0};
                    cs2rightfloor={x=(scale.cs1w/2)+(wallscale.cs2.w/2), y=0, z=0};
                    cs2rightceil ={x=(scale.cs1w/2)+(wallscale.cs2.w/2), y=scale.h, z=0}}
   decor = decor or {}
   decor = switch_shorthand_wall_names(decor)
   local decorpos = {cs1topleft =decor.cs1topleft  and {x=decor_close_pos(false), y=0, z=decor_spec_pos(wallscale.cs1.w, decor.cs1topleft, false)};
                     cs1topright=decor.cs1topright and {x=decor_close_pos(true), y=0, z=decor_spec_pos(wallscale.cs1.w, decor.cs1topright, true)};
                     cs1botleft =decor.cs1botleft  and {x=decor_close_pos(false), y=0, z=decor_spec_pos(wallscale.cs1.w, decor.cs1botleft, false)};
                     cs1botright=decor.cs1botright and {x=decor_close_pos(true), y=0, z=decor_spec_pos(wallscale.cs1.w, decor.cs1botright, true)};
                     cs2lefttop =decor.cs2lefttop  and {x=decor_spec_pos(wallscale.cs2.w, decor.cs2lefttop, true), y=0, z=decor_close_pos(false)};
                     cs2leftbot =decor.cs2leftbot  and {x=decor_spec_pos(wallscale.cs2.w, decor.cs2leftbot, false), y=0, z=decor_close_pos(true)};
                     cs2righttop=decor.cs2righttop and {x=decor_spec_pos(wallscale.cs2.w, decor.cs2righttop, true), y=0, z=decor_close_pos(false)};
                     cs2rightbot=decor.cs2rightbot and {x=decor_spec_pos(wallscale.cs2.w, decor.cs2rightbot, false), y=0, z=decor_close_pos(true)};
                     cs1floor   =decor.cs1floor    and {x=0, y=decor_close_pos(false), z=decor_spec_pos(wallscale.cs1floorceil.h, decor.cs1floor, false)};
                     cs1ceil    =decor.cs1ceil     and {x=0, y=decor_close_pos(true), z=decor_spec_pos(wallscale.cs1floorceil.h, decor.cs1ceil, false)};
                     cs2leftfloor =decor.cs2leftfloor  and {x=decor_spec_pos(wallscale.cs2floorceil.w, decor.cs2leftfloor, true), y=decor_close_pos(false), z=0};
                     cs2leftceil  =decor.cs2leftceil   and {x=decor_spec_pos(wallscale.cs2floorceil.w, decor.cs2leftceil, true), y=decor_close_pos(true), z=0};
                     cs2rightfloor=decor.cs2rightfloor and {x=decor_spec_pos(wallscale.cs2floorceil.w, decor.cs2rightfloor, true), y=decor_close_pos(false), z=0};
                     cs2rightceil =decor.cs2rightceil  and {x=decor_spec_pos(wallscale.cs2floorceil.w, decor.cs2rightceil, true), y=decor_close_pos(true), z=0}
                    }
   add_wall(walltexture, 90, wallscale.cs1, wallpos.cs1topleft,  pos, {spec=decor.cs1topleft,  calc={adjpos=decorpos.cs1topleft,  adjrot=0}}, "+x", rot_amount)
   add_wall(walltexture, 90, wallscale.cs1, wallpos.cs1topright, pos, {spec=decor.cs1topright, calc={adjpos=decorpos.cs1topright, adjrot=180}}, "-x", rot_amount)
   add_wall(walltexture, 90, wallscale.cs1, wallpos.cs1botleft,  pos, {spec=decor.cs1botleft,  calc={adjpos=decorpos.cs1botleft,  adjrot=0}}, "+x", rot_amount)
   add_wall(walltexture, 90, wallscale.cs1, wallpos.cs1botright, pos, {spec=decor.cs1botright, calc={adjpos=decorpos.cs1botright, adjrot=180}}, "-x", rot_amount)
   add_wall(walltexture,  0, wallscale.cs2, wallpos.cs2lefttop,  pos, {spec=decor.cs2lefttop,  calc={adjpos=decorpos.cs2lefttop,  adjrot=0}}, "+z", rot_amount)
   add_wall(walltexture,  0, wallscale.cs2, wallpos.cs2leftbot,  pos, {spec=decor.cs2leftbot,  calc={adjpos=decorpos.cs2leftbot,  adjrot=180}}, "-z", rot_amount)
   add_wall(walltexture,  0, wallscale.cs2, wallpos.cs2righttop, pos, {spec=decor.cs2righttop, calc={adjpos=decorpos.cs2righttop, adjrot=0}}, "+z", rot_amount)
   add_wall(walltexture,  0, wallscale.cs2, wallpos.cs2rightbot, pos, {spec=decor.cs2rightbot, calc={adjpos=decorpos.cs2rightbot, adjrot=180}}, "-z", rot_amount)
   add_ceilorfloor("floor",   walltexture, 0, wallscale.cs1floorceil, wallpos.cs1floor,     pos, {spec=decor.cs1floor,     calc={adjpos=decorpos.cs1floor,     adjrot=0}}, "+y")
   add_ceilorfloor("floor",   walltexture, 0, wallscale.cs2floorceil, wallpos.cs2leftfloor, pos, {spec=decor.cs2leftfloor, calc={adjpos=decorpos.cs2leftfloor, adjrot=0}}, "+y")
   add_ceilorfloor("floor",   walltexture, 0, wallscale.cs2floorceil, wallpos.cs2rightfloor,pos, {spec=decor.cs2rightfloor,calc={adjpos=decorpos.cs2rightfloor,adjrot=0}}, "+y")
   add_ceilorfloor("ceiling", walltexture, 0, wallscale.cs1floorceil, wallpos.cs1ceil,      pos, {spec=decor.cs1ceil,      calc={adjpos=decorpos.cs1ceil,      adjrot=180}}, "-y")
   add_ceilorfloor("ceiling", walltexture, 0, wallscale.cs2floorceil, wallpos.cs2leftceil,  pos, {spec=decor.cs2leftceil,  calc={adjpos=decorpos.cs2leftceil,  adjrot=180}}, "-y")
   add_ceilorfloor("ceiling", walltexture, 0, wallscale.cs2floorceil, wallpos.cs2rightceil, pos, {spec=decor.cs2rightceil, calc={adjpos=decorpos.cs2rightceil, adjrot=180}}, "-y")
end
function switch_shorthand_wall_names(decor)
   decor.cs1topleft    = decor.cs1topleft    or decor.cs1tl
   decor.cs1topright   = decor.cs1topright   or decor.cs1tr
   decor.cs1botleft    = decor.cs1botleft    or decor.cs1bl
   decor.cs1botright   = decor.cs1botright   or decor.cs1br
   decor.cs2lefttop    = decor.cs2lefttop    or decor.cs2lt
   decor.cs2leftbot    = decor.cs2leftbot    or decor.cs2lb
   decor.cs2righttop   = decor.cs2righttop   or decor.cs2rt
   decor.cs2rightbot   = decor.cs2rightbot   or decor.cs2rb
   decor.cs2leftfloor  = decor.cs2leftfloor  or decor.cs2lfloor
   decor.cs2leftceil   = decor.cs2leftceil   or decor.cs2lceil
   decor.cs2rightfloor = decor.cs2rightfloor or decor.cs2rfloor
   decor.cs2rightceil  = decor.cs2rightceil  or decor.cs2rceil
   return decor
end
function add_L_joint(walltexture, rot_amount, scale, pos, decor)
-- scale = {w, h, d, lw, _w}
   local wallscale = {left ={w=scale.d, h=scale.h, d=gen_wall_depth};
                      right={w=scale.d-scale._w, h=scale.h, d=gen_wall_depth};
                      front={w=scale.w-scale.lw, h=scale.h, d=gen_wall_depth};
                      back ={w=scale.w, h=scale.h, d=gen_wall_depth};
                      lfloorceil={w=scale.lw, h=scale.d, d=gen_wall_depth};
                      _floorceil={w=scale._w, h=scale.w-scale.lw, d=gen_wall_depth}}
   local wallpos = {left  ={x=0, y=0, z=-(scale.d/2)};
                    right ={x=scale.lw, y=0, z=-scale._w-(wallscale.right.w/2)};
                    front ={x=scale.lw+(wallscale.front.w/2), y=0, z=-scale._w};
                    back  ={x=(scale.w/2), y=0, z=0};
                    lfloor={x=(scale.lw/2), y=0, z=-(scale.d/2)};
                    lceil ={x=(scale.lw/2), y=scale.h, z=-(scale.d/2)};
                    _floor={x=wallscale.lfloorceil.w+(wallscale._floorceil.h/2), y=0, z=-(scale._w/2)};
                    _ceil ={x=wallscale.lfloorceil.w+(wallscale._floorceil.h/2), y=scale.h, z=-(scale._w/2)}}
   decor = decor or {}
   local decorpos = {left  =decor.left   and {x=decor_close_pos(false), y=0, z=decor_spec_pos(wallscale.left.w, decor.left, false)};
                     right =decor.right  and {x=decor_close_pos(true), y=0, z=decor_spec_pos(wallscale.right.w, decor.right, true)};
                     front =decor.front  and {x=decor_spec_pos(wallscale.front.w, decor.front, true), y=0, z=decor_close_pos(false)};
                     back  =decor.back   and {x=decor_spec_pos(wallscale.back.w, decor.back, false), y=0, z=decor_close_pos(true)};
                     lfloor=decor.lfloor and {x=0, y=decor_close_pos(false), z=decor_spec_pos(wallscale.lfloorceil.d, decor.lfloor, false)};
                     lceil =decor.lceil  and {x=0, y=decor_close_pos(true), z=decor_spec_pos(wallscale.lfloorceil.d, decor.lceil, false)};
                     _floor=decor._floor and {x=decor_spec_pos(wallscale._floorceil.w, decor._floor, true), y=decor_close_pos(false), z=0};
                     _ceil =decor._ceil  and {x=decor_spec_pos(wallscale._floorceil.w, decor._ceil, true), y=decor_close_pos(true), z=0}
                    }
   wallpos  = rotate_structure(rot_amount, wallpos)
   decorpos = rotate_structure(rot_amount, decorpos)

   add_wall(walltexture, 90+rot_amount, wallscale.left,  wallpos.left,  pos, {spec=decor.left,  calc={adjpos=decorpos.left,  adjrot=0}}, "+x", rot_amount)
   add_wall(walltexture, 90+rot_amount, wallscale.right, wallpos.right, pos, {spec=decor.right, calc={adjpos=decorpos.right, adjrot=180}}, "-x", rot_amount)
   add_wall(walltexture,  0+rot_amount, wallscale.front, wallpos.front, pos, {spec=decor.front, calc={adjpos=decorpos.front, adjrot=0}}, "+z", rot_amount)
   add_wall(walltexture,  0+rot_amount, wallscale.back,  wallpos.back,  pos, {spec=decor.back,  calc={adjpos=decorpos.back,  adjrot=180}}, "-z", rot_amount)
   add_ceilorfloor("floor",   walltexture,   0+rot_amount, wallscale.lfloorceil, wallpos.lfloor, pos, {spec=decor.lfloor, calc={adjpos=decorpos.lfloor, adjrot=0}}, "+y", rot_amount)
   add_ceilorfloor("floor",   walltexture, -90+rot_amount, wallscale._floorceil, wallpos._floor, pos, {spec=decor._floor, calc={adjpos=decorpos._floor, adjrot=0}}, "+y", rot_amount)
   add_ceilorfloor("ceiling", walltexture,   0+rot_amount, wallscale.lfloorceil, wallpos.lceil,  pos, {spec=decor.lceil,  calc={adjpos=decorpos.lceil,  adjrot=180}}, "-y", rot_amount)
   add_ceilorfloor("ceiling", walltexture, -90+rot_amount, wallscale._floorceil, wallpos._ceil,  pos, {spec=decor._ceil,  calc={adjpos=decorpos._ceil,  adjrot=180}}, "-y", rot_amount)
end
function rotate_structure(rot_amount, wallpos)
   local wall_table = {}
   local i = 1
   for k in pairs(wallpos) do
      wall_table[i] = k
      i = i + 1
   end
   if rot_amount == 90 or rot_amount == -270 then
      for i=1,#wall_table do
         -- swap x & z and negate z
         wallpos[wall_table[i]].x, wallpos[wall_table[i]].z = wallpos[wall_table[i]].z, wallpos[wall_table[i]].x
         wallpos[wall_table[i]].z = -wallpos[wall_table[i]].z
      end
   elseif rot_amount == 180 or rot_amount == -180 then
      for i=1,#wall_table do
         -- negate x & z
         wallpos[wall_table[i]].x = -wallpos[wall_table[i]].x
         wallpos[wall_table[i]].z = -wallpos[wall_table[i]].z
      end
   elseif rot_amount == 270 or rot_amount == -90 then
      for i=1,#wall_table do
         -- swap x & z and negate x
         wallpos[wall_table[i]].x, wallpos[wall_table[i]].z = wallpos[wall_table[i]].z, wallpos[wall_table[i]].x
         wallpos[wall_table[i]].x = -wallpos[wall_table[i]].x
      end
   end
   return wallpos
end
function decor_spec_pos(scale, decor, negate)
   if negate then return   (scale-(128*(decor[3] or .1)))*((decor[2]-50)/100)
   else           return -((scale-(128*(decor[3] or .1)))*((decor[2]-50)/100))
   end
end
function decor_close_pos(negate)
   if negate then return (-gen_wall_depth*0.1)+0.49
   else           return (gen_wall_depth*0.1)-0.49
   end
end
function del_wall(id, wall)
	E.delete_entity(wall.entity)
	table.remove(walls, id)
end
