SHOTS_LUA = true

_sslash = {
--[[ STATES
	 spawn = 1,
	 active = 2,
	 hit_target = 3,
	 hit_barrier = 4,
	 expo = 5,
	 deactivate = 6
--]]
consts = {	max_dt = 0.5,
			xtreme_speed = 0.85,
			y_offset = 2,
			low_base = 3,
			low_mod = 2,
			high_base = 7,
			high_mod = 5,
			xtreme_power = 3.1,
			low_req = 3,
			high_req = 6,
			xtreme_req = 13,
			spin=70,
			dev=2,
			turn=20
},

base_low_slash = E.create_object(sslash_file),
base_high_slash = E.create_object(sslash_file),
base_extreme_slash = E.create_object(sslash_file),
burn_mark = create_image_sprite(sslash_burn_file, {rx=0, ry=0, rz=0}, 1, {x=0, y=0, z=0}, false, clone_basegroup),
expo_flash = create_image_sprite(sslash_expo_file, {rx=0, ry=0, rz=0}, 1, {x=0, y=0, z=0}, false, clone_basegroup),
burn_mark_count = 0,
burn_mark_max = 60,
burn_marks = {},
sslashes = {},
fsm_mat = {
					--spawn  active  hit_target  hit_barrier  expo  deactivate
--[[spawn]]		{   0,     1,        0,           0,        0,      0,    };
--[[active]]		{   0,     0,        1,           1,        0,      1,    };
--[[hit_target]]	{   0,     1,        0,           0,        1,      1,    };
--[[hit_barrier]]	{   0,     0,        0,           0,        1,      0,    };
--[[expo]]		{   0,     0,        0,           0,        0,      1,    };
--[[deactivate]]	{   0,     0,        0,           0,        0,      0,    }},

do_states = function(dt)
	table.foreach(_sslash.sslashes, function(id, sslash) _sslash.do_state(id, sslash, dt) end)
end,

do_state = function(id, sslash, dt)
	if 	   sslash.state == 1 then _sslash.generate(sslash)
	elseif sslash.state == 2 then _sslash.step(sslash, dt)
	elseif sslash.state == 3 then
		if sslash.type == 4 then
			_sslash.change_state(sslash, 2)
			_sslash.step(sslash, dt)
		else _sslash.change_state(sslash, 6) end
	elseif sslash.state == 4 then
		sslash.hit_sound = E.load_sound(sound_files.sslash_hit_barrier)
		E.set_sound_emitter(sslash.hit_sound, sslash.entity)
		E.set_sound_receiver(camera, 50)
		E.play_sound(sslash.hit_sound)
		_sslash.change_state(sslash, 5)
	elseif sslash.state == 5 then _sslash.expo(sslash)
	else _sslash.del(id, sslash) end
end,

set_initial_state = function(sslash)
	if sslash.state == nil then
		sslash.state = 1
	end
end,

change_state = function(sslash, ts)
	if _sslash.fsm_mat[sslash.state][ts] == 1 then 
		sslash.state = ts
	end
end,

generate = function (sslash)
	if sslash.type == 1 or sslash.type == 2 then
		sslash.entity = E.create_clone(_sslash.base_low_slash)
		player.update_stat("weapon_of_choice low", 1)
	elseif sslash.type == 3 then
		sslash.entity = E.create_clone(_sslash.base_high_slash)
		player.update_stat("weapon_of_choice high", 1)
	else
		sslash.entity = E.create_clone(_sslash.base_extreme_slash)
		player.update_stat("weapon_of_choice extreme", 1)
	end

	local minx, miny, minz, maxx, maxy, maxz = E.get_entity_bound(sslash.entity)
	E.set_entity_geom_type(sslash.entity, E.geom_type_sphere, 1.3)
	set_geom_attr(sslash.entity, {	cat=cat_sslash,
									col=cat_enemy + cat_wall,
									res=0,
									cal=cat_enemy + cat_wall})
	E.parent_entity(sslash.entity, bulletgroup)
	_VP.attach_entity(player.entity, sslash.entity, {0,_sslash.consts.y_offset,-2})
	sslash.vect={{0,0,0},{0,1,0},{player.entity.pivot.vect[3][1],0,player.entity.pivot.vect[3][3]}}
	sslash.pos={}
	sslash.pos[1], sslash.pos[2], sslash.pos[3]=E.get_entity_position(sslash.entity)
	if sslash.type == 1 then E.turn_entity(sslash.entity, 0, 0, 40)
	elseif sslash.type == 2 then E.turn_entity(sslash.entity, 0, 0, -40) end
	E.set_mesh(sslash.entity, 0, sslash.brush)
	--sslash.brush = E.get_mesh(sslash.entity, 0)
	E.set_brush_flags(sslash.brush, E.brush_flag_unlit, true)
	_sslash.change_state(sslash, 2)
	
	-- play 'player shoot' sound
	sslash.slash_sound = E.load_sound(sound_files.sslash_move)
	E.set_sound_emitter(sslash.slash_sound, sslash.entity)
	
	E.set_sound_receiver(camera, 50)
	E.set_sound_frequency(sslash.slash_sound, sslash.speed/60+1)
	E.loop_sound(sslash.slash_sound)
	
	--E.set_entity_flags(sslash.entity, E.entity_flag_visible_geom, true)
end,

add = function (slashtype, sslash_speed)
--[[TYPES
	TL->BR = 1
	TR->BL = 2
	TC->BC = 3
	EXTREME = 4
--]]
	if (slashtype == 1 or slashtype == 2) then
		if player.weapon.energy < _sslash.consts.low_req then return end
	else
		if sslash_speed > _sslash.consts.xtreme_speed then
			if player.weapon.energy < _sslash.consts.xtreme_req then
				if player.weapon.energy < _sslash.consts.high_req then return
				else sslash_speed = _sslash.consts.xtreme_speed end
			end
		else
			if player.weapon.energy < _sslash.consts.high_req then return end
		end
	end

	local sslash = { }
	_sslash.set_initial_state(sslash)

	sslash.type = slashtype
	sslash.brush = E.create_brush()

	if sslash.type == 1 or sslash.type == 2 then
		E.set_brush_color(sslash.brush, 0.15, 0.3, 0.8, 1.0)
		player.weapon.energy = player.weapon.energy - _sslash.consts.low_req
		player.update_stat("saber_energy_used",_sslash.consts.low_req)
	else
		if sslash_speed > _sslash.consts.xtreme_speed then
			sslash.type=4
			E.set_brush_color(sslash.brush, 1.0, 1.0, 1.0, 1.0)
			player.weapon.energy = player.weapon.energy - _sslash.consts.xtreme_req
			player.update_stat("saber_energy_used",_sslash.consts.xtreme_req)
		else
			E.set_brush_color(sslash.brush, 0.8, 0.2, 0.1, 1.0)
			player.weapon.energy = player.weapon.energy - _sslash.consts.high_req
			player.update_stat("saber_energy_used",_sslash.consts.high_req)
		end
	end

	sslash.speed, sslash.damage = _sslash.calc_var(sslash.type, sslash_speed)
	sslash.scale = 1
	table.insert(_sslash.sslashes, sslash)

	--E.set_entity_alpha(weapon, E.get_entity_alpha(weapon)-.08)

--[[
   if sound_on then
      E.play_sound(sound.sslash)
   end
--]]
end,

step = function (sslash, dt)
	if sslash.scale <= 0 then _sslash.change_state(sslash, 6) return
	else sslash.scale = sslash.scale - (0.5*dt) end
	sslash.pos[1], sslash.pos[2], sslash.pos[3]=vector_position(0, 0, -sslash.speed*dt*2, sslash.vect, sslash.pos)
	local x, y, z=get_rotation(sslash.vect)
	if math.abs(input.joy.x)>0.15 then
			sslash.pos[1], sslash.pos[2], sslash.pos[3]=vector_position(input.joy.x*_sslash.consts.dev*dt, 0, 0, sslash.vect, sslash.pos)
			sslash.vect[3][1]=math.sin(math.rad(y-input.joy.x*_sslash.consts.turn*dt))
			sslash.vect[3][3]=math.cos(math.rad(y-input.joy.x*_sslash.consts.turn*dt))
	end
	E.set_entity_position(sslash.entity, sslash.pos[1], sslash.pos[2], sslash.pos[3])
	E.turn_entity(sslash.entity, -(sslash.speed*_sslash.consts.spin*dt), 0, 0)
	E.set_entity_scale(sslash.entity, sslash.scale, sslash.scale, sslash.scale)
	if sslash.type == 4 then E.set_brush_color(sslash.brush, math.random(), math.random(), math.random(), 1.0) end
end,

calc_var = function (sslash_type, rawspeed)
   local speed, damage

   if sslash_type == 1 or sslash_type == 2 then 
      speed = rawspeed/3.75 + 0.1
      damage = (rawspeed*_sslash.consts.low_mod)+_sslash.consts.low_base
   elseif sslash_type == 3 then
      speed = rawspeed/2.6 + 0.1
	damage = (rawspeed*_sslash.consts.high_mod)+_sslash.consts.high_base
   else
      speed = rawspeed/1.62
      damage = _sslash.consts.xtreme_power
   end

   return speed*60, damage
end,

expo = function (sslash)
	if not sslash.burned then
		_sslash.make_expo_flash(sslash)
		_sslash.make_burn_mark(sslash)
	elseif sslash.expo_count < 8 then
		sslash.expo_count = sslash.expo_count + 1
	else
		E.delete_entity(sslash.expo_flash)
		_sslash.change_state(sslash, 6)
	end
end,

make_burn_mark = function (sslash)
	local burn_mark = E.create_clone(_sslash.burn_mark)
	local bms = 0.05
	if 		sslash.type == 1 then E.set_entity_rotation(burn_mark, 0, sslash.burn_rot, 40)
	elseif	sslash.type == 2 then E.set_entity_rotation(burn_mark, 0, sslash.burn_rot, -40)
	else						  E.set_entity_rotation(burn_mark, 0, sslash.burn_rot, 0)
	end
	E.set_entity_scale(burn_mark, bms, bms, bms)
	E.set_entity_position(burn_mark, sslash.hit_x, sslash.pos[2], sslash.hit_z)
	E.parent_entity(burn_mark, sslashburnmarkgroup)
	sslash.burned = true
	table.insert(_sslash.burn_marks, burn_mark)
	_sslash.burn_mark_count = _sslash.burn_mark_count + 1
	if _sslash.burn_mark_count > _sslash.burn_mark_max then
		_sslash.burn_mark_count = _sslash.burn_mark_max
		E.delete_entity(_sslash.burn_marks[1])
		table.remove(_sslash.burn_marks, 1)
	end
end,

make_expo_flash = function (sslash)
	sslash.expo_count = 0
	sslash.expo_flash = E.create_clone(_sslash.expo_flash)
	local efs = 0.06
	if 		sslash.type == 1 then E.set_entity_rotation(sslash.expo_flash, 0, sslash.burn_rot, 40)
	elseif	sslash.type == 2 then E.set_entity_rotation(sslash.expo_flash, 0, sslash.burn_rot, -40)
	else						  E.set_entity_rotation(sslash.expo_flash, 0, sslash.burn_rot, 0)
	end
	E.set_entity_scale(sslash.expo_flash, efs, efs, efs)
	E.set_entity_position(sslash.expo_flash, sslash.hit_x, sslash.pos[2], sslash.hit_z)
	E.parent_entity(sslash.expo_flash, sslashexpoflashgroup)
end,

del = function (id, sslash)
	if sslash.hit_sound then E.stop_sound(sslash.hit_sound) E.free_sound(sslash.hit_sound) end
	if sslash.slash_sound then E.stop_sound(sslash.slash_sound) E.free_sound(sslash.slash_sound) end
	E.delete_entity(sslash.entity)
	table.remove(_sslash.sslashes, id)
end
}