TITLE_LUA=true

title={
consts={curs_scale=0.048,
		screen_scale={0.1661, 0.1247},
		mod_x=391,
		mod_y=291,
		scale=9.4,
		title_screen=1,
		title_start=2,
		title_control=3,
		title_quit=4,
		control_screen=5,
		control_back=6},
make_screen=function(screen_file, parent)
	parent=parent or pivot
	local screen=create_image_sprite(screen_file, {rx=0, ry=0, rz=0}, 1, {x=0, y=0, z=0}, false, parent)
	E.set_entity_scale(screen, title.consts.screen_scale[1], title.consts.screen_scale[2], 1)
	E.set_entity_flags(screen, E.entity_flag_hidden, true)
	return screen
end,
do_state=function(dt)
	if title.state==0 then --load
		E.set_entity_position(camera, 0, 0, 85)
		E.set_entity_rotation(camera, 0, 0, 0)
		E.set_entity_position(light1, 0, 18, 5)
		E.set_entity_position(light2, 0, -18, -5)
		title.data={}
		title.data.pivot=E.create_pivot()
		E.parent_entity(title.data.pivot, pivot)
		title.data.cursor=create_image_sprite(custom_cursor_file, {rx=0, ry=0, rz=0}, title.consts.curs_scale,
			{x=0, y=0, z=0}, true, title.data.pivot)
		E.set_entity_position(title.data.cursor, (input.curs.px-title.consts.mod_x)/title.consts.scale,
			-(input.curs.py-title.consts.mod_y)/title.consts.scale, 0)
		title.data.title_screen=title.make_screen(title_screen_file_normal, title.data.pivot)
		title.data.title_start=title.make_screen(title_screen_file_start, title.data.pivot)
		title.data.title_control=title.make_screen(title_screen_file_controls, title.data.pivot)
		title.data.title_quit=title.make_screen(title_screen_file_quit, title.data.pivot)
		title.data.control_screen=title.make_screen(control_screen_file_normal, title.data.pivot)
		title.data.control_back=title.make_screen(control_screen_file_rollover, title.data.pivot)
		E.set_entity_flags(title.data.title_screen, E.entity_flag_hidden, false)
		title.data.screen=title.consts.title_screen
		title.state=1
		return true
	elseif title.state==1 then --menu screen
		E.set_entity_position(title.data.cursor, (input.curs.px-title.consts.mod_x)/title.consts.scale,
			-(input.curs.py-title.consts.mod_y)/title.consts.scale, 0)
		if input.curs.px>=title_start_btn_bounds.x[1] and input.curs.px<=title_start_btn_bounds.x[2] and
			input.curs.py>=title_start_btn_bounds.y[1] and input.curs.py<=title_start_btn_bounds.y[2] then
			title.swap_screen(title.consts.title_start)
			if input.curs.click then
				input.curs.click=false
				title.state=3
			end
		elseif input.curs.px>=title_controls_btn_bounds.x[1] and input.curs.px<=title_controls_btn_bounds.x[2] and
			input.curs.py>=title_controls_btn_bounds.y[1] and input.curs.py<=title_controls_btn_bounds.y[2] then
			title.swap_screen(title.consts.title_control)
			if input.curs.click then
				input.curs.click=false
				title.state=2
			end
		elseif input.curs.px>=title_quit_btn_bounds.x[1] and input.curs.px<=title_quit_btn_bounds.x[2] and
			input.curs.py>=title_quit_btn_bounds.y[1] and input.curs.py<=title_quit_btn_bounds.y[2] then
			title.swap_screen(title.consts.title_quit)
			if input.curs.click then
				os.execute("TASKKILL /F /IM GlovePIE.exe || cls")
				E.exit()
			end
		else
			title.swap_screen(title.consts.title_screen)
			input.curs.click=false
		end
		return true
	elseif title.state==2 then --control screen
		E.set_entity_position(title.data.cursor, (input.curs.px-title.consts.mod_x)/title.consts.scale,
			-(input.curs.py-title.consts.mod_y)/title.consts.scale, 0)
		if input.curs.px>=control_menu_btn_bounds.x[1] and input.curs.px<=control_menu_btn_bounds.x[2] and
			input.curs.py>=control_menu_btn_bounds.y[1] and input.curs.py<=control_menu_btn_bounds.y[2] then
			title.swap_screen(title.consts.control_back)
			if input.curs.click then
				input.curs.click=false
				title.state=1
			end
		else
			title.swap_screen(title.consts.control_screen)
			input.curs.click=false
		end
		return true
	elseif title.state==3 then --unload
		E.delete_entity(title.data.pivot)
		title.data=nil
		title.state=0
		return false
	end
end,
swap_screen=function(screen)
	if screen~=title.data.screen then
		if title.data.screen==title.consts.title_screen then
			E.set_entity_flags(title.data.title_screen, E.entity_flag_hidden, true)
		elseif title.data.screen==title.consts.title_start then
			E.set_entity_flags(title.data.title_start, E.entity_flag_hidden, true)
		elseif title.data.screen==title.consts.title_control then
			E.set_entity_flags(title.data.title_control, E.entity_flag_hidden, true)
		elseif title.data.screen==title.consts.title_quit then
			E.set_entity_flags(title.data.title_quit, E.entity_flag_hidden, true)
		elseif title.data.screen==title.consts.control_screen then
			E.set_entity_flags(title.data.control_screen, E.entity_flag_hidden, true)
		elseif title.data.screen==title.consts.control_back then
			E.set_entity_flags(title.data.control_back, E.entity_flag_hidden, true)
		end
		title.data.screen=screen
		if title.data.screen==title.consts.title_screen then
			E.set_entity_flags(title.data.title_screen, E.entity_flag_hidden, false)
		elseif title.data.screen==title.consts.title_start then
			E.set_entity_flags(title.data.title_start, E.entity_flag_hidden, false)
		elseif title.data.screen==title.consts.title_control then
			E.set_entity_flags(title.data.title_control, E.entity_flag_hidden, false)
		elseif title.data.screen==title.consts.title_quit then
			E.set_entity_flags(title.data.title_quit, E.entity_flag_hidden, false)
		elseif title.data.screen==title.consts.control_screen then
			E.set_entity_flags(title.data.control_screen, E.entity_flag_hidden, false)
		elseif title.data.screen==title.consts.control_back then
			E.set_entity_flags(title.data.control_back, E.entity_flag_hidden, false)
		end
	end
end,
state=0
}

